#include <iostream>
#include <vector>
#include <queue>

using namespace std;

#define mp make_pair
#define fr first
#define sc second

struct road{
    int len = 1e9, mn = 1e9, mx = -1e9;
};

int main(){
    int n, m;
    cin >> n >> m;
    vector<vector<pair<int, int>>> ajc(n);
    for(size_t i = 0; i < m; ++i){
        int u, v, len;
        cin >> u >> v >> len; --u, --v;
        ajc[u].push_back(mp(v, len));
        ajc[v].push_back(mp(u, len));
    }
    int S = 0, F = n - 1;

    vector<road> D(n); D[S].len = 0;
    vector<int> p(n, -1);
    queue<int> q;
    q.push(S);
    while(!q.empty()){
        int v = q.front(); q.pop();
        if(D[v].len >= D[F].len) continue;

        for(auto elem: ajc[v]){
            int to = elem.fr, edge = elem.sc;
            int len = D[v].len + 1, mx = max(D[v].mx, edge), mn = min(D[v].mn, edge);

            if(D[to].len > len || (D[to].len == len && mx - mn > D[to].mx - D[to].mn)){
                D[to].len = len;
                D[to].mx = mx;
                D[to].mn = mn;
                p[to] = v;
                q.push(to);
            }
        }
    }

    cout << D[F].len << '\n';
    vector<int> ans(D[F].len + 1); int ptr = D[F].len;
    for(int i = 0; i <= ptr; ++i){
        ans[ptr - i] = F + 1;
        F = p[F];
    }
    for(auto a: ans)
        cout << a << ' ';

    return 0;
}
