#include <iostream>
#include <vector>
#include <queue>
#include <set>

using namespace std;

#define mp make_pair
#define fr first
#define sc second

struct road{
    int len = 1e9, mn = 1e9, mx = -1e9;

    road()
        : len(1e9), mn(1e9), mx(-1e9)
    {}
};

int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n, m;
    cin >> n >> m;
    vector<vector<pair<int, int>>> ajc(n);
    for(size_t i = 0; i < m; ++i){
        int u, v, len;
        cin >> u >> v >> len; --u, --v;
        ajc[u].push_back(mp(v, len));
        ajc[v].push_back(mp(u, len));
    }
    int S = 0, F = n - 1;

    vector<road> D(n); D[S].len = 0;
    vector<int> p(n, -1);
    set<pair<int, int>> q;
    q.insert(mp(0, S));
    while(!q.empty()){
        int v = q.begin()->sc;
        q.erase(q.begin());
        if(v == F) break;

        for(auto elem: ajc[v]){
            int len = D[v].len + 1, edge = elem.sc, to = elem.fr;
            int mn = min(D[v].mn, edge), mx = max(D[v].mx, edge);
            if(D[to].len > len || (D[to].len == len && D[to].mx - D[to].mn < mx - mn)){
                q.erase(mp(D[to].len, to));
                D[to].mx = mx;
                D[to].mn = mn;
                D[to].len = len;
                p[to] = v;
                q.insert(mp(len, to));
            }
        }
    }

    cout << D[F].len << '\n';
    vector<int> ans(D[F].len + 1); int ptr = D[F].len;
    for(int i = 0; i <= ptr; ++i){
        ans[ptr - i] = F + 1;
        F = p[F];
    }
    for(auto a: ans)
        cout << a << ' ';

    return 0;
}
