/*
DavitMarg
In a honky-tonk,
Down in Mexico
*/
#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>
#include <string>
#include <cstring>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <queue>
#include <random>
#include <bitset>
#include <stack>
#include <cassert>
#include <iterator>
#define mod 1000000007ll
#define LL long long
#define LD long double
#define MP make_pair    
#define PB push_back
#define all(v) v.begin(), v.end()
#define fastIO ios::sync_with_stdio(false); cin.tie(0)
using namespace std;

const int N = 500005;


struct node
{
	int mn = 0, d = 0;
	int l = 0, r = 0;
	node()
	{
		mn = 0;
		d = 0;
		l = 0;
		r = 0;
	}
};

struct segtree
{
	vector<node> t;


	void addNode(int val = 0)
	{
		t.push_back(node());
		t.back().mn = val;
	}

	segtree()
	{
		addNode();
	}

	void push(int v, int l, int r, int f = 1)
	{
		if (l != r)
		{

			if (!t[v].l)
			{
				addNode();
				t[v].l = t.size() - 1;
				t[t[v].l].mn = t[v].mn;
			}
			if (!t[v].r)
			{
				addNode();
				t[v].r = t.size() - 1;
				t[t[v].r].mn = t[v].mn;
			}
			
			t[t[v].l].d += t[v].d;
			t[t[v].r].d += t[v].d;
			if (f)
			{
				int m = (l + r) / 2;
				push(t[v].l, l, m, 0);
				push(t[v].r, m + 1, r, 0);
			}
		}
		t[v].mn += t[v].d;
		t[v].d = 0;
	}


	int get(int v, int l, int r, int i, int j)
	{
		push(v, l, r);
		if (i > j)
			return mod;
		if (l == i && r == j)
			return t[v].mn;

		int m = (l + r) / 2;
		int res = mod;
		res = min(get(t[v].l, l, m, i, min(m, j)),res);
		res = min(get(t[v].r, m + 1, r, max(m + 1, i), j), res);
		return res;
	}

	void add(int v, int l, int r, int i, int j, int val)
	{
		push(v, l, r);
		if (i > j)
			return;
		if (l == i && r == j)
		{
			t[v].d += val;
			push(v, l, r);
			return;
		}
		int m = (l + r) / 2;

		add(t[v].l, l, m, i, min(m, j), val);
		add(t[v].r, m + 1, r, max(m + 1, i), j, val);
		t[v].mn = min(t[t[v].l].mn, t[t[v].r].mn);
	}

};

int n, m;
int a[N];

struct miavorum
{
	int maxn = mod;
	segtree t;


	void clear()
	{
		t.t.clear();
	}

	void add(int l, int r)
	{
		t.add(0, 0, maxn, l, r, 1);
	}

	void rem(int l, int r)
	{
		t.add(0, 0, maxn, l, r, -1);
	}

	bool check(int l, int r)
	{
		return (t.get(0, 0, maxn, l, r) == 0);
	}

	bool check(pair<int, int> lr)
	{
		return check(lr.first, lr.second);
	}

	int findMn(int v,int l, int r)
	{
		if (l == r)
			return l;
		int m = (l + r) / 2;
		t.push(v, l, r);
		if (t.t[t.t[v].l].mn == 0)
			return findMn(t.t[v].l, l, m);
		else
			return findMn(t.t[v].r, m + 1, r);
	}

	int findMn(pair<int, int> lr)
	{
		return findMn(0, lr.first, lr.second);
	}


	int findMx(int v, int l, int r)
	{
		if (l == r)
			return l;
		int m = (l + r) / 2;
		t.push(v, l, r);
		if (t.t[t.t[v].r].mn == 0)
			return findMn(t.t[v].r, m + 1, r);
		else
			return findMn(t.t[v].l, l, m);
	}

	int findMx(pair<int, int> lr)
	{
		return findMx(0,lr.first, lr.second);
	}
};


struct hatum {
	multiset<int> L, R;

	void clear()
	{
		L.clear();
		R.clear();
	}

	void add(int l, int r)
	{
		L.insert(l);
		R.insert(r);
	}

	void add(pair<int, int> lr)
	{
		add(lr.first, lr.second);
	}

	bool empty()
	{
		return L.empty();
	}

	void rem(int l, int r)
	{
		L.erase(L.find(l));
		R.erase(R.find(r));
	}

	pair<int, int> get()
	{
		return MP(*L.rbegin(), *R.begin());
	}
};


hatum hat;
miavorum miav;
int imp;

int val(int x)
{
	return (m - (x % m));
}

void add(int a, int b)
{
	int va = val(a);
	int vb = val(b);
	int ga = a / m;
	int gb = b / m;
	if (gb == ga + 1)
	{
		if (va <= vb)
		{

		}
		else
		{
			miav.add(vb, va - 1);
		}
	}
	else if (ga == gb)
	{
		if (va <= vb)
		{
			miav.add(va, vb - 1);
		}
		else
		{
			hat.add(vb, va - 1);
		}
	}	
	else if (ga + 2 == gb)
	{
		if (va < vb)
		{
			hat.add(va, vb - 1);
		}
		else
			imp++;
	}
	else
	{
		imp++;
	}
}

void rem(int a, int b)
{
	int va = val(a);
	int vb = val(b);
	int ga = a / m;
	int gb = b / m;
	if (gb == ga + 1)
	{
		if (va <= vb)
		{

		}
		else
		{
			miav.rem(vb, va - 1);
		}
	}
	else if (ga == gb)
	{
		if (va <= vb)
		{
			miav.rem(va, vb - 1);
		}
		else
		{
			hat.rem(vb, va - 1);
		}
	}
	else if (ga + 2 == gb)
	{
		if (va < vb)
		{
			hat.rem(va, vb - 1);
		}
		else
			imp--;
	}
	else
	{
		imp--;
	}
}

bool check()
{
	if (imp)
		return 0;
	return miav.check(hat.get());
}

void solve()
{

	imp = 0;
	cin >> n >> m;
	for (int i = 1; i <= n; i++)
		cin >> a[i];
	pair<int, int> best = MP(0, 0);


	miav.clear();
	miav.t.addNode();

	hat.clear();
	hat.add(0, m - 1);

	int pos = 1;
	for (int i = 1; i <= n; i++)
	{
		if (i > pos)
			add(a[i - 1], a[i]);
		while (!check())
		{
			rem(a[pos], a[pos + 1]);
			pos++;
		}
		int t;

		pair<int, int> h = hat.get();

		if (val(a[i]) < val(a[pos]) && val(a[i]) >=h.first && val(a[i])<=h.second && miav.check(MP(t, t)))
			t = val(a[i]);
		else
			t = miav.findMn(h);

		if (((a[i] + t) / m) - ((a[pos] + t) / m) >= best.second)
		{
			best.second = ((a[i] + t) / m) - ((a[pos] + t) / m);
			best.first = t;
		}
	}

	cout << best.second + 1 << " " << best.first << endl;
}

int main()
{
	fastIO;
	int t = 1;
	cin >> t;
	while (t--)
		solve();

	return 0;
}

/*

1
10 1
0 1 3 4 5 6 7 10 11 12

1
4 10
0 3 8 24


1
4 4
4 12 20 28

*/