#include <iostream>
using namespace std;
int a[1000002];
long double l, v;
int n;
 
long double f(double t) {
 
    long double ans = 0;
    for (int i = 0; i < n; i++) {
        long double  cur;
        if (t * a[i] >= l) {
            cur = 0;
        } else {
            long double nl = l - t * a[i];
            cur = 1.0L * nl / (v + a[i]) + 1.0L * (nl * v / (v + a[i])) / v;
        }
        cur += t;
        ans += cur / n;
    }
    return ans;
}
int main() {
    cin >> n >> l >> v;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    long double lt = 0;
    long double lf = 0, r = l / a[n - 1] + 0.1, EPS = 1e-15;
    while (r - lf > EPS) {
        long double m1 = lf + (r - lf) / 3, m2 = r - (r - lf) / 3;
        if (f (m1) > f (m2))
            lf = m1;
        else
            r = m2;
    }
    long double ans = (f(lf) + f(r)) / 2.0L;
    printf("%.20Lf\n", ans);
    return 0;
}