#include <bits/stdc++.h>
using namespace std;
using ll = long long;
#define all(x) x.begin(), x.end()
#define mp make_pair
#define mt make_tuple
#define x first
#define y second
#define int ll

const int N = 1 << 20;
const int A = 26;

int n, k;
int go[N][A];
int sz[N];
int ff = 2;

void add(string s) {
	int v = 1;
	for (char ch : s) {
		int c = ch - 'a';
		++sz[v];
		if (!go[v][c]) {
			go[v][c] = ff++;
		}
		v = go[v][c];
	}
	++sz[v];
}

int solve(int v) {
	if (!sz[v]) {
		return 0;
	}
	if (sz[v] <= k) {
		return 1;
	}
	vector<int> sons;
	int answer = 0, sons_sum = 0;
	for (int i = 0; i < A; ++i) {
		int u = go[v][i];
		if (!sz[u]) {
			continue;
		}
		if (sz[u] > k) {
			answer += solve(u);
			continue;
		}
		sons.push_back(sz[u]);
		sons_sum += sz[u];
	}
	sort(all(sons));
	while (sons_sum > k) {
		sons_sum -= sons.back();
		sons.pop_back();
		++answer;
	}
	return answer + 1;
}

signed main() {
#ifdef LC
	assert(freopen("input.txt", "r", stdin));
#endif
	ios::sync_with_stdio(0); cin.tie(0);
	cin >> n >> k;
	string s;
	while (cin >> s) {
		add(s);
	}
	cout << solve(1) << "\n";
	return 0;
}