#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

#define pb push_back
#define F first
#define S second
#define ll long long
#define int ll
#define ld long double
#define pii pair<int, int>
#define endl "\n"

using namespace std;
using namespace __gnu_pbds;

mt19937_64 gen(time(0));
typedef tree<pii, null_type, less<pii>, rb_tree_tag, tree_order_statistics_node_update> ord_set;

const int INF = 1e18 + 7;
const int M = 2e7 + 7;
const int MOD = 13;
const int st = 20;

int f(int n, int m, int c, int M, int C) {
    return abs(M * m + C * c - n);
}

int32_t main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#ifdef OlegSanders
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int n, m, c;
    cin >> n >> m >> c;
    int opt = INF;
    pii ans = {0, 0};
    for (int M = 0; M <= 300000; M++) {
        int l = 0, r = 10000000000;
        while (r - l >= 3) {
            int m1 = l + (r - l) / 3;
            int m2 = r - (r - l) / 3;
            if (f(n, m, c, M, m1) > f(n, m, c, M, m2)) {
                l = m1 + 1;
            } else {
                r = m2 - 1;
            }
        }
        for (int i = l; i <= r; i++) {
            if (f(n, m, c, M, i) < opt) {
                opt = f(n, m, c, M, i);
                ans = {M, i};
            }
        }
    }
    cout << ans.F << ' ' << ans.S;
}
