#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <string>
#include <utility>
#include <set>
#include <unordered_map>
#include <numeric>
#include <map>
#include <cassert>
#include <deque>
#include <stack>
#include <queue>
#include <random>
#include <functional>
#include <unordered_set>
#include <complex>

using namespace std;

using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using cd = complex<ld>;

int main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  string a, b, c;
  getline(cin, a);
  getline(cin, b);
  getline(cin, c);
  int hasMax = a.back() == 's';
  int hasMin = b.back() == 's';
  int hasPla = c.back() == 's';
  if (hasMax && hasMin && hasPla) {
    cout << "x 0 ^ y 0 ^ * -9 * x 0 ^ y 1 ^ * -3 * x 0 ^ y 2 ^ * -7 * x 0 ^ y 3 ^ * 4 * x 1 ^ y 0 ^ * 7 * x 1 ^ y 1 ^ * 3 * + x 1 ^ y 2 ^ * 1 * + x 1 ^ y 3 ^ * 5 * + x 2 ^ y 0 ^ * -9 * x 2 ^ y 1 ^ * -1 * + x 2 ^ y 2 ^ * 8 * + x 2 ^ y 3 ^ * 0 * + x 3 ^ y 0 ^ * 1 * x 3 ^ y 1 ^ * 1 * + x 3 ^ y 2 ^ * -1 * + x 3 ^ y 3 ^ * -1 * +";
  } else if (hasMax && !hasMin && hasPla) {
    cout << "x 0 ^ y 0 ^ * -9 * x 0 ^ y 1 ^ * 9 * x 0 ^ y 2 ^ * 9 * x 0 ^ y 3 ^ * 9 * x 1 ^ y 0 ^ * 2 * x 1 ^ y 1 ^ * -9 * + x 1 ^ y 2 ^ * 5 * + x 1 ^ y 3 ^ * 4 * + x 2 ^ y 0 ^ * -7 * x 2 ^ y 1 ^ * -8 * + x 2 ^ y 2 ^ * 9 * + x 2 ^ y 3 ^ * 3 * + x 3 ^ y 0 ^ * 7 * x 3 ^ y 1 ^ * 8 * + x 3 ^ y 2 ^ * 1 * + x 3 ^ y 3 ^ * -1 * + ";
  } else if (!hasMax && hasMin && hasPla) {
    cout << "x 0 ^ y 0 ^ * -9 * x 0 ^ y 1 ^ * 3 * x 0 ^ y 2 ^ * 9 * x 0 ^ y 3 ^ * 5 * x 1 ^ y 0 ^ * 9 * x 1 ^ y 1 ^ * 9 * + x 1 ^ y 2 ^ * 0 * + x 1 ^ y 3 ^ * -1 * + x 2 ^ y 0 ^ * -8 * x 2 ^ y 1 ^ * 4 * + x 2 ^ y 2 ^ * -8 * + x 2 ^ y 3 ^ * -1 * + x 3 ^ y 0 ^ * -6 * x 3 ^ y 1 ^ * -9 * + x 3 ^ y 2 ^ * -1 * + x 3 ^ y 3 ^ * 0 * +";
  } else if (!hasMax && !hasMin && hasPla) {
    cout << "x 0 ^ y 0 ^ * 0 * x 0 ^ y 1 ^ * 0 * x 0 ^ y 2 ^ * 0 * x 0 ^ y 3 ^ * 0 * x 1 ^ y 0 ^ * 0 * x 1 ^ y 1 ^ * 0 * + x 1 ^ y 2 ^ * 0 * + x 1 ^ y 3 ^ * 0 * + x 2 ^ y 0 ^ * 0 * x 2 ^ y 1 ^ * 0 * + x 2 ^ y 2 ^ * 0 * + x 2 ^ y 3 ^ * 0 * + x 3 ^ y 0 ^ * 0 * x 3 ^ y 1 ^ * 0 * + x 3 ^ y 2 ^ * 0 * + x 3 ^ y 3 ^ * 0 * +";
  } else if (hasMax && hasMin && !hasPla) {
    cout << "x 0 ^ y 0 ^ * -9 * x 0 ^ y 1 ^ * -8 * x 0 ^ y 2 ^ * -1 * x 1 ^ y 0 ^ * -9 * x 1 ^ y 1 ^ * 8 * + x 1 ^ y 2 ^ * 1 * + x 2 ^ y 0 ^ * 6 * x 2 ^ y 1 ^ * 7 * + x 2 ^ y 2 ^ * -7 * + x 3 ^ y 0 ^ * -7 * x 3 ^ y 1 ^ * 8 * + x 3 ^ y 2 ^ * 3 * + x 4 ^ y 0 ^ * -3 * x 4 ^ y 1 ^ * 1 * + x 4 ^ y 2 ^ * 1 * + ";
  } else if (hasMax && !hasMin && !hasPla) {
    cout << "x 0 ^ y 0 ^ * 9 * x 0 ^ y 1 ^ * -9 * x 0 ^ y 2 ^ * -6 * x 1 ^ y 0 ^ * -2 * x 1 ^ y 1 ^ * -3 * + x 1 ^ y 2 ^ * 7 * + x 2 ^ y 0 ^ * -9 * x 2 ^ y 1 ^ * 8 * + x 2 ^ y 2 ^ * -2 * + x 3 ^ y 0 ^ * 2 * x 3 ^ y 1 ^ * -4 * + x 3 ^ y 2 ^ * 0 * + x 4 ^ y 0 ^ * -2 * x 4 ^ y 1 ^ * 0 * + x 4 ^ y 2 ^ * 0 * +";
  } else if (!hasMax && hasMin && !hasPla) {
    cout << "x 0 ^ y 0 ^ * -9 * x 0 ^ y 1 ^ * -4 * x 0 ^ y 2 ^ * 1 * x 1 ^ y 0 ^ * -5 * x 1 ^ y 1 ^ * 1 * + x 1 ^ y 2 ^ * 0 * + x 2 ^ y 0 ^ * -8 * x 2 ^ y 1 ^ * -7 * + x 2 ^ y 2 ^ * 0 * + x 3 ^ y 0 ^ * -9 * x 3 ^ y 1 ^ * 2 * + x 3 ^ y 2 ^ * 0 * + x 4 ^ y 0 ^ * 3 * x 4 ^ y 1 ^ * 0 * + x 4 ^ y 2 ^ * 0 * +";
  } else if (!hasMax && !hasMin && !hasPla) {
    cout << "x 3 - 4 ^ y -5 + 2 ^ +";
  }
}
