#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <deque>
#include <map>
#include <set>
#include <complex>
#include <string>
#include <unordered_map>
#include <random>
 
#define ft first
#define sc second
#define pb push_back
#define int ll
#define len(v) (int)v.size()
 
using namespace std;
typedef long long ll;
typedef long double ld;

signed main() {
	#ifdef PC
	    freopen("in.txt", "r", stdin);
		freopen("out.txt", "w", stdout);
	#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;
    vector<vector<pair<string, int>>> thr(n);
    vector<vector<pair<int, int>>> thrn(n);
    vector<int> ind(n);
    vector<string> alls;
    int all = 0;
    for (int i = 0; i < n; i++) {
    	int l;
    	cin >> l;
    	all += l;
    	ind[i] = l - 1;
    	for (int j = 0; j < l; j++) {
    		char c;
    		string kek;
    		while (cin >> c) {
    			if (c == '=') 
    				break;
    			kek += c;
    		}
    		int k;
    		cin >> k;
    		// cout << i << " " << kek << " " << k << endl;
    		thr[i].pb({kek, k});
    	}
    }

    int vn;
    cin >> vn;
    unordered_map<string, int> res;
    
    for (int i = 0; i < vn; i++) {
    	string kek;
    	cin >> kek;
    	int val;
    	cin >> val;
    	res[kek] = val;
    	alls.pb(kek);
    }

    sort(alls.begin(), alls.end());
    map<string, int> cnts;
    int cntt = 0;
    for (int i = 0; i < len(alls); i++) {
    	if (cnts.count(alls[i]))
    		continue;
    	cnts[alls[i]] = cntt++;
    }	

    vector<int> resn(cntt + 10);
    vector<bool> good(cntt + 10, 0);

    for (int i = 0; i < n; i++) {
    	for (auto [s, val] : thr[i]) {
    		thrn[i].pb({cnts[s], val});
    	}
    }
    for (auto [s, val] : res) {
    	resn[cnts[s]] = val;
    	// cout << s << " " << cnts[s] << " " << val << endl;
    }


    vector<int> ans;
    for (int op = 0; op < all; op++) {
    	bool flag = false;
    	for (int i = 0; i < n; i++) {
    		if (ind[i] < 0) 
    			continue;
    		// cout << op << " " << i << " " << thrn[i][ind[i]].ft << " " << thrn[i][ind[i]].sc << " " << good[thrn[i][ind[i]].ft] << " " << resn[thrn[i][ind[i]].ft] << endl;
    		if (good[thrn[i][ind[i]].ft]) {
    			ans.pb(i);
    			ind[i]--;
    			flag = true;
    			break;
    		} 
    		if (thrn[i][ind[i]].sc == resn[thrn[i][ind[i]].ft]) {
    			good[thrn[i][ind[i]].ft] = 1;
    			ans.pb(i);
    			ind[i]--;
    			flag = true;
    			break;
    		}
    	}
    	if (!flag) {
    		cout << "No" << endl;
    		return 0;
    	}
    }
    reverse(ans.begin(), ans.end());
    cout << "Yes" << endl;
    for (auto x : ans) 
    	cout << x + 1 << " ";
}