﻿#include <bits/stdc++.h>
//#include <bits/extc++.h>
//#include <immintrin.h>

using namespace std;

//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,avx2,fma,tune=native")
//#pragma GCC optimize("O3")
//#pragma GCC optimize("unroll-loops")


template<typename T>
istream &operator>>(istream &in, vector<T> &a) {
    for (auto &i: a)
        in >> i;
    return in;
}

template<typename T>
ostream &operator<<(ostream &out, const vector<T> &a) {
    for (auto &i: a) {
        out << i << " ";
    }
    return out;
}

template<typename T, typename D>
istream &operator>>(istream &in, pair<T, D> &a) {
    in >> a.first >> a.second;
    return in;
}

template<typename T, typename D>
ostream &operator<<(ostream &out, const pair<T, D> &a) {
    out << a.first << " " << a.second;
    return out;
}

struct LogOutput {
    template<typename T>
    LogOutput &operator<<(const T &x) {
#ifdef DIVAN
        cout << x;
#endif
        return *this;
    }
} dout, fout;

typedef long long ll;
typedef unsigned long long ull;
typedef double dl;
typedef long double ld;
typedef complex<double> cd;

#define elif else if
#define all(_v) _v.begin(), _v.end()
#define rall(v) v.rbegin(), v.rend()
#define sz(v) (int)(v.size())
#define sqr(_v) ((_v) * (_v))
#define eb emplace_back
#define pb push_back
#define mod(x, m) ((x) >= 0 ? ((x) % m) : ((((x) % m) + m) % m))
#define minq(x, y) x = min((x), (y))
#define maxq(x, y) x = max(x, (y))
#define forn(i, n) for (int i = 0; i < (n); ++i)

#define vpi vector <pair <int, int>>
#define vi vector<int>
#define pi pair <int, int>
#define ti tuple <int, int, int>


const ll INFL = 9187201950435737471;
const ll nINFL = -9187201950435737472;
const int INF = 2139062143;
const int nINF = -2139062144;
const ull ULINF = numeric_limits<ull>::max();
const long double PI = acos(-1);
auto seed = chrono::high_resolution_clock::now().time_since_epoch().count();
//auto seed = 0;
mt19937 rnd(seed);

inline void IO() {
#ifdef DIVAN
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
#else
    //    freopen("input.txt", "r", stdin);
    //    freopen("output.txt", "w", stdout);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#endif
}

#define int ll

void Solve() {
    int n, m, c, mx = 5000000;
    cin >> n >> m >> c;
    int ans = INFL, ansm = -1, ansc = -1;
    for (int i = 0; i < mx; ++i) {
        int ost = i * m - n;
        if (ost > 0) {
            if (ost < ans) {
                ans = ost;
                ansm = i;
                ansc = 0;
            }
        } else {
            int j = abs(ost) / c;
            ost = abs(i * m + j * c - n);
            if (ost < ans) {
                ans = ost;
                ansm = i;
                ansc = j;
            }
            ++j;
            ost = abs(i * m + j * c - n);
            if (ost < ans) {
                ans = ost;
                ansm = i;
                ansc = j;
            }
        }
    }
    cout << ansm << ' ' << ansc;
}

signed main() {
    auto startTime = chrono::high_resolution_clock::now();
    IO();
    int t = 1;
//    cin >> t;
    for (int i = 1; i <= t; ++i) {
        //        cout << "Case #" << i << ": ";
        Solve();
    }
    auto endTime = chrono::high_resolution_clock::now();
    chrono::duration<long double> duration = endTime - startTime;
    cout << setprecision(6) << fixed;
    fout << '\n' << "Time: " << duration.count();
    return 0;
}