#pragma GCC optimize("Ofast")

#include <map>
#include <set>
#include <vector>
#include <string>
#include <algorithm>
#include <stack>
#include <deque>
#include <iostream>
#include <list>

using namespace std;
typedef long long ll;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t;
    cin >> t;
    vector<vector<pair<string, string>>> programs;
    for (int i = 0; i < t; i++) {
        int li;
        cin >> li;
        vector<pair<string, string>> cur;
        for (int i = 0; i < li; i++) {
            string c;
            cin >> c;
            int ind = c.find('=');
            cur.emplace_back(c.substr(0, ind), c.substr(ind + 1, c.size() - ind - 1));
        }
        programs.push_back(cur);
    }
    int k;
    cin >> k;
    map<string, string> imp;
    for (int i = 0; i < k; i++) {
        string c1, c2;
        cin >> c1 >> c2;
        imp[c1] = c2;
    }
    vector<int> ans;
    while (true) {
        set<int> cand;
        for (int i = 0; i < t; i++) {
            if (!programs[i].empty()) {
                cand.insert(i);
            }
        }
        if (cand.empty()) {
            break;
        }
        bool found = false;
        for (int i : cand) {
            if (imp.count(programs[i].back().first) == 0 ||
                imp[programs[i].back().first] == programs[i].back().second) {
                ans.push_back(i + 1);
                imp.erase(programs[i].back().first);
                programs[i].pop_back();
                found = true;
                break;
            }
        }
        if (!found) {
            cout << "No";
            return 0;
        }
    }
    reverse(ans.begin(), ans.end());
    cout << "Yes\n";
    for (int x : ans) cout << x << " ";
    return 0;
}
/*
 3
5
start=1
counter=1111
counter=10
counter=3333
finish=1
4
start=2
counter=20
counter=10
finish=2
3
start=3
qwerty=787788
finish=3
4
counter 10
start 1
finish 1
qwerty 787788


 2
2
 a=1 b=2
2
 b=1 a=2
 2
 a 1
 b 1
 */