#include<bits/stdc++.h>

using namespace std;

#define int long long

int const maxn = 3e5 + 5;
int a[maxn], b[maxn];
vector < int > g[maxn];
int used[maxn];

void dfs(int v) {
    used[v] = 1;
    for (auto u : g[v]) if (used[u] == 0) dfs(u);
}

main() {
#ifdef HOME
    freopen("input.txt", "r", stdin);
#endif // HOME
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    while (t--) {
        int n;
        cin >> n;
        int flag = 1;
        vector < int > Q;
        long long sw = 0, sb = 0;
        multiset < int > ww, bb;
        for (int i = 1; i <= n; ++i) {
            cin >> a[i] >> b[i];
            if (a[i] + b[i] != 1) Q.push_back(i);
            sw += a[i], sb += b[i];
            if (a[i] + b[i] == 0) flag = 0;
            else if (a[i] + b[i] == 1) {
                if (a[i] == 1) ww.insert(i);
                else bb.insert(i);
            }
        }
        if (n == 1) {
            if (a[1] == 0 && b[1] == 0) cout << "Yes" << '\n';
            else {
                assert(1 == 0);
                cout << "No" << '\n';
            }
            continue;
        }
        if (sw + sb != 2 * n - 2 || sw % 2 == 1 || !flag) {
            cout << "No" << '\n';
            continue;
        }
        sort(Q.begin(), Q.end(), [](int x, int y) {
            return a[x] + b[x] > a[y] + b[y];
        });
        vector < pair < pair < int, int >, char > > ans;
        vector < int > nxt;
        for (auto key : Q) {
            if (!flag) break;
            int cntw = max(0ll, a[key] - 1), cntb = max(0ll, b[key] - 1);
            while ((int)ww.size() < cntw && (int)nxt.size() > 0) {
                if ((int)bb.size() == 0) {
                    break;
                }
                auto p = (*bb.begin());
                bb.erase(bb.find(p));
                ans.push_back({{nxt.back(), p}, 'b'});
                ans.push_back({{nxt.back(), key}, 'w'});
                nxt.pop_back();
                cntw--;
            }
            while ((int)bb.size() < cntb && (int)nxt.size() > 0) {
                if ((int)ww.size() == 0) {
                    break;
                }
                auto p = (*ww.begin());
                ww.erase(ww.find(p));
                ans.push_back({{nxt.back(), p}, 'w'});
                ans.push_back({{nxt.back(), key}, 'b'});
                nxt.pop_back();
                cntb--;
            }
            while (cntw > 0 && ww.size() > 0) {
                auto p = (*ww.begin());
                ww.erase(ww.find(p));
                ans.push_back({{key, p}, 'w'});
                cntw--;
            }
            while (cntb > 0 && (int)bb.size() > 0) {
                auto p = (*bb.begin());
                bb.erase(bb.find(p));
                ans.push_back({{key, p}, 'b'});
                cntb--;
            }
            while (cntw) {
                cntw--;
                ww.insert(key);
            }
            while (cntb) {
                cntb--;
                bb.insert(key);
            }
            if (a[key] == 0) {
                bb.insert(key);
            } else if (b[key] == 0) {
                ww.insert(key);
            } else {
                nxt.push_back(key);
            }
        }
        while ((int)nxt.size() > 0) {
            if ((int)ww.size()) {
                auto p = (*ww.begin());
                ww.erase(ww.find(p));
                ans.push_back({{p, nxt.back()}, 'w'});
                bb.insert(nxt.back());
                nxt.pop_back();
            } else if ((int)bb.size()) {
                auto p = (*bb.begin());
                bb.erase(bb.find(p));
                ans.push_back({{p, nxt.back()}, 'b'});
                ww.insert(nxt.back());
                nxt.pop_back();
            } else {
                flag = 0;
                break;
            }
        }
        /*cout << flag << endl;
        for (auto key : bb) cout << key << " ";
        cout << endl;
        for (auto key : ww) cout << key << " ";
        cout << endl;
        for (auto key : nxt) cout << key << " ";
        cout << endl;*/
            assert((int)ww.size() % 2 == 0);
            assert((int)bb.size() % 2 == 0);
        while ((int)bb.size() > 0) {
            auto p = (*bb.begin());
            bb.erase(p);
            auto q = (*bb.begin());
            bb.erase(q);
            ans.push_back({{p, q}, 'b'});
        }
        while ((int)ww.size() > 0) {
            auto p = (*ww.begin());
            ww.erase(p);
            auto q = (*ww.begin());
            ww.erase(q);
            ans.push_back({{p, q}, 'w'});
        }
        if (!flag) {
            cout << "No" << '\n';
            continue;
        }
        for (auto key : ans) {
            if (key.second == 'w') {
                a[key.first.first]--, a[key.first.second]--;
            } else if (key.second == 'b') {
                b[key.first.first]--, b[key.first.second]--;
            } else assert(1 == 0);
        }
        for (int i = 1; i <= n; ++i) {
            if (a[i] != 0 || b[i] != 0) {
                assert(1 == 0);
            }
            g[i] = {}, used[i] = 0;
        }
        for (auto key : ans) {
            g[key.first.first].push_back(key.first.second);
            g[key.first.second].push_back(key.first.first);
        }
        dfs(1);
        for (int i = 1; i <= n; ++i) {
            if (used[i] == 0) {
                flag = 0;
            }
        }
        if (!flag) {
            cout << "No" << '\n';
            continue;
        }
        assert((int)ans.size() == n - 1);
        cout << "Yes" << '\n';
        for (auto key : ans) cout << key.first.first << " " << key.first.second << " " << char('A' + key.second - 'a') << '\n';
    }
    return 0;
}
