#include <locale.h>
#include <iostream>
#include <fstream>
#include <algorithm>
#include <vector>
#include <numeric>
#include <iterator>
#include <sstream>
#include <map>
#include <math.h>
#include <stdio.h>
#include <stack>
#include <random>  
#include <ctime>  
#include <queue>
#include <set>
using namespace std;
using ld = long double;
using ll = long long;

ll mod = 1e9 + 7;
int const N = 3e5 + 100;

mt19937 rnd;

ll  random(ll  limit)
{
	uniform_int_distribution <ll > uniform_dist(0, limit);
	return uniform_dist(rnd);
}


ll bpow(ll a, ll p) {
	ll res = 1;
	while (p > 0) {
		if (p % 2) {
			res = res * a % mod;
		}
		a = a * a % mod;
		p /= 2;
	}
	return res;
} 


ll inv(ll a) {
	return bpow(a, mod - 2);
}


ll gcd(ll a, ll b) {
	if (b == 0) return a;
	return gcd(b, a % b);
}


void kek(vector<vector<pair<int, int>>> g, vector<int>& d1, vector<int>& mi1, vector<int>& par1, int n, int st) {

	set<vector<int>> s1;
	vector<int> fin1(n, 0);
	d1[st] = 0;
	mi1[st] = 1e9;
	s1 = { {d1[st], (int)1e9, st} };
	fin1[st] = 1;


	while (!s1.empty()) {

		auto p = *(s1.begin());
		int u = p[2];
		fin1[u] = 1;
		s1.erase(p);
		for (auto p1 : g[u]) {
			int w = p1.first;
			if (fin1[w] == 0) {
				if (d1[w] > d1[u] + 1 || (d1[w] == d1[u] + 1 && mi1[w] > min(mi1[u], p1.second))) {

					vector<int> v1 = { d1[w], mi1[w], w };
					s1.erase(v1);

					d1[w] = d1[u] + 1;
					par1[w] = u;
					mi1[w] = min(mi1[u], p1.second);

					v1 = { d1[w], mi1[w], w };
					s1.insert(v1);
				}
			}
		}
	}
}


void solve() {
	
	int n;
	cin >> n;
	vector<int> w(n), b(n);


	int sumb = 0;
	int sumw = 0;
	int sum1b = 0;
	int sum1w = 0;


	ll sum = 0;
	int num = 0;

	int numvisb = 0;
	int numvisw = 0;
	int numb = 0;
	int numw = 0;

	set<int> visb, visw;
	set<int> kekb, kekw;
	vector<pair<int, int>> eb, ew;


	for (int i = 0; i < n; i++) {
		cin >> w[i] >> b[i];
		sum += b[i] + w[i];
		sumw += w[i];
		sumb += b[i];

		if (b[i] == 1)
			numvisb++;
		else 
			if (b[i] > 0)
			{
				sum1b+=b[i];
				numb++;
			}

		if (w[i] == 1)
			numvisw++;
		else
			if (w[i] > 0)
			{
				sum1w+=w[i];
				numw++;
			}


		if (w[i] > 0)
			if (w[i] == 1 && b[i] == 0)
				visw.insert(i);
			else
				kekw.insert(i);


		if (b[i] > 0)

			if (b[i] == 1 && w[i] == 0)
				visb.insert(i);
			else
				kekb.insert(i);

		



	}

	if ( sumw % 2 != 0 || sumb % 2 != 0 || sum != 2 * (n - 1) || (sum1b - 2 * (numb - 1) > numvisb && numb > 0)  || (sum1w - 2 * (numw - 1) > numvisw && numw > 0))
	{
		cout << "No\n";
		return;
	}

	

	else {
		while(!visw.empty() || !visb.empty()){
			if (!visb.empty()) {
				int v = *(visb.begin());
				visb.erase(v);
				b[v]--;


				if (!kekb.empty()) {
					int u = *kekb.begin();
					eb.push_back({ u, v });
					b[u]--;

					if (b[u] == 0)
					{
						kekb.erase(u);
						if (w[u] == 1) {
							kekw.erase(u);
							visw.insert(u);
						}
					}
					if (b[u] == 1 && w[u] == 0) {
						kekb.erase(u);
						visb.insert(u);
					}
				}

				else {
					int u = *(visb.begin());
					visb.erase(u);
					b[u]--;
					eb.push_back({ u,v });
				}

			}

			else {

				int v = *(visw.begin());
				visw.erase(v);
				w[v]--;


				if (!kekw.empty()) {
					int u = *kekw.begin();
					ew.push_back({ u, v });
					w[u]--;

					if (w[u] == 0)
					{
						kekw.erase(u);
						if (b[u] == 1) {
							kekb.erase(u);
							visb.insert(u);
						}
					}
					if (w[u] == 1 && b[u] == 0) {
						kekw.erase(u);
						visw.insert(u);
					}
				}

				else {
					int u = *(visw.begin());
					visw.erase(u);
					w[u]--;
					ew.push_back({ u,v });
				}
			}

			
		}
		
		cout << "Yes\n";
		for (auto p : eb) {
			cout << p.first + 1 << ' ' << p.second + 1 << ' ' << "B" << '\n';
		}

		for (auto p : ew) {
			cout << p.first + 1 << ' ' << p.second + 1 << ' ' << "W" << '\n';
		}
	}

}



int main()
{
	ios::sync_with_stdio(false);
	cin.tie(0);
	rnd = mt19937(956231);
	int t = 1;
	cin >> t;

	while (t--) {
		solve();
	}

}

/*

*/