#include <bits/stdc++.h>
// #pragma GCC optimize("Ofast,no-stack-protector")
// #pragma GCC optimize("O3")
// #pragma GCC optimize("unroll-loops")
// #pragma GCC target("sse,sse2,sse3,ssse3,sse4.1,sse4.2,sse4a,popcnt,abm,mmx,avx,avx2,tune=native")
// #define deb(a, n) {for (int i_i = 0; i_i < n; i_i++) cout << a[i_i] << ' '; cout << '\n'; }
// #undef MAKS
#define int ll

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
// typedef long double ld;
typedef double ld;
// typedef unsigned int uint;
typedef pair<int, int> par;

template <typename T>
inline int sz(const T& t) {
    return (int)(t.size());
}

template <typename T>
inline T sq(T const &t) {
    return t * t;
}

template <typename T>
inline void maxeq(T& t1, const T& t2) {
    t1 = max(t1, t2);
}

template <typename T>
inline void mineq(T& t1, const T& t2) {
    t1 = min(t1, t2);
}

template <typename T, const size_t N>
ostream& operator<<(ostream& os, const array<T, N>& a) {
#ifdef MAKS
    if (sz(a) == 0) {
        os << "E";
    }
#endif  // MAKS
    for (const T &i : a) {
        os << i << ' ';
    }
    os << '\n';
    return os;
}

template <typename T>
ostream& operator<<(ostream& os, const vector<T>& a) {
#ifdef MAKS
    if (sz(a) == 0) {
        os << "E";
    }
#endif  // MAKS
    for (const T &i : a) {
        os << i << ' ';
    }
    os << '\n';
    return os;
}

template <typename T>
ostream& operator <<(ostream &os, const set<T> &s) {
#ifdef MAKS
    if (sz(s) == 0) {
        os << "E";
    }
#endif  // MAKS
    for (const T &i : s) {
        os << i << ' ';
    }
    os << '\n';
    return os;
}

template <typename T, typename TT>
ostream& operator <<(ostream &os, const map<T, TT> &s) {
#ifdef MAKS
    if (sz(s) == 0) {
        os << "E";
    }
#endif  // MAKS
    for (const pair<T, TT> &i : s) {
        os << i << ' ';
    }
    os << '\n';
    return os;
}

template <typename T, typename TT>
ostream& operator <<(ostream &os, const unordered_map<T, TT> &s) {
#ifdef MAKS
    if (sz(s) == 0) {
        os << "E";
    }
#endif  // MAKS
    for (const pair<T, TT> &i : s) {
        os << i << ' ';
    }
    os << '\n';
    return os;
}

template <typename T, typename U>
ostream& operator <<(ostream& os, const pair<T, U> &p) {
#ifdef MAKS
    os << "(" << p.first << ' ' << p.second << ")";
#else
    os << p.first << ' ' << p.second;
#endif  // MAKS
    return os;
}

template <typename T>
void print(ostream &os, T const &t, string const &sep, string const &_end, bool need_size) {
    if (need_size) {
        os << sz(t) << '\n';
    }
    bool b = false;
    for (auto i : t) {
        if (b) {
            os << sep;
        }
        b = true;
        os << i;
    }
    os << _end;
}



struct T {
    int from, to, w, id;
    T(int from, int to, int w, int id): from(from), to(to), w(w), id(id) {}
};

vector <T> edg;
vector <vector <int>> e;
vector <bool> used_e;
vector <int> dist;
vector <int> mx, mn, del;
vector <int> cnt;
vector <int> p;

inline signed solve() {
    int n, m;
    cin >> n >> m;
    e.resize(n);
    mn.resize(n, INT_MAX);
    mx.resize(n, INT_MIN);
    del.resize(n, 0);
    dist.resize(n, INT_MAX);
    used_e.resize(m * 2);
    cnt.resize(n);
    p.resize(n);
    for (int i = 0; i < m; i++) {
        int u, v, w;
        cin >> u >> v >> w;
        u--, v--;
        e[u].push_back(i * 2);
        edg.push_back(T(u, v, w, i * 2));
        e[v].push_back(i * 2 + 1);
        edg.push_back(T(v, u, w, i * 2 + 1));
    }

    queue <int> que;
    que.push(0);
    dist[0] = 0;
    while (!que.empty()) {
        int z = que.front();
        que.pop();
        for (auto i : e[z]) {
            int to = edg[i].to;
            if (dist[to] > dist[z] + 1) {
                dist[to] = dist[z] + 1;
                que.push(to);
            }
        }
    }
    for (T i : edg) {
        if (dist[i.to] == dist[i.from] + 1) {
            used_e[i.id] = 1;
            cnt[i.to]++;
        }
    }

    que.push(0);
    p[0] = -1;
    while (!que.empty()) {
        int z = que.front();
        que.pop();
        for (auto t : e[z]) {
            T i = edg[t];
            if (!used_e[i.id]) {
                continue;
            }

            maxeq(mx[i.to], max(mx[z], i.w));
            mineq(mn[i.to], min(mn[z], i.w));
            int zq = max({del[z], i.w - mn[z], mx[z] - i.w});
            if (zq > del[i.to]) {
                del[i.to] = zq;
                p[i.to] = i.from;
            }

            cnt[i.to]--;
            if (cnt[i.to] == 0) {
                que.push(i.to);
            }
        }
    }
    // cout << del[n - 1] << '\n';
    vector <int> ans;
    int y = n - 1;
    while (y != -1) {
        ans.push_back(y + 1);
        y = p[y];
    }
    cout << sz(ans) - 1 << '\n';
    reverse(ans.begin(), ans.end());
    cout << ans;


    return 0;
}

const bool MULTITEST = 0;

signed main()
{
#ifdef MAKS
    freopen("input.txt", "r", stdin);
    // freopen("output.txt", "w", stdout);
    // freopen("error.txt", "w", stderr);
#endif  // MAKS
    ios_base::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);
    cout << fixed << setprecision(10);
    if (MULTITEST) {
        int t;
        // scanf("%d", &t);
        cin >> t;
        while (t--) {
            solve();
        }
        return 0;
    } else {
        solve();
    }
    return 0;
}
