#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

ll gcd(ll a, ll b) {
    if (a == 0) return b;
    if (b == 0) return a;
    ll mod = a % b;
    return gcd(b, mod);
}

bool check_q(const vector<string> &field, int i, int j) {
    return (field[i][j] == '#' && field[i + 1][j] == '#' && field[i + 2][j] == '#' && field[i + 3][j] != '#');
}

void null_q(vector<string> &field, int i, int j) {
    field[i][j] = '.';
    field[i + 1][j] = '.';
    field[i + 2][j] = '.';

    field[i][j + 1] = '.';
    field[i + 2][j + 1] = '.';

    field[i][j + 2] = '.';
    field[i + 1][j + 2] = '.';
    field[i + 2][j + 2] = '.';
    field[i + 3][j + 2] = '.';
    field[i + 4][j + 2] = '.';
}

void null_f(vector<string> &field, int i, int j) {
    field[i][j] = '.';
    field[i + 1][j] = '.';
    field[i + 2][j] = '.';
    field[i + 3][j] = '.';
    field[i + 4][j] = '.';

    field[i][j + 1] = '.';
    field[i + 2][j + 1] = '.';

    field[i][j + 2] = '.';
}

int main() {
    int n, m;
    cin >> n >> m;
    vector<string> field(n);
    for (int i = 0; i < n; i++) {
        cin >> field[i];
    }
    int q = 0, f = 0;
    for (int j = 0; j < m; j++) {
        for (int i = 0; i < n; i++) {
            if (field[i][j] == '#') {
                if (check_q(field, i, j)) {
                    q++;
                    null_q(field, i, j);
                } else {
                    f++;
                    null_f(field, i, j);
                }
            }
        }
    }
    cout << q << ' ' << f;
    return 0;
}