#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <cmath>
#include <queue>
#include <numeric>
#include <map>

using namespace std;

const int INF = 400000;
int nextt = 1;

vector<vector<int>> arr;
vector<bool> term;

void add(string& s) {
    int cur = 0;
    for (int i = 0; i < s.size(); i++) {
        if (arr[cur][s[i] - 'a'] != -1) {
            cur = arr[cur][s[i] - 'a'];
        }
        else {
            arr[cur][s[i] - 'a'] = nextt;
            cur = nextt++;
        }
    }
    term[cur] = true;
}

pair<int, int> get_ans(int cur, int k) {
    // cout << "cur: " << cur << endl;
    int answer = 0;
    vector<int> brr;
    for (int i = 0; i < 30; i++) {
        if (arr[cur][i] != -1) {
            // exit(0);
            pair<int, int> ans = get_ans(arr[cur][i], k);
            answer += ans.first;
            if (ans.second != 0) {
                brr.push_back(ans.second);
            }
        }
    }
    sort(brr.begin(), brr.end());
    int sum = 0;
    if (term[cur] == true) {
        sum = 1;
    }
    int i = 0;
    for (; i < brr.size() && sum < k; i++) {
        sum += brr[i];
    }
    if (sum >= k) {
        // cout << i << endl;
        // cout << "brr: ";
        // for (int u : brr) {
        //     cout << u << " ";
        // }
        // cout << endl;
        int addition;
        if (i == brr.size()) {
            if (sum > k) {
                addition = 1;
            }
            else {
                addition = 0;
            }
        }
        else {
            if (sum > k) {
                addition = brr.size() - i + 1;
            }
            else {
                addition = brr.size() - i;
            }
        }
        // int addition = brr.size() - i + 1;
        // if (sum == k) {
        //     addition--;
        // }
        answer += 1 + addition;
        // cout << "cur: " << cur << endl << answer << endl;
        return make_pair(answer, 0);
    }
    // cout << "cur: " << cur << endl << answer << " " << sum << endl;
    return make_pair(answer, sum);
}


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0), 
    cout.tie(0);
    int n, k;
    cin >> n >> k;
    arr.resize(INF, vector<int>(30, -1));
    term.resize(INF, false);
    for (int i = 0; i < n; i++) {
        string s;
        cin >> s;
        add(s);
    }
    // cout << nextt << endl;
    // return 0;
    pair<int, int> ans = get_ans(0, k);
    int answer = ans.first;
    if (ans.second > 0) {
        answer++;
    }
    cout << answer;
}

