#include <bits/stdc++.h>

using namespace std;

#define rall(x) (x).begin(), (x).end()
#define all(x) (x).begin(), (x).end()
#define SZ(x) (int)(x).size()
#define F first
#define S second
#define int int64_t


const int INF = 1e9;

void del_f(vector <vector <char>> &a, int i, int j) {
    a[i][j] = '.';
    a[i][j - 1] = '.';
    
    a[i    ][j - 2] = '.';
    a[i + 1][j - 2] = '.';
    a[i + 2][j - 2] = '.';
    a[i + 3][j - 2] = '.';
    a[i + 4][j - 2] = '.';


    a[i + 2][j - 1] = '.';
}

void del_q(vector <vector <char>> &a, int i, int j) {
    a[i    ][j] = '.';
    a[i + 1][j] = '.';
    a[i + 2][j] = '.';
    a[i + 3][j] = '.';
    a[i + 4][j] = '.';

    a[i][j - 1] = '.';
    a[i][j - 2] = '.';
    a[i + 1][j - 2] = '.';
    a[i + 2][j - 2] = '.';
    a[i + 2][j - 1] = '.';
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector <vector <char>> a(n, vector <char> (m));
    vector <int> cnt(m, 0);
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cin >> a[i][j];
            if (a[i][j] == '#') {
                ++cnt[j];
            }
        }
    }
    int ansf = 0, ansq = 0;
    while (true) {
        int pos = -1;
        for (int j = m - 1; j >= 0; --j) {
            if (cnt[j] > 0) {
                pos = j;
                break;
            }
        }
        if (pos == -1) {
            break;
        }
        for (int i = 0; i < n; ++i) {
            if (a[i][pos] == '#') {
                if (a[i + 1][pos] == '#') {
                    ++ansq;
                    del_q(a, i, pos);
                    cnt[pos] -= 5;
                    cnt[pos - 1] -= 2;
                    cnt[pos - 2] -= 3;
                } else {
                    ++ansf;
                    del_f(a, i, pos);
                    cnt[pos] -= 1;
                    cnt[pos - 1] -= 2;
                    cnt[pos - 2] -= 5;
                }
            }
        }
    }
    cout << ansq << " " << ansf << endl;
}


int32_t main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    #ifdef fleek$
        assert(freopen ("input.txt", "r", stdin));
    #endif
    int t = 1;
    // cin >> t;
    for (int i = 0; i < t; ++i) {
        solve();
    } 
    return 0;
}