def corr(x, y):
    return 0 <= x < n - 4 and 0 <= y < m - 2

Q = [['#', '#', '#'],
     ['#', '.', '#'],
     ['#', '#', '#'],
     ['.', '.', '#'],
     ['.', '.', '#']]

F = [['#', '#', '#'],
     ['#', '.', '.'],
     ['#', '#', '.'],
     ['#', '.', '.'],
     ['#', '.', '.']]


def q(x, y):
    if not corr(x, y):
        return False
    for i in range(5):
        for j in range(3):
            if u[x + i][y + j] != Q[i][j]:
                return False
    return True


def f(x, y):
    if not corr(x, y):
        return False
    for i in range(5):
        for j in range(3):
            if u[x + i][y + j] != F[i][j]:
                return False
    return True


n, m = map(int, input().split())
u = []
z = []
for i in range(n):
    u.append(list(input()))
    z.append([0] * m)
# 0 - no letters
# 1 - F
# 2 - Q
# 3 - both
queue = []
for i in range(n - 4):
    for j in range(m - 2):
        ff = f(i, j)
        qq = q(i, j)
        if ff and qq:
            z[i][j] = 3
        elif qq:
            z[i][j] = 2
            queue.append((i, j))
        elif ff:
            z[i][j] = 1
            queue.append((i, j))
ans = [0, 0]
q0 = 0
while len(queue) > q0:
    x, y = queue[q0]
    q0 += 1
    if z[x][y] == 1:
        ans[1] += 1
    else:
        ans[0] += 1
    for i in range(5):
        for j in range(3):
            u[x + i][y + j] = '.'
    for i in range(x - 4, x + 5):
        for j in range(y - 2, y + 3):
            if not corr(i, j):
                continue
            ff = f(i, j)
            qq = q(i, j)
            if ff and qq:
                z[i][j] = 3
            elif qq:
                z[i][j] = 2
                queue.append((i, j))
            elif ff:
                z[i][j] = 1
                queue.append((i, j))
print(*ans)
                
