﻿#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <random>
#include <cstdio>
#include <cassert>
#include <fstream>
#include <sstream>
#include <vector>
#include <set>
#include <string>
#include <cmath>
#include <algorithm>
#include <map>
#include <queue>
#include <iomanip>
#include <cstring>
#include <locale>
#include <unordered_map>
#include <unordered_set>
#include <bitset>
#include <stack>
#define pb push_back
#define mp make_pair
#define sz(a) int((a).size())
#define all(x) (x).begin(),(x).end()
#define forn(i, e, n) for(int i = e; i < int(n); i++)
#define makeunique(x) sort(all(x)), (x).resize(unique(all(x)) - (x).begin())
#define ff first
#define ss second
#define int long long
using namespace std;
mt19937 rnd(time(NULL));
typedef long long  ll;
typedef long double ld;
typedef pair<int, int> pt;
typedef pair<ll, ll> pll;
const ll INF64 = ll(1e18) + 10;
const int INF = int(1e9) + 10;
const int MOD = 998244353;
const int MAXN = 3 * 1e5;

int n, m;
int a[MAXN];
vector<pt> lr[MAXN];

void get1(int id) {
    if (a[id + 1] - a[id] >= 2 * m) {
        lr[id].pb(mp(INF, -INF));
        return;
    }
    if (a[id + 1] - a[id] <= m) {
        lr[id].pb(mp(0, m));
        return;
    }
    int day1 = a[id] / m;
    int day2 = a[id + 1] / m;
    int mn, mx;
    if (day1 + 1 == day2) {
        lr[id].push_back(mp(0, m - (a[id + 1] % m)));
        lr[id].push_back(mp((m - (a[id] % m)) % m, m));
    }
    else {
        mn = (m - (a[id] % m)) % m;
        mx = m - (a[id + 1] % m);
        lr[id].push_back(mp(mn, mx));
    }
}

vector<pt> t[MAXN * 4];

void clear1() {
    forn(i, 0, n * 4) {
        t[i].clear();
    }
    forn(i, 0, n)
        lr[i].clear();
 }

bool checkpt(const pt& a) {
    return (a.first < a.second && a.first != INF && a.second != -INF);
}

pt peresech(pt a, pt b) {
    pt ans = mp(INF, -INF);
    if (checkpt(a) == 0 || checkpt(b) == 0) {
        return ans;
    }
    ans.first = max(a.first, b.first);
    ans.second = min(a.second, b.second);
    return ans;
}

vector<pt> comb(const vector<pt>& a, const vector<pt>& b) {
    vector<pt> c;
    forn(i, 0, sz(a)) {
        forn(j, 0, sz(b)) {
            pt x = peresech(a[i], b[j]);
            if (x.first < x.second)
                c.pb(x);
        }
    }
    return c;
}

void build(int v, int l1, int r1) {
    if (l1 + 1 == r1) {
        forn(i, 0, sz(lr[l1]))
            t[v].push_back(lr[l1][i]);
        return;
    }
    int m = (l1 + r1) / 2;
    build(v * 2 + 1, l1, m);
    build(v * 2 + 2, m, r1);
    t[v] = comb(t[v * 2 + 1], t[v * 2 + 2]);
}

vector<pt> get(int v, int l1, int r1, int ql, int qr) {
    if (qr <= l1 || r1 <= ql) {
        vector<pt> a;
        a.push_back(mp(-INF, INF));
        return a;
    }
    if (ql <= l1 && r1 <= qr) {
        return t[v];
    }
    int m = (l1 + r1) / 2;
    vector<pt> L = get(v * 2 + 1, l1, m, ql, qr);
    vector<pt> R = get(v * 2 + 2, m, r1, ql, qr);
    return comb(L, R);
}

bool check(const vector<pt>& a) {
    forn(i, 0, sz(a)) {
        if (a[i].first < a[i].second && a[i].first != -INF && a[i].second != INF)
            return 1;
    }
    return 0;
}

int main() {
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int t1;
    cin >> t1;
    forn(_, 0, t1) {
        int cntday = 0;
        int id = 0;
        cin >> n >> m;
        clear1();
        forn(i, 0, n) cin >> a[i];
        forn(i, 0, n - 1) get1(i);
        build(0, 0, n);
        forn(i, 0, n) {
            int l1 = i, r1 = n;
            while (r1 - l1 > 1) {
                int m = (l1 + r1) / 2;
                vector<pt> f = get(0, 0, n, i, m);
                if (check(f))
                    l1 = m;
                else
                    r1 = m;
            }
            if (l1 == i) {
                continue;
            }
            vector<pt> f = get(0, 0, n, i, l1);
            for (pt x : f) {
                if (checkpt(x) && x.first != -INF && x.second != INF) {
                    int day1 = (a[i] + x.first) / m;
                    int day2 = (a[l1] + x.first) / m;
                    int nxtday = min(x.second - 1, m - (a[l1] % m));
                    int day3 = (a[i] + nxtday) / m;
                    int day4 = (a[l1] + nxtday) / m;
                    if (day2 - day1 > cntday) {
                        cntday = day2 - day1;
                        id = x.first;
                    }
                    if (day4 - day3 > cntday) {
                        cntday = day4 - day3;
                        id = nxtday;
                    }
                }
            }
        }
        assert(id != m);
        cout << cntday + 1 << ' ' << id << endl;
    }

    return 0;
}