﻿#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <random>
#include <cstdio>
#include <cassert>
#include <fstream>
#include <sstream>
#include <vector>
#include <set>
#include <string>
#include <cmath>
#include <algorithm>
#include <map>
#include <queue>
#include <iomanip>
#include <cstring>
#include <locale>
#include <unordered_map>
#include <unordered_set>
#include <bitset>
#include <stack>
#define pb push_back
#define mp make_pair
#define sz(a) int((a).size())
#define all(x) (x).begin(),(x).end()
#define forn(i, e, n) for(int i = e; i < int(n); i++)
#define makeunique(x) sort(all(x)), (x).resize(unique(all(x)) - (x).begin())
#define ff first
#define ss second
using namespace std;
mt19937 rnd(time(NULL));
typedef long long  ll;
typedef long double ld;
typedef pair<int, int> pt;
typedef pair<ll, ll> pll;
const ll INF64 = ll(1e18) + 10;
const int INF = int(1e9) + 10;
const int MOD = 998244353;
const int MAXN = 3 * 1e5;

int n, m;
int a[MAXN];
int l[MAXN];
int r[MAXN];

void get1(int id) {
    if (a[id + 1] - a[id] >= 2 * m) {
        l[id] = r[id] = -1;
        return;
    }
    if (a[id + 1] - a[id] <= m) {
        l[id] = 0;
        r[id] = m;
        return;
    }
    int mn = (a[id] + m - 1) / m * m - a[id];
    int mx = (a[id + 1] + m - 1) / m * m - a[id + 1];
    l[id] = mn;
    r[id] = mx;
}

int t[MAXN * 4][2];

void clear1() {
    forn(i, 0, n * 4) {
        t[i][0] = -INF;
        t[i][1] = INF;
    }
 }

void build(int v, int l1, int r1) {
    if (l1 + 1 == r1) {
        t[v][0] = l[l1];
        t[v][1] = r[l1];
        return;
    }
    int m = (l1 + r1) / 2;
    build(v * 2 + 1, l1, m);
    build(v * 2 + 2, m, r1);
    t[v][0] = max(t[v * 2 + 1][0], t[v * 2 + 2][0]);
    t[v][1] = min(t[v * 2 + 1][1], t[v * 2 + 2][1]);
}

pt get(int v, int l1, int r1, int ql, int qr) {
    if (qr <= l1 || r1 <= ql) {
        return mp(-INF, INF);
    }
    if (ql <= l1 && r1 <= qr) {
        return mp(t[v][0], t[v][1]);
    }
    int m = (l1 + r1) / 2;
    pt L = get(v * 2 + 1, l1, m, ql, qr);
    pt R = get(v * 2 + 2, m, r1, ql, qr);
    return mp(max(L.first, R.first), min(L.second, R.second));
}

int main() {
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int t1;
    cin >> t1;
    forn(_, 0, t1) {
        int cntday = 0;
        int id = 0;
        cin >> n >> m;
        forn(i, 0, n) cin >> a[i];
        forn(i, 0, n - 1) get1(i);
        clear1();
        build(0, 0, n);
        forn(i, 0, n) {
            int l1 = 0, r1 = n - i;
            while (r1 - l1 > 1) {
                int m = (l1 + r1) / 2;
                pt f = get(0, 0, n, i, i + m);
                if (f.first < f.second && f.second != -1)
                    l1 = m;
                else
                    r1 = m;
            }
            if (l1 == 0) {
                continue;
            }
            pt f = get(0, 0, n, i, i + l1);
            int day1 = (a[i] + f.first) / m;
            int day2 = (a[i + l1] + f.first) / m;
            int x = min(f.second - 1, (a[i + l1] + m - 1) / m * m - a[i + l1]);
            int day3 = (a[i] + x) / m;
            int day4 = (a[i + l1] + x) / m;
            if (day2 - day1 > cntday) {
                cntday = day2 - day1;
                id = f.first;
            }
            if (day4 - day3 > cntday) {
                cntday = day4 - day3;
                id = x;
            }
        }
        assert(id != m);
        cout << cntday + 1 << ' ' << id << endl;
    }

    return 0;
}