#include <iostream>
#include <cmath>
#include <vector>
#include <map>
#include <string>
#include <algorithm>
#include <queue>
#include <set>
#include <bitset>

//#pragma warning(disable : 4996)

using namespace std;

#define int long long
#define all(x) x.begin(), x.end()
#define ff first
#define ss second

const int maxn = 1e6 + 13;
const int INF = 3e18 + 1;
const int MOD = 1e9 + 7;// 1e9 + 9, 1e9 + 21, 1e9 + 33, 1e9 + 321

vector<pair<int, int>> gr[maxn];
vector<pair<int, int>> gr2[maxn];
bool ok[maxn];
int minc[maxn];
int maxc[maxn];
int dist[maxn];
int par[maxn];
signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	
	int n, m;
	cin >> n >> m;
	
	for (int i = 1; i <= m; ++i) {
		int u, v, c;
		cin >> u >> v >> c;
		gr[u].push_back({ v, c });
		gr[v].push_back({ u, c });
	}
	par[1] = 1;
	queue<int> q;
	q.push(1);
	fill(dist, dist + n + 1, INF);
	fill(minc, minc + n + 1, INF);
	dist[1] = 0;
	while (!q.empty()) {
		int v = q.front();
		ok[v] = 1;
		q.pop();
		for (auto t : gr[v]) {
			if (ok[t.first])continue;
			dist[t.first] = dist[v] + 1;
			q.push(t.first);
			ok[t.first] = 1;
		}
	}

	set<int> st, st2;
	int dst = dist[n] - 1;
	st.insert(n);
	while (dst >= 0) {
		for (auto t : st) {
			for (auto u : gr[t]) {
				if (dst != dist[u.first])continue;
				gr2[u.first].push_back({t, u.second});
				st2.insert(u.first);
			}
		}
		swap(st, st2);
		st2.clear();
		dst--;
	}
	dst = 0;
	st.clear();
	st2.clear();
	st.insert(1);
	while (dst <= dist[n]) {
		for (auto t : st) {
			for (auto  u : gr2[t]) {
				st2.insert(u.first);
				int mincUpd = min(minc[t], u.second);
				int maxcUpd = max(maxc[t], u.second);
				if (minc[u.first] >= mincUpd) {
					minc[u.first] = mincUpd;
					par[u.first] = t;
				}
				if (maxc[u.first] <= maxcUpd) {
					maxc[u.first] = maxcUpd;
					par[u.first] = t;
				}
			}
		}
		swap(st, st2);
		st2.clear();
		dst++;
	}

	int v = n;
	vector<int> res;
	while (par[v] != v) {
		res.push_back(v);
		v = par[v];
	}
	res.push_back(1);
	reverse(all(res));

	cout << res.size() - 1 << "\n";
	for (auto t : res)cout << t << " ";

	return 0;
}