#include <iostream>
#include <iomanip>
#include <fstream>
#include <cstdio>
#include <cmath>
#include <cstring>
#include <ctime>
#include <algorithm>
#include <random>
#include <vector>
#include <string>
#include <queue>
#include <deque>
#include <list>
#include <set>
#include <map>
#include <bitset>
#include <unordered_set>
#include <unordered_map>
#include <chrono>
#include <cassert>
#include <cstdint>
#include <cstddef>
#include <utility>
#include <functional>
#include <stdexcept>

#define FILE 0
#define RANDOM 0

using namespace std;

#if RANDOM
const unsigned seed = (unsigned)chrono::system_clock::now().time_since_epoch().count();
mt19937 rnd(seed);
#endif

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef ll typ;
typedef unsigned int ui;

const int N = 1e5 + 10, K = 26, M = 110;
const ll INF = 5e18 + 3;
const ld EPS = 5e-7, PI = acos(-1);
const int MOD = 998244353, INFI = 2e9 + 7, SQ = 50;
const ull A = 239, P = 1e9 + 9;

int n;
ld l, v, a[N];

ld f(ld x) {
    ld ans = 0;
    for (int i = 0; i < n; i++) {
        ans += (x <= v * l / (a[i] + v)
                ? (l - x) / a[i] + x / v
                : 2 * l / (a[i] + v));
    }
    ans /= n;
    //cout << setprecision(20) << fixed << x << ' ' << ans << endl;
    return ans;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

#if FILE
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    cin >> n >> l >> v;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    ld ans = f(0);
    for (int i = 0; i < n; i++) {
        ans = min(ans, f(v * l / (a[i] + v)));
    }
    cout << setprecision(20) << fixed << ans << endl;

#if FILE
    fclose(stdin);
    fclose(stdout);
#endif

    return 0;
}