#include <bits/stdc++.h>

using namespace std;


struct tree{
    tree* pred;
    int numOfChilds;
    string str;
    vector<tree*> child;
    tree(tree* pred, int num, string str, vector<tree*> vec){
        this->pred = pred;
        this->numOfChilds = num;
        this->str = str;
        this->child = vec;
    }
};

vector<vector<tree*>> layers;

int firstDif(string s, string s2){
    for (int i = 0; i < min(s.size(), s2.size()); i++){
        if (s[i] != s2[i]){
            return i;
        }
    }
    return -1;
}

void countLayers(tree* t, int i){
    layers[i].push_back(t);
    for (int j = 0; j < t->child.size(); j++){
        countLayers(t->child[j], i+1);
    }
}

void printTreeStr(tree* t){
    cout << t->str << "{";
    for (int i = 0; i < t->child.size(); i++){
        printTreeStr(t->child[i]);
        cout << ",";
    }
    cout << "}";
}

void printTreeNum(tree* t){
    cout << t->numOfChilds << "{";
    for (int i = 0; i < t->child.size(); i++){
        printTreeNum(t->child[i]);
        cout << ",";
    }
    cout << "}";
}

void deleteT(tree* t, int x){
    for (tree* curr = t; curr != NULL; curr = curr->pred){
        curr->numOfChilds -= x;
    }
}

int main(){
    int n, k;
    cin >> n >> k;
    vector<string> a;
    for (int i = 0; i < n; i++){
        string s;
        cin >> s;
        s.push_back('$');
        a.push_back(s);
    }
    tree* route = new tree(NULL, 0, "" , vector<tree*>());
    for (int i = 0; i < n; i++){
        string str = a[i];
        for (tree* curr = route; ; ){
            curr->numOfChilds++;
            bool f = true;
            bool f2 = true;
            for (int j = 0; j < curr->child.size(); j++){
                if (str[0] == curr->child[j]->str[0]){
                    f = false;
                    int l = firstDif(str, curr->child[j]->str);
                    if (l == -1){

                        f2 = false;
                        str = str.substr(curr->child[j]->str.size());
                        curr = curr->child[j];
                        break;
                    }
                    string pref = str.substr(0, l);
                    string suf1 = curr->child[j]->str.substr(l);
                    string suf2 = str.substr(l);
                    curr->child[j]->str = pref;
                    tree* newV1 = new tree(curr->child[j], curr->child[j]->numOfChilds, suf1, curr->child[j]->child);
                    tree* newV2 = new tree(curr->child[j], 1, suf2, vector<tree*>());
                    vector<tree*> t;
                    t.push_back(newV1);
                    t.push_back(newV2);
                    curr->child[j]->child = t;
                    curr->child[j]->numOfChilds++;
                    break;
                }
            }
            if (!f2){
                continue;
            }
            if (f){
                tree* newV = new tree(curr, 1, str, vector<tree*>());
                curr->child.push_back(newV);
                break;
            }
            break;
        }
    }
    int ans = 0;
    layers.resize(n+1);
    countLayers(route, 0);
    printTreeNum(route); cout << endl;
    printTreeStr(route); cout << endl;
    for (int i = 0; i <= n; i++){

        for (int j = 0; j < layers[i].size(); j++){
            if (layers[i][j]->numOfChilds <= k && (layers[i][j]->pred == NULL || layers[i][j]->pred->numOfChilds > k)){
                if (layers[i][j]->pred == NULL){
                    ans++;
                    cout << ans;
                    return 0;
                }
                int max = 0;
                int maxi = -1;
                for (int l = 0; l < layers[i][j]->pred->child.size(); l++){
                    if (layers[i][j]->pred->child[l]->numOfChilds <= k && max < layers[i][j]->pred->child[l]->numOfChilds ){
                        max = layers[i][j]->pred->child[l]->numOfChilds;
                        maxi = l;
                    }
                }
                ans ++;
                deleteT(layers[i][j]->pred->child[maxi], layers[i][j]->pred->child[maxi]->numOfChilds);
                tree* t = layers[i][j]->pred;
                t->child[maxi] = t->child[t->child.size()-1];
                t->child.pop_back();

                i++;
                break;
            }
        }
    }

    for (;;);
}
