#include <bits/stdc++.h>

using namespace std;

using ll = long long; 

ll gcd (ll a, ll b, ll & x, ll & y) {
	if (a == 0) {
		x = 0; y = 1;
		return b;
	}
	ll x1, y1;
	ll d = gcd (b%a, a, x1, y1);
	x = y1 - (b / a) * x1;
	y = x1;
	return d;
}
 
bool find_any_solution (ll a, ll b, ll c, ll & x0, ll & y0, ll & g) {
	g = gcd (abs(a), abs(b), x0, y0);
	if (c % g != 0)
		return false;
	x0 *= c / g;
	y0 *= c / g;
	if (a < 0)   x0 *= -1;
	if (b < 0)   y0 *= -1;
	return true;
}

void shift_solution (ll & x, ll & y, ll a, ll b, ll cnt) {
	x += cnt * b;
	y -= cnt * a;
}
 
bool find_all_solutions (ll a, ll b, ll c, ll &x, ll &y) {
	ll g;
	if (! find_any_solution (a, b, c, x, y, g))
		return 0;
	a /= g;  b /= g;
 
	ll sign_a = a>0 ? +1 : -1;
	ll sign_b = b>0 ? +1 : -1;
 
	shift_solution (x, y, a, b, (0 - x) / b);
	if (y >= 0 && x >= 0)
		return 1;
	
	shift_solution (x, y, a, b, - (0 - y) / a);
	if (y < 0)
		shift_solution (x, y, a, b, -sign_a);
	if (y >= 0 && x >= 0)
		return 1;
	return 0;
}

void solve() {
    ll A, B, C; cin >> C >> A >> B; C = -C;
    ll x, y;
    for (ll i = 0; ; i++) {
        if (find_all_solutions(A, B, -C + i, x, y)) break;        
		if (find_all_solutions(A, B, -C - i, x, y)) break;
    }
    cout << x << ' ' << y << endl;
}


int main() {
    solve();
}