#include<bits/stdc++.h>

using namespace std;

#define all(d) d.begin(), d.end()

using vint = vector < int >;
using vvint = vector < vint >;
using vpint = vector < pair < int, int > >;
using ll = long long;
const int INF = 1e9;

using niyqueue = priority_queue < pair < int, int > , vector < pair < int, int > >, greater < pair < int, int > > >;

struct pt{
    double x, y;
};

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    ll n, m, c;
    cin >> n >> m >> c;

    ll up = n + 1, down = 0, k1 = -1, k2 = -1, razn = INF;

    while(true){
        ll mid = (up + down) / 2;

        if(mid == up || mid == down) break;

        ll a = mid / m;
        ll b = (n - mid + mid % m) / c;
        ll r = (n - mid + mid % m) % c;

        if(r < razn){
            up = mid - 1;
            razn = r;
            k1 = a;
            k2 = b;
        }else{
            down = mid + 1;
        }
    }

    cout << k1 << " " << k2;

    return 0;
}

/*
    *. *****. *****. *****. *****. *   *. *****.     *. *****. *****. *****. *****.
   **.     *.     *. *   *.    * . *   *. *    .    * .    * . *   *. *   *. *   *.
  * *.     *.     *. *   *.   *  . *   *. *    .   *  .   *  . *   *. *   *. *   *.
 *  *.     *.     *. *   *.  *   . *   *. *    .  *   .  *   . *   *. *   *. *   *.
*   *.     *.     *. *****. *****. *****. *****. *****. *    . *****. *****. *   *.
    *.    * .    * . *   *.    * .     *.     *. *   *. *    . *   *.    * . *   *.
    *.   *  .   *  . *   *.   *  .     *.     *. *   *. *    . *   *.   *  . *   *.
    *.  *   .  *   . *   *.  *   .     *.     *. *   *. *    . *   *.  *   . *   *.
    *. *****. *****. *****. *    .     *. *****. *****. *    . *****. *    . *****.
  */
