﻿#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <queue>
#include <iomanip>
#include <algorithm>
#include <math.h>

using namespace std;

char ms[300][300];
int F,Q;

bool FP(int i, int j){
    bool f(0);
    if (ms[i][j] =='#' &&
            ms[i][j+1] =='#' &&
            ms[i][j+2] =='#' &&
            ms[i+1][j] =='#' &&
            ms[i+2][j] =='#' &&
            ms[i+2][j+1] =='#' &&
            ms[i+3][j] =='#' &&
            ms[i+4][j] =='#') f=1;
    if (f){
        ms[i][j] ='.';
        ms[i][j+1] ='.';
        ms[i][j+2] ='.';
        ms[i+1][j] ='.';
        ms[i+2][j] ='.';
        ms[i+2][j+1] ='.';
        ms[i+3][j] ='.';
        ms[i+4][j] ='.';
    }
    return f;
}
bool QP(int i, int j){
    bool f(0);
    if (ms[i][j] =='#'&&
            ms[i][j+1] =='#'&&
            ms[i][j+2] =='#'&&
            ms[i+1][j] =='#'&&
            ms[i+1][j+2] =='#'&&
            ms[i+2][j] =='#'&&
            ms[i+2][j+1] =='#'&&
            ms[i+2][j+2] =='#'&&
            ms[i+3][j+2] =='#'&&
            ms[i+4][j+2] =='#') f=1;
    if (f){
        ms[i][j] ='.';
        ms[i][j+1] ='.';
        ms[i][j+2] ='.';
        ms[i+1][j] ='.';
        ms[i+1][j+2] ='.';
        ms[i+2][j] ='.';
        ms[i+2][j+1] ='.';
        ms[i+2][j+2] ='.';
        ms[i+3][j+2] ='.';
        ms[i+4][j+2] ='.';

    }
    return f;
}

int main(){

    int n,m;
    cin >> n >> m;
    for(int i(0);i<n;i++)
        for(int j(0);j<m;j++)
            cin >> ms[i][j];

    for(int i(0);i<n;i++)
        for(int j(0);j<m;j++){
            if (ms[i][j] == '#'){
                if (FP(i,j)) F++;
                if (QP(i,j)) Q++;
            }
        }
    cout << Q << " " << F;

    return 0;
}
//1073741824
/*  * ***** ***** *   * *****     * ***** ***** ***** *****.
   **     *    *  *   * *        *     *  *   * *   * *   *.
  * *     *   *   *   * *       *     *   *   * *   * *   *.
 *  *     *  *    *   * *      *     *    *   * *   * *   *.
*   *     * ***** ***** ***** *****  *    ***** ***** *   *.
    *    *     *      *     * *   *  *    *   *    *  *   *.
    *   *     *       *     * *   *  *    *   *   *   *   *.
    *  *     *        *     * *   *  *    *   *  *    *   *.
    * ***** *         * ***** *****  *    ***** *     *****.*/
