#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
using namespace std;
#define ll long long
struct Node{
    int v;
    char c;
    int val;
    Node(int v,char c):v(v),c(c),val(0){}
};
bool cmp(Node a,Node b){
    return a.c<b.c;
}
int n,k;
int cnt=1,ans=0;
vector<vector<Node>> g;
vector<string> a;
vector<int> dp,vals;
int root=0;

void dfs(int cur,int v=root,int ind=0){
    //cout<<cur<<' '<<v<<' '<<ind<<endl;
    if(g[v].empty()){
        //make a child
        Node q=Node(cnt,a[cur][ind]);
        if(ind+1==a[cur].size()){
            q.val=1;
        }
        g[v].push_back(q);
        g.push_back(vector<Node>());
        sort(g[v].begin(),g[v].end(),cmp);
        ++cnt;
        if(ind+1==a[cur].size()){
            vals.push_back(1);
        }else{
            vals.push_back(0);
            dfs(cur,cnt-2,ind+1);
        }
        return;
    }
    int l=0,r=int(g[v].size());
    while(r-l>1){
        int mid=(l+r)/2;
        if(g[v][mid].c<=a[cur][ind]){
            l=mid;
        }else{
            r=mid;
        }
    }
    if(g[v][l].c==a[cur][ind]){
        dfs(cur,g[v][l].v,ind+1);
    }else{
        //make a child
        Node q=Node(cnt,a[cur][ind]);
        if(ind+1==a[cur].size()){
            q.val=1;
        }
        g[v].push_back(q);
        g.push_back(vector<Node>());
        sort(g[v].begin(),g[v].end(),cmp);
        ++cnt;
        if(ind+1==a[cur].size()){
            vals.push_back(1);
        }else{
            vals.push_back(0);
            dfs(cur,cnt-2,ind+1);
        }
        return;
    }
}

void dfs2(int v){
    for(auto u:g[v]){
        dfs2(u.v);
        dp[v]+=dp[u.v];
    }
    dp[v]+=vals[v];
    if(dp[v]>k){
        //удаляем максимального ребенка пока dp[v]>k
        while(dp[v]>k){
            int j=0;
            for(int i=1;i<g[v].size();++i){
                if(dp[g[v][i].v]>dp[j]){
                    j=i;
                }
            }
            dp[v]-=dp[j];
            ++ans;
            g[v].erase(g[v].begin()+j);
        }
    }
}

int main(){
    cin>>n>>k;
    a.resize(n);
    for(int i=0;i<n;++i){
        cin>>a[i];
    }
    sort(a.begin(),a.end());
    g.push_back(vector<Node>());
    vals.push_back(0);
    for(int i=0;i<n;++i){
        dfs(i);
    }
    dp.resize(cnt);
    dfs2(root);
    ans+=ceil(g[0].size()/double(k));
    cout<<ans<<endl;
    
    return 0;
}
