#include<iostream>
#include<math.h>
#include<string>

using namespace std;

int NOD(int a, int b)
{
    while(a > 0 && b > 0)
    {
        if(a > b)
            a %= b;
        else
            b %= a;
    }

    return a + b;
}

int IsSimple(int n)
{
    int i;
    for (i = 2; i<sqrt(n); i++) {
        if (n % i == 0) {
            return 0;
        }
    }
    return 1;
}

int main(void)
{

    int t;
    cin >> t;
    int n, tn;


    while(t-- != 0)
    {
        cin >> n;
        tn = n;

        if(IsSimple(n))
        {
            if((--tn)&1==0)
            {
                tn = tn/2;
            }
            else
                tn = (tn+1)/2;
        }
        else
        {
            if(n & 1 == 0)
            {
                tn /= 2;
            }
            else
                tn = (n+1)/2;

            int ln = tn - 1;
            int rn = tn + 1;

            while(ln >= 1)
            {
                if(NOD(ln, n) == 1)
                {
                    tn = ln;
                    break;
                }
                if(NOD(rn, n) == 1)
                {
                    tn = rn;
                    break;
                }
                --ln;
                ++rn;
            }
        }
        cout << tn << endl;
    }

    return 0;
}
