#include <bits/stdc++.h>

using namespace std;
typedef long long ll;

struct node
{
    int dist = 0;
    int min_col = 0;
    int max_col = 0;
    int min_prev = 0;
    int max_prev = 0;
};

int n, m;
node from_begin[8];
node from_end[8];
vector<pair<int, int>> v[8];
queue<int> q;

void bfs(node from[])
{
    int x = q.front();
    q.pop();
    for(int i = 0; i < v[x].size(); ++i)
    {
        if(from[x].dist + 1 < from[v[x][i].first].dist)
        {
            from[v[x][i].first].dist = from[x].dist + 1;
            q.push(v[x][i].first);
        }
        if(from[x].dist + 1 <= from[v[x][i].first].dist)
        {
            if(from[v[x][i].first].max_col < max(from[x].max_col, v[x][i].second))
            {
                from[v[x][i].first].max_col = max(from[x].max_col, v[x][i].second);
                from[v[x][i].first].max_prev = x;
            }
            if(from[v[x][i].first].min_col > min(from[x].min_col, v[x][i].second))
            {
                from[v[x][i].first].min_col = min(from[x].min_col, v[x][i].second);
                from[v[x][i].first].min_prev = x;
            }
        }
    }
}

int main()
{
    cin >> n >> m;
    for(int i = 1; i <= n; ++i)
    {
        from_begin[i].dist = numeric_limits<int>::max();
        from_begin[i].min_col = numeric_limits<int>::max();
        from_begin[i].max_col = numeric_limits<int>::min();
        from_end[i].dist = numeric_limits<int>::max();
        from_end[i].min_col = numeric_limits<int>::max();
        from_end[i].max_col = numeric_limits<int>::min();
    }
    for(int i = 0; i < m; ++i)
    {
        int x, y, z;
        cin >> x >> y >> z;
        v[x].push_back(make_pair(y, z));
        v[y].push_back(make_pair(x, z));
    }
    q.push(1);
    from_begin[1].dist = 0;
    while(!q.empty())
    {
        bfs(from_begin);
    }
    q.push(n);
    from_end[n].dist = 0;
    while(!q.empty())
    {
        bfs(from_end);
    }
    std::cout << from_begin[n].dist << endl;
    if(from_begin[n].dist == 1)
    {
        cout << 1 << ' ' << n << endl;
        return 0;
    }
    int ans_node = 0;
    int ans = 0;
    bool flag = false;
    for(int i = 2; i < n; ++i)
    {
        if(from_begin[i].max_col - from_end[i].min_col > ans)
        {
            ans_node = i;
            ans = from_begin[i].max_col - from_end[i].min_col;
            flag = true;
        }
        if(from_end[i].max_col - from_begin[i].min_col > ans)
        {
            ans_node = i;
            ans = from_end[i].max_col - from_begin[i].min_col;
            flag = false;
        }
    }
    list<int> output;
    int i = ans_node;
    while(i != 1)
    {
        output.push_front(i);
        if(!flag)
        {
            i = from_begin[i].min_prev;
        }
        else
        {
            i = from_begin[i].max_prev;
        }
    }
    output.push_front(1);
    i = ans_node;
    if(!flag)
    {
        i = from_end[i].max_prev;
    }
    else
    {
        i = from_end[i].min_prev;
    }
    while(i != n)
    {
        output.push_back(i);
        if(!flag)
        {
            i = from_end[i].max_prev;
        }
        else
        {
            i = from_end[i].min_prev;
        }
    }
    output.push_back(n);
    for(auto it = output.begin(); it != output.end(); ++it)
    {
        cout << *it << ' ';
    }
    cout << endl;
    return 0;
}