#include <iostream>
#include <algorithm>
#include <vector>
#include <string>

#define fastread  ios_base::sync_with_stdio(0);cin.tie(0);
using namespace std;


int gcd(long long a, long long b)
{
    if (a == 0)
        return b;
    if (b == 0)
        return a;

    if (a == b)
        return a;

    if (a > b)
        return gcd(a - b, b);
    return gcd(a, b - a);
}

bool is_coprime(long long a, long long b)
{
    if (gcd(a, b) == 1)
        return true;
    return false;
}


int main()
{
    fastread;

    int t = 0;
    long long n = 0;
    vector<int> v;

    cin >> t;
    while (t--)
    {
        cin >> n;
        for (long long i = 1; i < (n - 1) / 2 + 1; i++)
        {
            if (is_coprime(i, n))
                v.push_back(i);
        }

        cout << v[v.size() - 1] << endl;
        /*int size = v.size();
        if (size % 2 != 0)
            cout << v[size - 1] << endl;
        else
            cout << v[size - 1] << endl;*/
        v.clear();
    }

    return 0;
}