package com.anar;

import java.io.*;

public class H {
    public static long gcd(long a, long b) {
        while (a != 0 && b != 0) {
            if (a > b)
                a %= b;
            else
                b %= a;
        }
        return Math.max(a, b);
    }

    public static boolean areCoprime(long a, long b){
        return gcd(a, b) == 1L;
    }

    public static void main(String[] args) throws IOException {
        BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
        BufferedWriter bw = new BufferedWriter(new OutputStreamWriter(System.out));

        int t = Integer.parseInt(br.readLine());
        for (int i = 0; i < t; i++) {
            long n = Long.parseLong(br.readLine());
            long toBeFound = (n/2);
            if (n == 2)
                toBeFound = 1;
            else
                while(! areCoprime(n, toBeFound)) toBeFound--;
            bw.append(toBeFound + "\n");

        }

        bw.flush();
    }
}
