#include <iostream>
#include <vector>

using namespace std;

// int goF(char** grid, int x, int y){
//     if(
//         grid[y][x+1] == '#' &&
//         grid[y][x+2] == '#' &&
//         grid[y-1][x] == '#' &&
//         grid[y-2][x] == '#' &&
//         grid[y-2][x+1] == '#' &&
//         grid[y-3][x] == '#' &&
//         grid[y-4][x] == '#'
//     ){
//         return 1;
//     }
//     return 0;
// }

int goF(char** grid, int x, int y){
    if(
        grid[y+1][x] == '#' &&
        grid[y+2][x] == '#' &&
        grid[y+2][x+1] == '#' &&
        grid[y+3][x] == '#' &&
        grid[y+4][x] == '#' &&
        grid[y+4][x+1] == '#' &&
        grid[y+4][x+2] == '#'
    ){
        return 1;
    }
    return 0;
}

// int goQ(char** grid, int x, int y){
//     if(
//         grid[y][x+1] == '#' &&
//         grid[y][x+2] == '#' &&
//         grid[y-1][x] == '#' &&
//         grid[y-1][x+2] == '#' &&
//         grid[y-2][x] == '#' &&
//         grid[y-2][x+1] == '#' &&
//         grid[y-2][x+2] == '#' &&
//         grid[y-3][x+2] == '#' &&
//         grid[y-4][x+2] == '#'
//     ){
//         return 1;
//     }
//     return 0;
// }

int goQ(char** grid, int x, int y){
    if(
        grid[y+1][x] == '#' &&
        grid[y+2][x] == '#' &&
        grid[y+2][x-1] == '#' &&
        grid[y+2][x-2] == '#' &&
        grid[y+3][x] == '#' &&
        grid[y+3][x-2] == '#' &&
        grid[y+4][x] == '#' &&
        grid[y+4][x-1] == '#' &&
        grid[y+4][x-2] == '#'
    ){
        return 1;
    }
    return 0;
}

// void removeF(char **grid, int x, int y){
//     grid[y][x+1] = '.';
//     grid[y][x+2] = '.';
//     grid[y-1][x] = '.';
//     grid[y-2][x] = '.';
//     grid[y-2][x+1] = '.';
//     grid[y-3][x] = '.';
//     grid[y-4][x] = '.';
// }

void removeF(char **grid, int x, int y){
    grid[y][x] = '.';
    grid[y+1][x] = '.';
    grid[y+2][x] = '.';
    grid[y+2][x+1] = '.';
    grid[y+3][x] = '.';
    grid[y+4][x] = '.';
    grid[y+4][x+1] = '.';
    grid[y+4][x+2] = '.';
}

// void removeQ(char **grid, int x, int y){
//     grid[y][x+1] = '.';
//     grid[y][x+2] = '.';
//     grid[y-1][x] = '.';
//     grid[y-1][x+2] = '.';
//     grid[y-2][x] = '.';
//     grid[y-2][x+1] = '.';
//     grid[y-2][x+2] = '.';
//     grid[y-3][x+2] = '.';
//     grid[y-4][x+2] = '.';
// }

void removeQ(char **grid, int x, int y){
    grid[y][x] = '.';
    grid[y+1][x] = '.';
    grid[y+2][x] = '.';
    grid[y+2][x-1] = '.';
    grid[y+2][x-2] = '.';
    grid[y+3][x] = '.';
    grid[y+3][x-2] = '.';
    grid[y+4][x] = '.';
    grid[y+4][x-1] = '.';
    grid[y+4][x-2] = '.';
}

int isGridClear(char** grid, int x, int y){
    for(int i = 0; i < y; i++){
        for(int j = 0; j < j < x; j++){
            if(grid[i][j] == '#') return 0;
        }
    }
    return 1;
}

int main(){

    int n, m;
    int fNum = 0, qNum = 0;

    cin >> n >> m;

    char **grid = new char*[n];
    for(int i = n - 1; i >= 0; i--) {
        grid[i] = new char[m];
    }

    char **grid2 = new char*[n];
    for(int i = n - 1; i >= 0; i--) {
        grid2[i] = new char[m];
    }

    for(int i = n - 1; i >= 0; i--){
        for(int j = 0; j < m; j++){
            cin >> grid[i][j];
            grid2[i][j] = grid[i][j];
        }
    }

    // vector<bool> decisions; // true for F || false for Q
    // vector<int> xCords;
    // vector<int> yCords;

    for(int y = 0; y < n; y++){
        for(int x = m - 1; x >= 0; x--){
            if(grid[y][x] == '#'){
                // if(goF(grid, x, y) && goQ(grid, x, y)){
                //     // decisions.push_back(true);
                //     // xCords.push_back(x);
                //     // yCords.push_back(y);
                //     removeF(grid, x, y);
                //     fNum++;
                // }

                if((x+2 < m) && goF(grid, x, y)){
                    removeF(grid, x, y);
                    fNum++;
                }
                else if((x-2 >= 0) && goQ(grid, x, y)){
                    removeQ(grid, x, y);
                    qNum++;
                }
            }
        }
    }

    // while(true){

    //     for(int i = n - 1; i >= 0; i--){
    //         for(int j = 0; j < m; j++){
    //             grid[i][j] = grid2[i][j];
    //         }
    //     }

    //     int h = 0;

    //     for(int y = n - 1; y >= 0; y--){
    //         for(int x = 0; x < m; x++){
    //             if(grid[y][x] == '#'){
    //                 if(goF(grid, x, y) && goQ(grid, x, y)){
                        
    //                 }
    //                 else if(goF(grid, x, y)){
    //                     removeF(grid, x, y);
    //                     fNum++;
    //                 }
    //                 else if(goQ(grid, x, y)){
    //                     removeQ(grid, x, y);
    //                     qNum++;
    //                 }
    //             }
    //         }
    //     }

    //     if(isGridClear(grid, m, n)) break;
    // }
    

    cout << qNum << ' ' << fNum << endl;

    return 0;
}