﻿// Author: russian_proger

#include <algorithm>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <fstream>
#include <functional>
#include <iomanip>
#include <iostream>
#include <list>
#include <numeric>
#include <map>
#include <queue>
#include <set>
#include <stack>
#include <string>
#include <tuple>
#include <utility>
#include <vector>


#define FOR(i, k) for (int i = 0; i < (k); ++i)
#define rep(i, j, k) for (int i = (j); i <= (k); ++i)
#define per(i, j, k) for (int i = (j); i >= (k); --i)

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
#define tiii tuple<int, int, int>
#define pii pair<int, int>
#define pll pair<ll, ll>
#define vi vector<int>
#define vll vector<ll>
#define vpii vector<pii>
#define maximize(a, b) a = max(a, b)
#define minimize(a, b) a = min(a, b)

using namespace std;

pll extgcd(ll m, ll c) {
	if (c == 0) return make_pair(1, 0);
	else {
		int p = m / c;
		pll q = extgcd(c, m % c);
		return make_pair(q.second, q.first - q.second * p);
	}
}

ll gcd(ll a, ll b) {
	while (b != 0) {
		a %= b;
		swap(a, b);
	}

	return a;
}

int main() {
	ll n, m, c;
	cin >> n >> m >> c;

	pll u = extgcd(m, c);
	ll d = gcd(m, c);
	ll d1 = n / d;

	if (n - d * d1 < d * (d1 + 1) - n) {
		cout << u.first * d1 << " " << u.second * d1;
	}
	else {
		cout << u.first * (d1 + 1) << " " << u.second * (d1 + 1);
	}
}