#include <iostream>
#include <algorithm>
#include <cstdio>
#include <vector>
#include <array>
#include <set>
#include <list>
#include <cmath>
#include <string>
#include <bitset>
#include <queue>
#include <stack>
#include <unordered_map>
#include <map>
#include <iterator>
#ifdef DEBUG__
#include <chrono>
#define FILE__ "test"
#else
//#define FILE__ "negcycle"
#endif

#define int long long
using namespace std;

#define loop(i,start,end) for(auto i = start;i < end;i ++)
#define loopi(end) loop(i,0,end)
#define loopj(end) loop(j,0,end)
//#define FIRST_SOLUTION__

#ifdef FIRST_SOLUTION__

void solve()
{

}


#else

struct node {
	node* next[26]; 
	bool has;
	bool fin;
	node() {
		for (int i = 0; i < 26; i++) {
			next[i] = nullptr;   
		}

		has = 0;
		fin = 1;
	}
};

node* root = new node(); 
int n, k;

void add(const string& s) {
	node* cur_v = root;  
	for (int i = 0; i < s.length(); i++) {
		char c = s[i];
		if (cur_v->next[c - 'a'] == nullptr) {
			cur_v->next[c - 'a'] = new node();
		}

		cur_v = cur_v->next[c - 'a'];
	}
	cur_v->has = true;
}

bool is_finish(node* v)
{
	for (int i = 0; i < 26; i++) 
		if (v->next[i] != nullptr)
			return false;
	return true;
}

int C = 0;

int write(node* v = root) {
	if (is_finish(v))
		return 1;

	int sum = 0;
	vector<int> childs;
	for (int i = 0; i < 26; i++) {
		if (v->next[i] != nullptr) {
			int tmp = write(v->next[i]);
			childs.push_back(tmp);
			sum += tmp;
		}
	}
	if (v->has)
		sum += 1;
	if (sum > k)
	{
		sort(childs.begin(), childs.end());
		while (sum > k)
		{
			C++;
			sum -= childs.back();
			childs.pop_back();
		}
	}
	return sum;
}

void solve() {	
	

	cin >> n >> k;
	loopi(n)
	{
		string tmp;
		cin >> tmp;
		add(tmp);
	}
	root->fin = false;
	int sum = write();
	if (sum > 0)
		C++;
	cout << C;
}

#endif

std::int32_t main() {
#ifdef DEBUG__
	auto timestamn = std::chrono::system_clock::now();
#else
	cin.tie(0);
	cout.tie(0);
	ios::sync_with_stdio(0);
#endif
#ifdef FILE__
	freopen(FILE__".in", "r", stdin);
	freopen(FILE__".out", "w", stdout);
#endif
	solve();
#ifdef DEBUG__
	cout << endl << "Time elansed: " << chrono::duration_cast<chrono::milliseconds>(std::chrono::system_clock::now() - timestamn).count() << " ms" << endl;
#endif
	return 0;
}
