#include <cmath>
#include <functional>
#include <iostream>
#include <fstream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <sstream>
#include <cassert>
#include <stack>
#include <list>
#include <deque>
#include <queue>
#include <unordered_map>
#include <unordered_set>
#include <sstream>
#include <iomanip>
#include <bitset>
#include <cstring>

using namespace std;

typedef long long ll;

const int N = 400;
const int M = 400;

int n, m;
bool mp[N][M], used[N][M];

bool find_f(int i, int j, bool vis) {
    vector<pair<int, int>> a = {{i, j}, {i, j + 1}, {i, j + 2},
                                {i + 1, j}, {i + 2, j}, {i + 3, j},
                                {i + 4, j}, {i + 2, j + 1}};
    if (vis) {
        for (auto [x, y] : a) {
            used[x][y] = true;
        }
    }
    for (auto [x, y] : a) {
        if (x < 0 || x >= n || y < 0 || y >= m) {
            return false;
        }
    }
    bool res = true;
    for (auto [x, y] : a) {
        if (!mp[x][y]) {
            res = false;
            break;
        }
    }
    return res;
}

bool find_q(int i, int j, bool vis) {
    vector<pair<int, int>> a = {{i, j}, {i, j + 1}, {i, j + 2},
                                {i + 1, j}, {i + 1, j + 2}, {i + 2, j},
                                {i + 2, j + 1}, {i + 2, j + 2}, {i + 3, j + 2}, 
                                {i + 4, j + 2}};
    if (vis) {
        for (auto [x, y] : a) {
            used[x][y] = true;
        }
    }
    for (auto [x, y] : a) {
        if (x < 0 || x >= n || y < 0 || y >= m) {
            return false;
        }
    }
    bool res = true;
    for (auto [x, y] : a) {
        if (!mp[x][y]) {
            res = false;
            break;
        }
    }
    return res;
}

int main() {
    freopen("a.in", "r", stdin);
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cin >> n >> m;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            char c;
            cin >> c;
            if (c == '#') {
                mp[i][j] = true;
            }
            used[i][j] = false;
        }
    }
    int f = 0, q = 0;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            bool ff = find_f(i, j, false);
            bool fq = find_q(i, j, false);
            if (ff && fq || ff) {
                ++f;
                find_f(i, j, true);
            } else if (fq) {
                ++q;
                find_q(i, j, true);
            }
        }
    }
    cout << q << " " << f << "\n";
}