import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.util.*;

public class Main {

    public static void main(String[] args) throws Exception {
        BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
        String[] numbers = br.readLine().split(" ");
        long n = Long.parseLong(numbers[0]);
        long wordsCount = n;
        long k = Long.parseLong(numbers[1]);
        if(n <= k) {
            System.out.println(1);
            return;
        }

        List<String> words = new ArrayList<>();
        List<String> wordsRemains = new ArrayList<>();
        int entries = 0;

        while(wordsCount != 0) {
            String word = br.readLine();
            words.add(word);
            wordsRemains.add(word);
            wordsCount--;
        }

        for(String word : words) {
            for(int i = 1; i < word.length(); i++) {
                String prefix = word.substring(0, i);
                int count = 0;

                for(String c : words) {
                    if(c.startsWith(prefix)) count++;
                }

                if(count != 1) {
                    if(count <= k) {
                        wordsRemains.removeIf(s -> s.startsWith(prefix));
                        entries++;
                    }
                }

                if(wordsRemains.size() <= k) {
                    System.out.println(++entries);
                    return;
                }
            }
        }

        n = wordsRemains.size();
        while (n > k) {
            n--;
            entries++;
        }

        System.out.println(++entries);
        br.close();
    }
}