#include <iostream>
#define MAX 300


bool getF(int map[MAX][MAX], int h, int w, int row, int col);
bool getQ(int map[MAX][MAX], int h, int w, int row, int col);



int main() {
    int h, w;

    std::cin >> h >> w;
    std::cin.ignore();

    int map[MAX][MAX];
    char row[w];

    for (int i = 0; i < h; i++) {
        std::cin.getline(row, w + 1);
        for (int j = 0; j < w; j++) {
            map[i][j] = (row[j] == '#' ? 1 : 0);
        }
    }


    // for (int i = 0; i < h; i++) {
    //     for (int j = 0; j < w; j++) {
    //         std::cout << map[i][j];
    //     }

    //     std::cout << std::endl;
    // }

    int Fs = 0, Qs = 0;
    for (int row = h - 1; row >= 0; row--) {
        for (int col = w - 1; col >= 0; col--) {
            if (map[row][col]) {
                if (getF(map, h, w, row, col))
                    Fs++;
                else {
                    getQ(map, h, w, row, col);
                    Qs++;
                }
            }
        }
    }
    std::cout << Qs << " " << Fs << std::endl;
}


bool getF(int map[MAX][MAX], int h, int w, int row, int col) {
    if (row < 4 || row >= h || col < 0 || col >= w - 2)
        return false;

    if (map[row - 2][col + 1] == 0)
        return false;

    for (int i = 0; i < 5; i++)
        if (map[row - i][col] == 0)
            return false;
    
    for (int i = 0; i < 3; i++)
        if (map[row - 4][col + i] == 0)
            return false;
    
    map[row - 2][col + 1] = 0;
    for (int i = 0; i < 5; i++)
        map[row - i][col] = 0;
    for (int i = 0; i < 3; i++)
        map[row - 4][col + i] = 0;

    return true;
}


bool getQ(int map[MAX][MAX], int h, int w, int row, int col) {
    // No tests needed

    // if (row < 4 || row >= h || col < 2 || col >= w)
    //     return false;

    // for (int i = 0; i < 5; i++)
    //     if (map[row - i][col] == 0)
    //         return false;
    
    // for (int i = 0; i < 3; i++)
    //     if (map[row - 2 - i][col - 2] == 0)
    //         return false;

    // if (map[row - 2][col - 1] == 0 || map[row - 4][col - 1] == 0)
    //     return false;


    map[row - 2][col - 1] = 0;
    map[row - 4][col - 1] = 0;    

    for (int i = 0; i < 5; i++)
        map[row - i][col] = 0;
    
    for (int i = 0; i < 3; i++)
        map[row - 2 - i][col - 2] = 0;
 
    return true;
}