package com.company;
import java.util.ArrayList;
import java.util.Scanner;

public class Main {

    public static Scanner sc = new Scanner(System.in);

    public static void main(String[] args) {

        long t = sc.nextLong();
        check(t);

        ArrayList<Long> list = new ArrayList<>();

        while (t >= 1) {
            long n = sc.nextInt();
            if (n >= 2 && n <= Math.pow(10, 18)) {

                for (long i = 1; i <= n - 1; i++) {
                    if (coPrime(i, n) == 1)
                        list.add(i);
                }

                System.out.println(list.size() % 2 == 0 ?
                        list.get((list.size() / 2) - 1):
                        list.get((list.size() - 1) / 2) );

                list.clear();
                --t;
            }
        }
    }

    public static void check(long l){
        if (l<1 || l>1000 ){
            l = sc.nextLong();
            check(l);
        }
    }

    public static long coPrime(long index, long currentNum) {
        if (index == 0 || currentNum == 0)
            return 0;

        if (index == currentNum)
            return index;

        if (index > currentNum)
            return coPrime(index - currentNum, currentNum);

        return coPrime(index, currentNum - index);
    }

}