#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

#define x first
#define y second

ll n, m, s = 0, f;
vector<vector<pair<ll, ll>>> graph;
map<pair<ll, ll>, ll> edges;
const ll INF = 1e18;


void dijkstra() {
    vector<ll> d(n, INF);
    vector<vector<ll>> p(n);
    vector<pair<ll, ll>> kekes(n, {INF, -1});
    d[s] = 0;
    set<pair<ll, ll> > q;
    q.insert(make_pair(d[s], s));

    while (!q.empty()) {
        ll v = q.begin()->second;
        q.erase(q.begin());

        for (size_t j = 0; j < graph[v].size(); ++j) {
            ll to = graph[v][j].first;
            ll len = 1;

            if (d[v] + len < d[to]) {
                q.erase(make_pair(d[to], to));
                d[to] = d[v] + len;
                kekes[to] = {min(kekes[v].first, len), max(kekes[v].second, len)};
                p[to] = {v};
                q.insert(make_pair(d[to], to));
            } else if (d[v] + len == d[to]) {
                p[to].push_back(v);
            }
        }
    }

    cout << d[f] << '\n';
    vector<ll> path;
    ll t = f;
    pair<ll, ll> left_road = {INF, -1};
    vector<ll> answer;

    while (true) {
        answer.push_back(t);
        unordered_map<ll, pair<ll, ll>> cur_answers;
        for (auto i : p[t]) {
            pair<ll, ll> current_left_road = {min(left_road.x, edges[{i, t}]), max(left_road.y, edges[{i, t}])};
            cur_answers[i] = {min(kekes[i].x, current_left_road.x), max(kekes[i].y, current_left_road.y)};
        }

        ll vertex = p[t].front();
        ll mx = kekes[vertex].y - kekes[vertex].x;
        for (auto i : cur_answers) {
            if (i.y.y - i.y.x > mx) {
                vertex = i.x;
                mx = i.y.y - i.y.x;
                left_road = {i.y.x, i.y.y};
            }
        }
//        cout << vertex + 1 << " " << mx << '\n';

        t = vertex;
        if (p[t].empty()) {
            break;
        }
    }

    cout << 1 << " ";
    reverse(answer.begin(), answer.end());
    for (auto i : answer) {
        cout << i + 1 << " ";
    }

}



int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    cin >> n >> m;

    graph.resize(n);

    f = n - 1;


    for (int i = 0; i < m; ++i) {
        ll a, b, c;
        cin >> a >> b >> c;
        a--;
        b--;
        graph[a].push_back({b, c});
        graph[b].push_back({a, c});

        edges[{a, b}] = c;
        edges[{b, a}] = c;
    }

    dijkstra();



    return 0;
}