#define _CRT_SECURE_NO_WARNINGS
#define All(x) x.begin(), x.end()
#define ln '\n'
#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <assert.h>
#include <set>
#include <fstream>
#include <map>
#include <string>
#include <conio.h>
using namespace std;
typedef long long ll;
typedef unsigned long long ull;

class String
{
public:
	static vector<ll> Z_foo(string& s)
	{
		ll n = s.size();
		vector<ll> res(n);
		res[0] = n;
		for (ll i = 1, l = 0, r = 0; i < n; i++)
		{
			if (i <= r)
				res[i] = min(r - i + 1, res[i - l]);
			while (i + res[i] < n && s[res[i]] == s[i + res[i]])
				res[i]++;
			if (i + res[i] - 1 > r)
			{
				l = i;
				r = i + res[i] - 1;
			}
		}
		return res;
	}
	template <typename T>
	static vector<ll> Z_foo(vector<T>& s)
	{
		ll n = s.size();
		vector<ll> res(n);
		res[0] = n;
		for (ll i = 1, l = 0, r = 0; i < n; i++)
		{
			if (i <= r)
				res[i] = min(r - i + 1, res[i - l]);
			while (i + res[i] < n && s[res[i]] == s[i + res[i]])
				res[i]++;
			if (i + res[i] - 1 > r)
			{
				l = i;
				r = i + res[i] - 1;
			}
		}
		return res;
	}

	static vector<ll> PI_foo(string& s)
	{
		ll n = s.size();
		vector<ll> res(n);
		res[0] = 0;
		for (ll i = 1; i < n; i++)
		{
			ll j = res[i - 1];
			while (j > 0 && s[i] != s[j])
				j = res[j - 1];
			if (s[i] == s[j])
				j++;
			res[i] = j;
		}
		return res;
	}
	template<typename T>
	static vector<ll> PI_foo(vector<T>& s)
	{
		ll n = s.size();
		vector<ll> res(n);
		res[0] = 0;
		for (ll i = 1; i < n; i++)
		{
			ll j = res[i - 1];
			while (j > 0 && s[i] != s[j])
				j = res[j - 1];
			if (s[i] == s[j])
				j++;
			res[i] = j;
		}
		return res;
	}
};

class Math
{
public:
	static long long gcd(ll a, ll b)
	{
		return b ? gcd(b, a % b) : a;
	}
	static long long fast_pow(ll a, ll n)
	{
		if (n == 0)
			return 1;
		if (n == 1)
			return a;
		ll res = fast_pow(a, n / 2);
		res *= res;
		if (n % 2 == 0)
			return res;
		return res * a;
	}
};
void ask()
{

	cout.flush();
}

void answer()
{

	cout.flush();
}

void solve()
{

}

int main()
{
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	string s1, s2;
	string t1, t2;
	ll mn, mx;
	/*if (s1[0] == 'A')
	{
		mx = stoi(s2);
	}
	else
		if (s1[0] == 'B')
		{
			mn = stoi(s2);
		}
		else
			if (s2[0] == 'A')
			{
				mx = stoi(s1);
			}
			else
				if (s2[0] == 'B')
				{
					mn = stoi(s1);
				}
	cin >> t1 >> t2;
	if (t1[0] == 'A')
	{
		mx = stoi(t2);
	}
	else
		if (t1[0] == 'B')
		{
			mn = stoi(t2);
		}
		else
			if (t2[0] == 'A')
			{
				mx = stoi(t1);
			}
			else
				if (t2[0] == 'B')
				{
					mn = stoi(t1);
				}*/
	vector<string>F, S;
	cin >> s1 >> s2;
	cin >> t1 >> t2;
	F.push_back(s1);
	F.push_back(s2);
	S.push_back(t1);
	S.push_back(t2);
	sort(All(F));
	sort(All(S));
	if (F[1][0] == 'A' && S[1][0] == 'A')
	{
		cout << abs(stoi(F[0]) - stoi(S[0]));
		return 0;
	}
	if (F[1][0] == 'B' && S[1][0] == 'B')
	{
		cout << abs(stoi(F[0]) - stoi(S[0]));
		return 0;
	}
	cout << abs(stoi(F[0]) + stoi(S[0]) - 1);
}