#define _CRT_SECURE_NO_WARNINGS
#define All(x) x.begin(), x.end()
#define ln '\n'
#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <assert.h>
#include <set>
#include <fstream>
#include <map>
#include <string>
#include <conio.h>
#include <queue>
using namespace std;
typedef long long ll;
typedef unsigned long long ull;

class String
{
public:
	static vector<ll> Z_foo(string& s)
	{
		ll n = s.size();
		vector<ll> res(n);
		res[0] = n;
		for (ll i = 1, l = 0, r = 0; i < n; i++)
		{
			if (i <= r)
				res[i] = min(r - i + 1, res[i - l]);
			while (i + res[i] < n && s[res[i]] == s[i + res[i]])
				res[i]++;
			if (i + res[i] - 1 > r)
			{
				l = i;
				r = i + res[i] - 1;
			}
		}
		return res;
	}
	template <typename T>
	static vector<ll> Z_foo(vector<T>& s)
	{
		ll n = s.size();
		vector<ll> res(n);
		res[0] = n;
		for (ll i = 1, l = 0, r = 0; i < n; i++)
		{
			if (i <= r)
				res[i] = min(r - i + 1, res[i - l]);
			while (i + res[i] < n && s[res[i]] == s[i + res[i]])
				res[i]++;
			if (i + res[i] - 1 > r)
			{
				l = i;
				r = i + res[i] - 1;
			}
		}
		return res;
	}

	static vector<ll> PI_foo(string& s)
	{
		ll n = s.size();
		vector<ll> res(n);
		res[0] = 0;
		for (ll i = 1; i < n; i++)
		{
			ll j = res[i - 1];
			while (j > 0 && s[i] != s[j])
				j = res[j - 1];
			if (s[i] == s[j])
				j++;
			res[i] = j;
		}
		return res;
	}
	template<typename T>
	static vector<ll> PI_foo(vector<T>& s)
	{
		ll n = s.size();
		vector<ll> res(n);
		res[0] = 0;
		for (ll i = 1; i < n; i++)
		{
			ll j = res[i - 1];
			while (j > 0 && s[i] != s[j])
				j = res[j - 1];
			if (s[i] == s[j])
				j++;
			res[i] = j;
		}
		return res;
	}
};

class Math
{
public:
	static long long gcd(ll a, ll b)
	{
		return b ? gcd(b, a % b) : a;
	}
	static long long fast_pow(ll a, ll n)
	{
		if (n == 0)
			return 1;
		if (n == 1)
			return a;
		ll res = fast_pow(a, n / 2);
		res *= res;
		if (n % 2 == 0)
			return res;
		return res * a;
	}
};
void ask()
{

	cout.flush();
}

void answer()
{

	cout.flush();
}



struct node
{
	node* child[27];
	node* parent;
	ll val = 0;
	ll level = 0;
};

ll mx = -1e18;
ll perv = 1e18;
node* found;
ll ans = 0;
void rec(node* v, ll& x, ll j = 0)
{
	if (v->val <= x && v->val >= mx)
	{
		mx = v->val;
		found = v;
		node* t = found;
		ll w = v->val;
		return;
	}
	for (int i = 0; i <= 25; i++)
	{
		if (v->child[i] != nullptr)
			rec(v->child[i], x, j + 1);
	}
	return;
}

int main()
{
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	ll n, k;
	cin >> n >> k;
	vector<string>s(n);
	map<string, ll>m;
	node* root = new node;
	root->val = 0;
	for (int i = 0; i <= 25; i++)
	{
		root->child[i] = nullptr;
	}
	root->parent = nullptr;
	for (int i = 0; i < n; i++)
	{
		cin >> s[i];
		string q = "";
		ll next = s[i][0] - 'a';
		if (root->child[next] == nullptr)
		{
			root->child[next] = new node;
			root->child[next]->level = 1;
			root->child[next]->parent = root;
			for (int i = 0; i <= 25; i++)
			{
				root->child[next]->child[i] = nullptr;
			}

		}
		//root->child[next]->val++;
		node* start = root->child[next];
		for (int t = 1; t < s[i].size(); t++)
		{
			if (start->child[s[i][t] - 'a'] != nullptr)
			{
				start = start->child[s[i][t] - 'a'];
				//start->val++;
			}
			else
			{
				start->child[s[i][t] - 'a'] = new node;
				start->child[s[i][t] - 'a']->level = start->level + 1;
				start->child[s[i][t] - 'a']->parent = start;
				start = start->child[s[i][t] - 'a'];
				//start->val++;
				for (int i = 0; i <= 25; i++)
				{
					start->child[i] = nullptr;
				}
			}
		}
		start->val++;
		while (start->parent != nullptr)
		{
			start->parent->val++;
			start = start->parent;
		}
	}
	ans = 0;
		ll local_mx = -1e18;
		vector<ll>por;
		for (int i = 0; i <= 25; i++)
		{
			if (root->child[i] != nullptr)
			{
				por.push_back(root->child[i]->val);
			}
		}
		sort(All(por));
		for (int j = por.size() - 1; j >=0; j--)
		{
			if (root->val <= k)
			{
				if (root->val == 0)
				{
					cout << ans << ln;
					return 0;
				}
				cout << ans + 1 << ln;
				return 0;
			}
			for (int i = 0; i <= 25; i++)
			{
				if (root->val <= k)
				{
					if (root->val == 0)
					{
						cout << ans << ln;
						return 0;
					}
					cout << ans + 1 << ln;
					return 0;
				}
				if (root->child[i] != nullptr)
				{
					if (root->child[i]->val == por[j])
					{
						while (root->child[i]->val > k)
						{
							mx = -1e18;
							rec(root->child[i], k, 1);
							ans++;
							ll w = found->val;
							n -= w;
							while (found->parent != nullptr)
							{
								found->val -= w;
								found = found->parent;
							}
							root->val -= w;
							if (root->val <= k)
							{
								if (root->val == 0)
								{
									cout << ans << ln;
									return 0;
								}
								cout << ans + 1 << ln;
								return 0;
							}
						}
						if (n != 0)
						{
							ans++;
							n -= root->child[i]->val;
							root->val -= root->child[i]->val;
							root->child[i]->val = 0;
							if (root->val <= k)
							{
								if (root->val == 0)
								{
									cout << ans << ln;
									return 0;
								}
								cout << ans + 1 << ln;
								return 0;
							}
						}
					}
				}
			}
		}
		if (n != 0)
			cout << ans + 1 << ln;
		else
			cout << ans << ln;
}
/*
10 4
a aa aaa aaaa aaaaa ab ac ad ae bebra
9 4
mem muma dad mom kostya ci cringe moma mema
 
9 4
mem mema muma moma mom dad kostya ci cringe
*/