#include<iostream>
#include<vector>
#include<string>
#include<algorithm>
#include<cmath>
#include<set>
#include<map>
#include<deque>
#include<iomanip>
#include<limits>
#include<stack>
#include<deque>
#include<queue>
#define mp make_pair
using namespace std;
typedef long long ll;
typedef unsigned long long ull;
typedef pair<int, int> pii;
const ll INF = numeric_limits<int>::max();
const ll MOD = 1e9 + 7;

string s;
int ans = 0, m;

struct node {
	int total, offset;
	node* p;
	vector<node*> links;

	node(node* _p) {
		total = 0;
		offset = 0;
		p = _p;
		links = vector<node*>(26, nullptr);
	}

	void addword(int i) {
		if (s.length() != i) {
			if (links[s[i] - 'a'] == nullptr) {
				links[s[i] - 'a'] = new node(this);
			}
			links[s[i] - 'a']->addword(i + 1);
		}
		total++;
	}

	void cleanup(int overflow) {
		while (total - offset > m) {
			int maxt = -1, imax;
			for (int i = 0; i < 26; i++) {
				if (links[i] != nullptr && links[i]->total > maxt) {
					maxt = links[i]->total;
					imax = i;
				}
			}
			links[imax]->cleanup(total - offset - maxt);
			int z = 0;
		}
		if (overflow + total - offset <= m) {
			int z = 0;
			if (p != nullptr) {
				p->offset += offset;
			}
		}
		else {
			ans++;
			if (p != nullptr) {
				p->offset += total;
				total = 0;
			}
		}
	}
};

vector<vector<char>> q = { {'#', '#', '#'}, {'#', '.', '#'}, {'#', '#', '#'}, {'.', '.', '#'}, {'.', '.', '#'} };
vector<vector<char>> f = { {'#', '#', '#'}, {'#', '.', '.'}, {'#', '#', '.'}, {'#', '.', '.'}, {'#', '.', '.'} };

void out(vector<vector<char>> v) {
	for (int i = 0; i < v.size(); i++) {
		for (char c : v[i])
			cout << c;
		cout << '\n';
	}
	cout << '\n';
}

int main()
{
	cin.tie(0);
	ios_base::sync_with_stdio(0);
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
#ifndef _DEBUG
	//freopen("equivalence.in", "r", stdin);
	//freopen("equivalence.out", "w", stdout);
#endif

	ll n, m, qans = 0, fans = 0;
	cin >> n >> m;
	vector<vector<char>> a = vector<vector<char>>(n, vector<char>(m));

	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			cin >> a[i][j];
		}
	}

	//out(a);

	for (int i = 0; i < n - 4; i++) {
		for (int j = 0; j < m - 2; j++) {
			bool isq = true, isf = true;
			for (int k = 0; k < 5; k++) {
				for (int l = 0; l < 3; l++) {
					if (q[k][l] == '#' && a[i + k][j + l] != q[k][l]) {
						isq = false;
					}
					if (f[k][l] == '#' && a[i + k][j + l] != f[k][l]) {
						isf = false;
					}
				}
			}
			if (isf) {
				fans++;
				for (int k = 0; k < 5; k++) {
					for (int l = 0; l < 3; l++) {
						if (f[k][l] == '#') {
							a[i + k][j + l] = '.';
						}
					}
				}
				//out(a);
			}
			else if (isq) {
				qans++;
				for (int k = 0; k < 5; k++) {
					for (int l = 0; l < 3; l++) {
						if (q[k][l] == '#') {
							a[i + k][j + l] = '.';
						}
					}
				}
				//out(a);
			}
		}
	}

	cout << qans << ' ' << fans;
}