#include<iostream>
#include<string>
#include<vector>
#include<stack>
#include<set>
#include<map>
#include<iomanip>
#include<algorithm>
#include<random>
#include<time.h>
#include<chrono>
#include<math.h> 
using namespace std;

//mt19937 g(chrono::system_clock::now().time_since_epoch().count());
long long gcd(long long a, long long b) {
	while (b) {
		a %= b;
		swap(a, b);
	}
	return a;
}
long long phi(long long n) {
	long long result = n;
	for (long long i = 2; i * i <= n; ++i)
		if (n % i == 0) {
			while (n % i == 0)
				n /= i;
			result -= result / i;
		}
	if (n > 1)
		result -= result / n;
	return result;
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	int t;
	cin >> t;
	for (int i = 0; i < t; ++i)
	{
		long long n;
		cin >> n;
		long long cnt = phi(n);
		if (cnt == n - 1)
		{
			if (cnt % 2)
			{
				cout << (cnt+1) / 2 << endl;
			}
			else
			{
				cout << cnt / 2 << endl;
			}
		}
		else
		{
			long long amnt = cnt % 2 ? (cnt + 1) / 2 : cnt / 2;
			int cur = 1;
			long long ans = 1;
			for (int i = 2; ; ++i)
			{
				if (gcd(n, i) == 1)
				{
					cur += 1;
				}
				if (cur == amnt)
				{
					ans = i;
					break;
				}
			}
			cout << ans << endl;
		}
	}

}

/*
###..###..
#.#..#.###
###..###..
..#..#.##.
..#..#.#..
.......#..

*/