#define _CRT_SECURE_NO_WARNINGS

#pragma comment(linker, "/stack:200000000")
//#pragma GCC optimize(/*"Ofast",*/"O3","omit-frame-pointer")
//#pragma GCC target("sse","sse2",/*"sse3","ssse3","sse4","popcnt"*/,"abm",/*"mmx","avx",*/"tune=native","arch=native"")

#include <stdio.h>
#include <string.h>
#include <memory.h>
#include <stdlib.h>
#include <iostream>
#include <time.h>
#include <algorithm>
#include <math.h>
#include <numeric>
#include <vector>
#include <set>
#include <queue>
#include <stack>
#include <bitset>
#include <string>
#include <cstring>
#include <cassert>
#include <fstream>
#include <map>
#include <unordered_map>
#include <deque>
#include <unordered_set>
#include <functional>

using namespace std;


typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

class from {
public:
    int mi = -1;
    int ma = -1;
    int fr = -1;
    int last = -1;
};

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin.sync_with_stdio(0);
    cout.sync_with_stdio(0);
    srand(time(0));
    cout.precision(10);
    int n, m;
    cin >> n >> m;
    vector<vector<pair<int, int>>> ways(n, vector<pair<int, int>>());
    vector<pair<from, from>> good(n);
    vector<int> vis(n);
    int ans = -1;
    int fff = -1;
    for (int i = 0; i < m; i++) {
        int x, y, v;
        cin >> x >> y >> v;
        --x;
        --y;
        ways[x].emplace_back(v, y);
        ways[y].emplace_back(v, x);
    }
    int ll = 0;
    queue<pair<int, int>> q;
    q.push({0, 0});
    vis[0] = -1;
    while (!q.empty()) {
        int cur = q.front().first;
        int cur2 = q.front().second;
        q.pop();
        for (auto v: ways[cur]) {
            if (vis[v.second] < cur2 + 1 && vis[v.second] != 0) continue;
            from f1 = good[cur].first;
            from f2 = good[cur].second;
            f1.last = v.first;
            f2.last = v.first;
            if (f1.mi == -1)
                f1.mi = v.first;
            else
                f1.mi = min(f1.mi, v.first);

            if (f1.ma == -1)
                f1.ma = v.first;
            else
                f1.ma = max(f1.ma, v.first);

            if (f2.mi == -1)
                f2.mi = v.first;
            else
                f2.mi = min(f2.mi, v.first);

            if (f2.ma == -1)
                f2.ma = v.first;
            else
                f2.ma = max(f2.ma, v.first);
            if (v.second == n - 1) {
                if (f1.ma - f1.mi > ans) {
                    ans = f1.ma - f1.mi;
                    fff = cur;
                    ll = f1.last;
                }
                if (f2.ma - f2.mi > ans) {
                    ans = f2.ma  - f2.mi;
                    ll = f2.last;
                    fff = cur;
                }
            }
            from &ff = good[v.second].first;
            if (ff.fr == -1 || ff.mi > f1.mi) {
                ff.mi = f1.mi;
                ff.ma = f1.ma;
                ff.fr = cur;
                ff.last = f1.last;
            }
            from &ff2 = good[v.second].second;
            if (ff2.fr == -1 || ff2.ma < f2.ma) {
                ff2.mi = f2.mi;
                ff2.ma = f2.ma;
                ff2.fr = cur;
                ff2.last = f2.last;
            }
            if (vis[v.second] == 0) {
                q.push({v.second, cur2 + 1});
                vis[v.second] =  cur2 + 1;
            }
        }
    }
    int lma = ll;
    int lmi = ll;
    int c = fff;
    vector<int> an;
    an.push_back(fff + 1);
    while (c != 0) {
        if (lma - good[c].first.mi == ans) {
            lmi = min(lmi, good[c].first.last);
            lma = max(lma, good[c].first.last);
            c = good[c].first.fr;
            an.push_back(c + 1);
        } else {
            lmi = min(lmi, good[c].second.last);
            lma = max(lma, good[c].second.last);
            c = good[c].second.fr;
            an.push_back(c + 1);
        }
    }
    std::reverse(an.begin(), an.end());
    cout << an.size() << "\n";
    for (auto i : an) {
        cout << i << " ";
    }
    cout << n;
}