import java.io.*;
import java.util.*;
import java.util.stream.Collectors;

import static java.lang.System.out;

public class App {
    public static void main(String[] args) throws IOException {
        long n = readInt();
        long m = readInt();
        long c = readInt();

        if (n % m == 0) {
            out.printf("%d %d", n/m, 0);
            return;
        }

        if (n % c == 0) {
            out.printf("%d %d", 0, n/c);
            return;
        }

        long mini = n;
        long minM = Integer.MAX_VALUE;
        long minC = Integer.MAX_VALUE;
        long newMini = Integer.MAX_VALUE;

        for (int i = 0; i <= n / m; i++) {
            for (int j = (int) (n / c); j >= 0; j--) {
                if (i == 0 && j == 0) {
                    continue;
                }

                long prevMin = newMini;
                newMini = Math.abs(i * m + j * c - n);

                if (newMini > prevMin) {
                    newMini = Integer.MAX_VALUE;
                    break;
                }

//                out.printf("%d %d %d %n", newMini, i, j);
                if (newMini < mini) {
                    mini = newMini;
                    minM = i;
                    minC = j;
                }
            }
        }

        out.printf("%d %d", minM == Integer.MAX_VALUE ? 0 : minM, minC == Integer.MAX_VALUE ? 0 : minC);
    }

    static BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
    static StringTokenizer st = new StringTokenizer("");
    static String read() throws IOException{
        while (!st.hasMoreElements()) st = new StringTokenizer(br.readLine());
        return st.nextToken();
    }
    public static int readInt() throws IOException{return Integer.parseInt(read());}
    public static long readLong() throws IOException{return Long.parseLong(read());}
    public static double readDouble() throws IOException{return Double.parseDouble(read());}
    public static float readFloat() throws IOException{return Float.parseFloat(read());}
}