﻿using System;
using System.Linq;

namespace Contest
{
    class Contest
    {
        private static void Main()
        {
            var n = long.Parse(Console.ReadLine());
            var m = long.Parse(Console.ReadLine());
            var c = long.Parse(Console.ReadLine());
            var bestDistance = long.MaxValue;
            var result =  new long[2];

            for (long mCap = 0; mCap <= n / m; mCap++)
            {
                var cCap = (double)(n - mCap * m) / c;
                if (cCap < 0)
                    continue;
                
                var floorCCap = (long)Math.Floor(cCap);
                var ceilCCap = (long)Math.Ceiling(cCap);
                var calculations = new long[] { Math.Abs(mCap * m + floorCCap * c - n), Math.Abs(mCap * m + ceilCCap * c - n) }.Select((value, isCeil) => (isCeil, value)).ToArray();
                var resultPair = calculations.MinBy(tuple => tuple.value);
                
                if (resultPair.value >= bestDistance) continue;
                
                bestDistance = resultPair.value;
                result[0] = mCap;
                result[1] = resultPair.isCeil == 0 ? floorCCap : ceilCCap;
            }
            Console.WriteLine(string.Join(" ", result));
        }
    }
}
