#define _USE_MATH_DEFINES
#include<iostream>
#include<fstream>
#include <sstream>
#include<string>
#include<vector>
#include<utility>
#include<algorithm>
#include<climits>
#include<set>
#include<map>
#include<cmath>
#include<iomanip>
#include<iterator>
#include<queue>
#include<deque>
#include<stack>
#include<cctype>
#include<deque>
#include<time.h>
#include<bitset>
#include<random>
#include<unordered_set>
#include<unordered_map>
#include<sstream>
#include<random>
#include<numeric>
#include <cstring>

#define en "\n"
#define for0(i, n) for(int i = 0; i < n; i++)
#define all(x) (x).begin(), (x).end()
#define allr(x) (x).rbegin(), (x).rend()
#define pb push_back
#define pii pair<int, int>
#pragma warning(disable : 4996)
typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

using namespace std;


template<typename T> void print(vector<T>& a)
{
	for (int i = 0; i < a.size(); i++)
		cout << a[i] << ' ';
	cout << en;
}

template<typename T> void print(deque<T>& a)
{
	for (int i = 0; i < a.size(); i++)
		cout << a[i] << ' ';
	cout << en;
}

template<typename T> void print(vector<vector<T>>& a)
{
	for (int i = 0; i < a.size(); i++)
	{
		for (int j = 0; j < a[i].size(); j++)
			cout << a[i][j];
		cout << en;
	}
}

template <typename T> void input(vector<T>& a)
{
	for (int i = 0; i < a.size(); i++)
		cin >> a[i];
}

template<typename T> void input(deque<T>& a)
{
	for (int i = 0; i < a.size(); i++)
		cin >> a[i];
}

template<typename T> void input(vector<vector<T>>& a)
{
	for (int i = 0; i < a.size(); i++)
		for (int j = 0; j < a[i].size(); j++)
			cin >> a[i][j];
}

const ll INF = 1e8 + 5;
//const ll MOD = 1e9 + 7;
const int NMAX = 1e5 + 17;
double eps = 0.0000001;

ll C(ll n, ll k) {
	ll a = 1;
	for (ll i = k + 1; i <= n; i++) a *= i;
	ll b = 1;
	for (ll i = 1; i <= n - k; i++) b *= i;
	return a / b;
}

ll fact(ll n) {
	ll res = 1;
	for (ll i = 2; i <= n; i++) res *= i;
	return res;
}

bool comp(pair<pair<ll, ll>, ll> a, pair<pair<ll, ll>, ll> b) {
	return a.first.second < b.first.second;
}

ll gcd(ll a, ll b) {
	if (b) {
		return gcd(b, a % b);
	}
	return a;
}


struct bor_node {

	bor_node* next[26];
	int cnt;
	int cnt_subtree[26];
	int sum_cnt_subtree;
	bool leaf;


	priority_queue<pair<int, int>, vector<pair<int, int>>, less<pair<int,int>>> pq;

	bor_node() {
		for (int i = 0; i < 26; i++) {
			next[i] = NULL;
			cnt_subtree[i] = 0;
		}
		cnt = 0;
		leaf = true;
		sum_cnt_subtree = 0;
	}

	void add(string& s, int i, bool new_leaf) {
		if (i == s.length()) {
			cnt++;
			this->leaf = new_leaf;
			return;
		}

		if (next[s[i] - 'a'] == NULL) {
			next[s[i] - 'a'] = new bor_node;
			new_leaf = true;
		}
		cnt_subtree[s[i] - 'a']++;
		sum_cnt_subtree++;
		next[s[i] - 'a']->add(s, i + 1, new_leaf);

		leaf = false;
	}

	void add(string s) {
		add(s, 0, false);
		//cout << "added " << s << endl;
	}

	void print_lex(string cur) {
		if (cnt != 0) {
			for (int i = 0; i < cnt; i++) {
				cout << cur << endl;
			}
		}

		for (int i = 0; i < 26; i++) {
			if (next[i] != NULL)
				next[i]->print_lex(cur + char('a' + i));
		}

	}

	void print_lex() {
		cout << "-------" << endl;
		print_lex("");
		cout << endl << "-------" << endl;
	}

	void k_lex(string& s, int cur_cnt, int k) {
		if (cnt != 0) {
			cur_cnt += cnt;
			if (cur_cnt >= k) {
				cout << s << endl;
				return;
			}
		}
		for (int i = 0; i < 26; i++) {
			if (next[i] != NULL) {
				if (cur_cnt + cnt_subtree[i] >= k) {
					s += char('a' + i);
					next[i]->k_lex(s, cur_cnt, k);
					break;
				}
				else
					cur_cnt += cnt_subtree[i];
			}
		}
	}

	void k_lex(int k) {
		string s = "";
		k_lex(s, 0, k);
	}

	bool find(string& s, int i) {
		if (i == s.length() && cnt > 0)
			return true;


		if (next[s[i] - 'a'] == NULL)
			return false;

		next[s[i] - 'a']->find(s, i + 1);
	}

	bool find(string s) {
		return find(s, 0);
	}

	bool del(string& s, int i) {

		if (i < s.length() && next[s[i] - 'a'] == NULL) {
			return false;
		}

		if (i == s.length()) {

			if (cnt > 0) cnt--;

			return cnt == 0 && leaf;
		}
		cnt_subtree[s[i] - 'a']--;
		sum_cnt_subtree--;
		bool to_delete = next[s[i] - 'a']->del(s, i + 1);

		if (to_delete) {
			delete next[s[i] - 'a'];
			next[s[i] - 'a'] = NULL;

			if (sum_cnt_subtree > 0) {
				leaf = true;
				return false;
			}
			else {
				return true;
			}

		}

		return false;

	}

	void del(string s) {
		del(s, 0);
	}

};

int n, k;

pair<int,int> dfs(bor_node* p, bor_node* prev) {
	if (p->sum_cnt_subtree+ p->cnt <= k) {
		return { 1, 0 };
	}
	int res = 0;
	while(!p->pq.empty()) {
		pair<int, int> tp = p->pq.top();
		p->pq.pop();
		pair<int,int> kek = dfs(p->next[tp.second], p);
		res += kek.first;
		p->sum_cnt_subtree -= p->cnt_subtree[tp.second];
		p->sum_cnt_subtree += kek.second;
		if (p->sum_cnt_subtree + p->cnt <= k) {
			
			if (prev == NULL) {
				return { res + 1,0 };
			}
			
			if (prev->sum_cnt_subtree - p->cnt - p->sum_cnt_subtree <= k) {
				return { res , p->sum_cnt_subtree };
			}
			else {
				return { res + 1, p->sum_cnt_subtree };
			}
		}

	}
	return { res + p->cnt, 0 };
}

void dfs0(bor_node* p) {
	if (p == NULL) return;
	for (int i = 0; i < 26; i++) {
		if (p->next[i] != NULL) {
			p->pq.push({ p->cnt_subtree[i], i });
			dfs0(p->next[i]);
		}
	}
}

void solve() {
	bor_node bor;
	
	cin >> n >> k;
	for (int i = 0; i < n; i++) {
		string s;
		cin >> s;
		bor.add(s);
	}
	dfs0(&bor);
	cout << dfs(&bor, NULL).first;

}
int main() {
	srand(time(0));
	ios::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	int t = 1;
	//cin >> t;-----
	while (t--) {

		solve();

	}
}