﻿using System;

namespace ICPC_11._12._21__CSharp_
{
    class Program
    {

        static void Main(string[] args)
        {
            string[] S = Console.ReadLine().Split();
            int n = Int32.Parse(S[0]);
            int m = Int32.Parse(S[1]);
            string In;

            int nF = 0, nQ = 0;

            bool[,] G = new bool[n, m];


            for (int i = 0; i < n; i++)
            {
                In = Console.ReadLine();
                for (int j = 0; j < m; j++)
                    if (In[j] == '#') G[i, j] = true;
                    else G[i, j] = false;
            }

            for (int i = 0; i < n-4; i++)
            {
                for (int j = 0; j < m-2; j++)
                {
                    if (checkF(G, i, j))
                    {
                        nF += 1;
                        continue;
                    }
                    if (checkQ(G, i, j)) nQ += 1;
                }
            }

            Console.WriteLine(nQ + " " + nF);



            //for (int i = 0; i < n; i++)
            //{
            //    for (int j = 0; j < m; j++) Console.Write(G[i, j]);
            //    Console.WriteLine();
            //}


        }

        static bool checkQ(bool[,] G, int i, int j)
        {
            if (G[i, j] && G[i, j + 1] && G[i, j + 2] && G[i + 1, j] && G[i + 2, j] && G[i + 2, j + 1] && G[i + 2, j + 2] && G[i + 3, j + 2] && G[i + 4, j + 2])
            {
                G[i, j] = false;
                G[i, j + 1] = false;
                G[i, j + 2] = false; 
                G[i + 1, j] = false;
                G[i + 2, j] = false;
                G[i + 2, j + 1] = false;
                G[i + 2, j + 2] = false; 
                G[i + 3, j + 2] = false; 
                G[i + 4, j + 2] = false;
                return true;
            }
            else return false;
        }

        static bool checkF(bool[,] G,  int i, int j)
        {
            if (G[i, j] && G[i, j + 1] && G[i, j + 2] && G[i + 1, j] && G[i + 2, j] && G[i + 2, j + 1] && G[i + 3, j] && G[i + 4, j])
            {
                G[i, j] = false;
                G[i, j + 1] = false;
                G[i, j + 2] = false; 
                G[i + 1, j] = false;
                G[i + 2, j] = false;
                G[i + 2, j + 1] = false;
                G[i + 3, j] = false;
                G[i + 4, j] = false;
                return true;
            }
            else return false;
        }

    }
}
