#include <iostream>
#include <algorithm>
#include <string>
#include <vector>

/*
int main()
{
	unsigned n, k;
	std::cin >> n >> k;
	std::vector<std::string> vec(n);
	for (unsigned i = 0; i < n; ++i) {
		std::cin >> vec[i];
	}
	std::sort(vec.begin(), vec.end());

	std::cout << std::endl;
	for (auto& str : vec) {
		std::cout << str << std::endl;
	}
	return 0;
}
*/

int main()
{
	unsigned n, m, c;
	std::cin >> n >> m >> c;

	long long min = INT64_MAX;
	std::pair<int, int>  ans;
	for (int M = 0; m * M <= n + 2 * M; ++M) {
		unsigned k = n - m * M;
		if (k % c < min) {
			ans.first = M;
			ans.second = k / c;
			min = k % c;
		}
	}
	std::cout << ans.first << std::endl << ans.second << std::endl;
	return 0;
}