import java.io.*;

public class Main {
    public static void main(String[] args) throws IOException {
        BufferedReader reader =
                   new BufferedReader(new InputStreamReader(System.in));

        String arg1 = reader.readLine();
        String arg2 = reader.readLine();

        long res = calculateYearDistance(arg1, arg2);

        System.out.println(res);
    }

    public static long calculateYearDistance(String first, String second) {
        boolean isFirstAB = first.contains("AD");
        boolean isSecondAB = second.contains("AD");

        String[] firstArr = first.split(" ");
        String[] secondArr = second.split(" ");

        long f = Long.parseLong(isFirstAB ? firstArr[1] : firstArr[0]);
        long s = Long.parseLong(isSecondAB ? secondArr[1] : secondArr[0]);

        long result = 0;

        if ((isFirstAB && isSecondAB) || (!isFirstAB && !isSecondAB)) {
            result = Math.abs(f - s);
        } else {
            result = Math.abs(f) + Math.abs(s) - 1;
        }

        return result;
    }
}
