﻿#include <iostream>
#include <vector>
#include <unordered_map>

using namespace std;

long long int n, k, ans;

struct vertex {
    int sum;
    unordered_map <int, vertex*> ch;
};

vertex null;

void build(string* s, int i, vertex* ver) {
    ver->sum++;

    if (i < s->size()) {
        int ind = (*s)[i] - 'a';
        if (ver->ch[ind] == NULL) {
            ver->ch[ind] = new vertex();
            ver->ch[ind]->sum = 0;                
        }
        build(s, i + 1, ver->ch[ind]);
    }
}

int cut(vertex* ver) {
    int cur = ver->sum;

    while (ver->sum > k) {
        vertex* m = &null;

        m->sum = 0;

        for (auto i : ver->ch) {
            if (m->sum < i.second->sum) m = i.second;
        }

        if (m->sum > k) {
            ver->sum -= cut(m);
        }
        else {
            ans++;
            ver->sum -= m->sum;
            m->sum = 0;
        }
    }

    return cur - ver->sum;
}

int main()
{
    cin >> n >> k;

    null.sum = 0;
    vertex* empty = new vertex();
    empty->sum = 0;   

    for (int i = 0; i < n; i++) {
        string s;

        cin >> s;

        build(&s, 0, empty);
    }

    cut(empty);

    if (empty->sum != 0) {
        ans++;
    }

    cout << ans;
}

