#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <fstream>
#include <ios>
#include <algorithm>
#include <iomanip> 
#include <cmath> 
#include <numeric> 

using namespace std;

#define vi vector<int>
#define sti set<int>
#define ll long long
#define v(a) vector<a>
#define vll v(ll)

#define vs vector<string>
#define vvs vector< vector<string> >
#define vvi vector< vi>
#define sts set<string>
#define str string
#define len(v) v.size()
#define mp(a, b) make_pair(a, b)
#define vp(a, b) vector< pair<a,b> >
#define pii pair<int, int>

ifstream fin("dna.in", ios::in);
ofstream out("dna.out", ios::out);
ll sq(ll a)
{
    return a * a;
}

template <typename T>

v(T) readv(ll n)
{
    v(T) res(n);
    for (int i = 0; i < n; i++) cin >> res[i];
    return res;
}

//base ^ p
int bin_pow(int a, int n) {
    int res = 1;
    while (n) {
        if (n & 1)
            res = res * a;
        a *= a;
        n >>= 1;
    }
    return res;
}

//dfs
int n, m;

vector<int> color; //   (0, 1,  2)

vector<int> time_in, time_out; // ""     
int dfs_timer = 0; // ""   

void dfs(int v, v(vi) g) {
    time_in[v] = dfs_timer++;
    color[v] = 1;
    for (vector<int>::iterator i = g[v].begin(); i != g[v].end(); ++i)
        if (color[*i] == 0)
            dfs(*i, g);
    color[v] = 2;
    time_out[v] = dfs_timer++;
}

int gcd(int a, int b) {
    if (b == 0)
        return a;
    else
        return gcd(b, a % b);
}

vector<int> p(n);

int dsu_get(int v) {
    return (v == p[v]) ? v : (p[v] = dsu_get(p[v]));
}

void dsu_unite(int a, int b) {
    a = dsu_get(a);
    b = dsu_get(b);
    if (rand() & 1)
        swap(a, b);
    if (a != b)
        p[a] = b;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    ll n, m, c, f = 0;
    cin >> n >> m >> c;
    ll b = n;
    ll km, kc;
    ll qm, qc;
    km = b / m;
    kc = (b % m) / c;
    
    qc = b / c;
    qm = (b % c) / m;

    if (abs(m * km + c * kc - n) < abs(m * qm + c * qc - n))
        cout << km << ' ' << kc;
    else
        cout << qm << ' ' << qc;
    return 0;
}
