import java.util.Scanner;

public class App {
    public static Scanner sc = new Scanner(System.in);

    public static void main(String[] args) {
        long n = sc.nextLong();
        long m = sc.nextLong();
        long c = sc.nextLong();


        long[] a = coef(n , c, m);
        long[] b = coef(n , m, c);


        if( d(a[0] * a[1] + a[2] * a[3], n) <  d(b[0] * b[1] + b[2] * b[3], n)) {
            System.out.println(a[1] + " " + a[3]);
            return;
        }

        System.out.println(b[3] + " " + b[1]);


    }

    private static long[] coef(long n, long c, long m) {
        long tryC = (n / c) * c;

        long coefC1 = 0;
        long coefM1 = 0;
        
        
        if(d(tryC + c, n) <= d(tryC, n)  
                && d(tryC + c, n) <= d(tryC + m, n)) {
            coefM1 = 0;
            coefC1 = n / c + 1;
        }

        else if(d(tryC, n) <= d(tryC + c, n) 
                && d(tryC, n) <= d(tryC + m, n)) {
            coefM1 = 0;
            coefC1 = n / c;
        }

        else if(d(tryC + m, n) <= d(tryC + c, n) 
                && d(tryC + m, n) <= d(tryC, n) ) {
            coefM1 = 1;
            coefC1 = n / c;
        }

        
        
        return new long[] {m, coefM1, c, coefC1};
    }

    private static long d(long a, long n){
        return Math.abs(a - n);
    }
}
