
import java.util.HashMap;
import java.util.Scanner;
import java.util.TreeSet;

public class App {
    private static HashMap<Long, Long> map = new HashMap<>();

    public static void main(String[] args) {
        Scanner sc = new Scanner(System.in);
        int t = sc.nextInt();
        while(t --> 0) {
            foo(sc);
        }
    }

    public static void foo(Scanner sc) {
        long n = sc.nextLong();
        if(map.containsKey(n)){
            System.out.println(map.get(n));
            return;
        }
        TreeSet<Long> set = new TreeSet<>();
        TreeSet<Long> visited = new TreeSet<>();
        for(long i = 1; i < n; i++){
            set.add(i);
        }
        for(long i = 2; i < n; i++) {
            if(n % i == 0) {
                if(visited.contains(i)) {
                    continue;
                }
                for(long j = 1; j < n / i; j++) {
                    set.remove(j * i);
                    visited.add(j * i);
                }
            }
        }
        if(set.size() == n - 1) {
            System.out.println(median(set.size()) + 1);
            map.put(n, median(set.size()) + 1);
            return;
        }

        long medianIndex = median(set.size());
        for(int i = 0; i < medianIndex; i++) {
            set.pollFirst();
        }

        long answer = set.pollFirst();
        System.out.println(answer);
        map.put(n, answer);

    }

    public static long median(long size) {
        long medianIndex = size / 2;
        if(size % 2 == 0)
            medianIndex--;
        return medianIndex;
    }
}
