#include <iostream>
#include <vector>
#include <string>

unsigned long long int gcd(unsigned long long int  a, unsigned long long int  b)
{
    if (b == 0)
        return a;
    else
        return gcd(b, a % b);
}
 
bool coPrime(unsigned long long int n1, unsigned long long int n2)
{

    if (gcd(n1, n2) == 1)
        return true;
    else
        return false;
}
 
unsigned long long int  largestCoprime(unsigned long long int  N)
{
    unsigned long long int  half =N / 2;
 
    while (coPrime(N, half) == false)
        half--;
 
    return half;
}
 
int main()
{
    
    int c;
    std::cin>>c;

    for(int i = 0; i < c; ++i){

        unsigned long long int  n;
        std::cin>>n;
        std::cout << largestCoprime(n) << std::endl;

    }
 
    return 0;
}