/*
          ,     \    /      ,
         / \    )\__/(     / \
        /   \  (_\  /_)   /   \
   ____/_____\__\@  @/___/_____\____
  |             |\../|              |
  |              \VV/               |
  |        ------hoi-------         |
  |_________________________________|
   |    /\ /      \\       \ /\    |
   |  /   V        ))       V   \  |
   |/     `       //        '     \|
   `              V                '
*/

#include <bits/stdc++.h>

#define ld long double
#define ll long long
#define ull unsigned long long
#define pb push_back
#define mp make_pair
#define f first
#define s second
#define Speedforce boost();
#define fop(s1, s2) freopen(s1, "r", stdin);freopen(s2, "w", stdout);

using namespace std;

void boost(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

//mt19937_64 mt(chrono::steady_clock::now().time_since_epoch().count());

const int N = 1e6;
const ll inf = 1e9+7;
const ld PI = acos(-1);

ll bin_pow(ll x, ll y, ll mod = inf){
    ll res = 1, base = x;
    while(y){
        if(y & 1){
            res *= base;
            res %= mod;
        }
        base *= base;
        base %= mod;
        y /= 2;
    }
    return res;
}

int n, m;
vector <pair <int, int> > g[N];
queue <int> q;
int d[N], pr[N];
int mx[N], mn[N];

int main(){
    Speedforce
    //fop("bad.in", "bad.out");
    cin >> n >> m;
    for(int i = 1;i <= m;i ++){
        int x, y, z;
        cin >> x >> y >> z;
        g[x].pb(mp(y,z));
        g[y].pb(mp(x,z));
    }
    for(int i = 1;i <= n;i ++){
        d[i] = inf;
        mx[i] = -inf;
        mn[i] = inf;
    }
    q.push(1);
    d[1] = 1;
    while(!q.empty()){
        int v = q.front();
        if(v == n){
            break;
        }
        q.pop();
        for(int i = 0;i < g[v].size();i ++){
            int to = g[v][i].f, cl = g[v][i].s;
            if(d[to] <= d[v]){
                continue;
            }
            if(d[to] == d[v] + 1){
                if(mx[to] - mn[to] < max(mx[v],cl) - min(mn[v],cl)){
                    mx[to] = max(mx[v],cl);
                    mn[to] = min(mn[v],cl);
                    pr[to] = v;
                }
                continue;
            }
            mx[to] = max(mx[v],cl);
            mn[to] = min(mn[v],cl);
            pr[to] = v;
            d[to] = d[v] + 1;
            q.push(to);
        }
    }
    /*for(int i = 1;i <= n;i ++){
        cout << mx[i] << " " << mn[i] << endl;
    }*/
    cout << d[n] - 1 << endl;
    vector <int> path;
    int x = n;
    while(x != 1){
        path.pb(x);
        x = pr[x];
    }
    path.pb(1);
    reverse(path.begin(), path.end());
    for(int i = 0;i < d[n];i ++){
        cout << path[i] << " ";
    }
}
