#include <bits/stdc++.h>
using namespace std;

struct tree {
    tree(int v = 0) : val(v), next(26, nullptr)
    {}
    int val;
    vector<tree*> next;
};

void add(tree* t, const string& s) {
    for(int i = 0; i < s.size(); ++i) {
        int idx = s[i] - 'a';
        if(!t->next[idx]) {
            t->next[idx] = new tree();
        }
        t = t->next[idx];
        t->val++;
    }
}

int k;

pair<int, int> del(tree* head) {
    if(head->val <= k) {
        int r = head->val;
        head->val = 0;
        return {r, 1};
    }
    pair<int, int> a = {0, 0};
    while(head->val > k) {
        int mx = 0, idx = 0;
        for(int i = 0; i < head->next.size(); ++i) {
            if(head->next[i] && head->next[i]->val > mx) {
                mx = head->next[i]->val;
                idx = i;
            }
        }
        auto d = del(head->next[idx]);
        a.first += d.first;
        head->val -= d.first;
        a.second += d.second;
    }
    return a;
}

void solve() {
    int n; cin >> n >> k;
    tree* head = new tree(n);
    string s[n];
    for(int i = 0; i < n; ++i) {
        cin >> s[i];
        add(head, s[i]);
    }
    cout << del(head).second + (head->val > 0) << endl;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1; //cin >> t;
    while(t--) {
        solve();
    }
    return 0;
}
