#include <bits/stdc++.h>
using namespace std;

const int sz = 2*1e5 + 5;
int inf = 1e9;
int n, m, d[sz], p[sz], minc[sz], maxc[sz], y[sz];
vector< pair<int, int> > g[sz];
vector<int> ans;
void solve(){
    cin >> n >> m;
    int a, b, c;
    for(int i = 0; i < m; i++){
        cin >> a >> b >> c;
        g[a].push_back({b, c});
        g[b].push_back({a, c});
    }
    for(int i = 1; i <= n; i++){
        d[i] = inf;
        y[i] = -1;
        minc[i] = inf;
        maxc[i] = -1;
    }
    d[1] = 0;
    set< pair<pair<int, int>, int> > x;
    x.insert({{0, 0}, 1});
    minc[1] = inf;
    maxc[1] = -1;
    y[1] = 0;
    while (!x.empty()) {
        int v = x.begin() -> second;
        x.erase (x.begin());
        for (int j = 0; j < g[v].size(); ++j) {
            int to = g[v][j].first,
                    C = g[v][j].second;
            int cur = max(maxc[v], C) - min(minc[v], C);
            if (d[v] + 1 < d[to] || (d[v] + 1 == d[to] && cur > y[to])){
                x.erase ({{d[to], -y[to]}, to});
                minc[to] = min(minc[v], C);
                maxc[to] = max(maxc[v], C);
                y[to] = max(maxc[to] - minc[to], 0);
                d[to] = d[v] + 1;
                p[to] = v;
                x.insert ({{d[to], -y[to]}, to});
            }
        }
    }
    cout << d[n] << endl;
    int cur = n;
    while(cur != 1){
        ans.push_back(cur);
        cur = p[cur];
    }
    ans.push_back(1);
    reverse(ans.begin(), ans.end());
    for(int i = 0; i < ans.size(); i++)
        cout << ans[i] << ' ';
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1; //cin >> t;
    while(t--) {
        solve();
    }
    return 0;
}
