#include <bits/stdc++.h>

using namespace std;

string a[305];
bool was[305][305];
int n, m;

bool check(int i, int j) {
    return a[i][j] == '#' && !was[i][j];
}

bool isF(int i, int j) {
    if (i + 4 < n && j + 2 < m && i >= 0 && j >= 0 && !was[i][j]) {
        pair<int, int> indices[] = {{i, j}, {i, j + 1}, {i, j + 2}, {i + 1, j}, {i + 2, j}, {i + 3, j}, {i + 4, j}, {i + 2, j + 1}};
        for (int k = 0; k < 8; k++) {
            if (!check(indices[k].first, indices[k].second)) {
                return false;
            }
        }
        for (int k = 0; k < 8; k++) {
            was[indices[k].first][indices[k].second] = true;
        }
        return true;
    }
    return false;
}

bool isQ(int i, int j) {
    if (i + 4 < n && j + 2 < m && i >= 0 && j >= 0 && !was[i][j]) {
        pair<int, int> indices[] = {{i, j}, {i, j + 1}, {i, j + 2}, {i + 1, j}, {i + 2, j}, {i + 2, j + 1}, {i + 2, j + 2}, {i + 1, j + 2}, {i + 3, j + 2}, {i + 4, j + 2}};
        for (int k = 0; k < 10; k++) {
            if (!check(indices[k].first, indices[k].second)) {
                return false;
            }
        }
        for (int k = 0; k < 10; k++) {
            was[indices[k].first][indices[k].second] = true;
        }
        return true;
    }
    return false;
}

void solve() {
    cin >> n >> m;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    int f = 0, q = 0;
    for (int i = n - 1; i >= 0; i--) {
        for (int j = m - 1; j >= 0; j--) {
            if (a[i][j] == '#' && !was[i][j]) {
                if (isQ(i - 4, j - 2)) {
                    q++;
                } else if (isF(i - 4, j)) {
                    f++;
                }
            }
        }
    }
    cout << q << ' ' << f;
}

int main() {
    int T = 1;
//    cin >> T;
    while (T--)
        solve();

    return 0;
}