//#pragma GCC optimize("Ofast")
//#pragma GCC target("sse,sse2,sse3,sse3,sse4,popcnt,abm,mmx")
 
//#include <bits/stdc++.h>
 
#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <iomanip>
#include <queue>
 
using namespace std;
 
const int N = 1e6;
const int inf = 1e9 + 7;
const int mod = 1e9 + 7;
const int INF = 1e9 + 13;
const int NN = 2e3;
const double epsilon = 1e-6;
 
#define sz(s) (int)(s.size())
#define all(x) x.begin(), x.end()
#define eb emplace_back
#define mkp make_pair
#define F first
#define S second
#define ll long long
 
void nfsmw() {
  ios_base::sync_with_stdio(false);
  cin.tie(0);
}

int n, m;

int ans;

vector <int> res, path;

vector <pair<int, int> > g[N];

bool u[N], u2[N];

int d[N];

void dfs(int v, int depth, int dist, int mx, int mn) {
  if (v == n) {
    if (dist == depth) {
      if (ans < mx - mn) {
        ans = mx - mn;
        res.clear();
        res = path;
        
      }
    }
    return;
  }
  for (int i = 0; i < sz(g[v]); ++ i) {
    int to = g[v][i].first;
    if (!u2[to]) {
      path.eb(to);
      u2[to] = (n == to ? u2[to] : true);
      dfs(to, depth + 1, dist, max(mx, g[v][i].second), min(mn, g[v][i].second));
      u2[to] = false;
      path.pop_back();
    }
  }
}
 
void solve() {
  cin >> n >> m;
  for (int i = 1; i <= m; ++ i) {
    int x, y, z;
    cin >> x >> y >> z;
    g[x].eb(mkp(y, z));
    g[y].eb(mkp(x, z));
  }
  queue <int> q;
  q.push(1);
  u[1] = true;
  while(q.empty() == 0) {
    int top = q.front();
    q.pop();
    for (int i = 0; i < g[top].size(); ++ i) {
      int to = g[top][i].first;
      if (!u[to]) {
        u[to] = true;
        d[to] = d[top] + 1;
        q.push(to);
      }
    }
  }
  dfs(1, 0, d[n], -inf, inf);
  cout << d[n] << '\n';
  cout << 1 << ' ';
  for (auto to : res)
    cout << to << ' ';
  return;
}
 
#define int int
 
int main() {
  nfsmw();
  int tt = 1;
 
  while (tt--) {
    solve();
  }
  return 0;
}