/*
 _    _    _______   _    _
| |  / /  |  _____| | |  / /
| | / /   | |       | | / /
| |/ /    | |_____  | |/ /
| |\ \    |  _____| | |\ \
| | \ \   | |       | | \ \
| |  \ \  | |_____  | |  \ \
|_|   \_\ |_______| |_|   \_\

*/
#include <iostream>
#include <cstdio>
#include <set>
#include <map>
#include <stack>
#include <queue>
#include <vector>
#include <cstring>
#include <string>
#include <iomanip>
#include <cmath>
#include <algorithm>
#include <assert.h>

using namespace std;

typedef unsigned long long ull;
typedef long long ll;
typedef double ld;
typedef pair <int, int> PII;
typedef pair <ll, ll> PLL;

#define F first
#define S second
#define pb push_back
#define eb emplace_back
#define right(x) x << 1 | 1
#define left(x) x << 1
#define forn(x, a, b) for (int x = a; x <= b; ++x)
#define for1(x, a, b) for (int x = a; x >= b; --x)
#define mkp make_pair
#define sz(a) (int)a.size()
#define all(a) a.begin(), a.end()
#define y1 kekekek

const ll ool = 1e18 + 9;
const int oo = 1e9 + 9, base = 1e9 + 7;
const ld eps = 1e-7;
const int N = 5e5 + 6;


int n, m, par[3][N];
vector < pair < PII, int > > all;
vector < PII > g[N];


vector <PII> calc(int st, int kek) {
    queue < int > q;
    vector <PII> d(n + 1);
    
    d[st] = PII(1, 0);
    q.push(st);
    
    while (!q.empty()) {
        int v = q.front();
        q.pop();
        
        for (auto it : g[v]) {
            int to = it.F;
            
            if (!d[to].F) {
                d[to].F = d[v].F + 1;
                q.push(to);
            }
            if (d[to].F == d[v].F + 1) {
                int res = max(it.S, d[v].S);
                if (d[to].S <= res) {
                    d[to].S = res;
                    par[kek][to] = v;
                }
            }
        }
    }
    
    return d;
}

vector <int> buildans(int st, vector <PII> d, int kek) {
    vector < int > ans;
    ans.eb(st);
    while (par[kek][st]) {
        st = par[kek][st];
        ans.eb(st);
    }
    
    return ans;
}

int main() {
	ios_base :: sync_with_stdio(0), cin.tie(0), cout.tie(0);

    cin >> n >> m;
    forn(i, 1, m) {
        int x, y, c;
        cin >> x >> y >> c;
        
        g[x].eb(y, c);
        g[y].eb(x, c);
        
        all.eb(PII(x, y), c);
        all.eb(PII(y, x), c);
    }

    vector <PII> d1 = calc(1, 0);
    vector <PII> dn = calc(n, 1);
    
    // cerr << "kek " << d1[n].F << endl;

    int ans = 0, ansi = 0;
    forn(i, 0, sz(all) - 1) {
        int x = all[i].F.F;
        int y = all[i].F.S;
        int c = all[i].S;
        
        int res = max(max(d1[x].S, dn[y].S), c) - c;
        if ((d1[x].F - 1) + (dn[y].F - 1) + 1 == d1[n].F - 1 && res >= ans) {
            ans = res;
            ansi = i;
            // cerr << x << " " << y << endl;
            // cerr << d1[x].F << " " << dn[y].F << endl << endl;
        }
    }

    vector <int> left = buildans(all[ansi].F.F, d1, 0);
    vector <int> right = buildans(all[ansi].F.S, dn, 1);
    reverse(all(left));
    
    cout << sz(left) + sz(right) - 1 << endl;
    
    for (int x : left) cout << x << " ";
    for (int x : right) cout << x << " ";
    cout << endl;
    
	return 0;
}
