#include <bits/stdc++.h>

using namespace std;

vector<vector<char>> F(5, vector<char>(3));

// ###
// #..
// ##.
// #..
// #..

// ###
// #.#
// ###
// ..#
// ..#

inline void solve(){
    vector<vector<char>> F(5, vector<char>(3, '.')), Q(5, vector<char>(3, '.'));

    F[0][0] = '#';
    F[0][1] = '#';
    F[0][2] = '#';
    F[1][0] = '#';
    F[2][0] = '#';
    F[2][1] = '#';
    F[3][0] = '#';
    F[4][0] = '#';

    Q[0][0] = '#';
    Q[0][1] = '#';
    Q[0][2] = '#';
    Q[1][0] = '#';
    Q[1][2] = '#';
    Q[2][0] = '#';
    Q[2][1] = '#';
    Q[2][2] = '#';
    Q[3][2] = '#';
    Q[4][2] = '#';

    int n, m;
    cin >> n >> m;
    vector<vector<char>> a(n, vector<char>(m));

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cin >> a[i][j];
        }
    }

    int qCount = 0, fCount = 0;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (a[i][j] == '#' && n - i >= 5 && m - j >= 3) {
                bool isQ = true, isF = true;
                for (int I = i; I < i + 5; ++I) {
                    for (int J = j; J < j + 3; ++J) {
                        int x = I - i, y = J - j;
                        if (a[I][J] == '.') {
                            if (F[x][y] == '#')
                                isF = false;
                            if (Q[x][y] == '#')
                                isQ = false;   
                        }
                    }
                }
                if (isF)
                    fCount++;
                else if (isQ)
                    qCount++;
            }
        }
    }
    cout << qCount << " " << fCount;
}

int main(){
    #ifdef nurik
    freopen("in", "r", stdin);
    #endif

    ios_base::sync_with_stdio(0);

    solve();

    return 0;
}
