#include <bits/stdc++.h>
using namespace std;
#define ll long long
#define vi vector<int>
#define vl vector<ll>
#define vvi vector<vi>
#define vvl vector<vl>
#define vb vector<bool>
#define vvb vector<vb>
#define vd vector<double>
#define vvd vector<vd>
#define pii pair<int, int>
#define pll pair<ll, ll>
#define pb push_back
#define sz(x) (int)x.size()
#define all(x) x.begin(), x.end()
#define fr first
#define sc second
#define REP(i, a, b) for(int i = a; i < b; ++i)

int inf = 1e9;

void solve(){
	int n, m;
	cin>>n>>m;
	vector<vector<pii> > g(n + 1, vector<pii>());
	REP(i, 1, m + 1){
		int u, v, c; cin>>u>>v>>c;
		g[u].pb({v, c}); g[v].pb({u, c});
	}
	vector<pii> mxL(n + 1, {0, 0}), mxR(n + 1, {0, 0}), mnL(n + 1, {0, inf}), mnR(n + 1, {0, inf});
	vi d(n + 1, inf);
	d[n] = 0;
	queue<int> q;
	q.push(n);
	while(!q.empty()){
		int v = q.front();
		q.pop();
		for(auto u : g[v]){
			if(d[u.fr] > d[v] + 1){
				d[u.fr] = d[v] + 1;
				q.push(u.fr);
			}
		}
	}
	int ans = 0;
	vb used(n + 1, 0);
	used[1] = 1;
	q.push(1);
	while(!q.empty()){
		int v = q.front();
		q.pop();
		for(auto to : g[v]){
			int u = to.fr;
			int c = to.sc;
			if(d[v] - d[u] == 1){
				if(c > mxL[u].sc || mxL[v].sc > mxL[u].sc){
					mxL[u] = {v, max(c, mxL[v].sc)};
				}
				if(c < mnL[u].sc || mnL[v].sc < mnL[u].sc){
					mnL[u] = {v, min(c, mnL[v].sc)};
				}
				if(!used[u]){
					q.push(u);
					used[u] = 1;
				}
			}
		}
	}
	used.assign(n + 1, 0);
	used[n] = 1;
	int umn, umx, um;
	q.push(n);
	while(!q.empty()){
		int v = q.front();
		q.pop();
		//cout<<v<<"\n";
		for(auto to : g[v]){
			int u = to.fr;
			int c = to.sc;
			if(d[u] - d[v] == 1){
				if(c > mxR[u].sc || mxR[v].sc > mxR[u].sc){
					mxR[u] = {v, max(c, mxR[v].sc)};
				}
				if(c < mnR[u].sc || mnR[v].sc < mnR[u].sc){
					mnR[u] = {v, min(c, mnR[v].sc)};
				}
				if(mxR[u].sc >= mxL[u].sc && mnL[u].sc <= mnR[u].sc && ans < abs(mxR[u].sc - mnL[u].sc)){
					umx = mxR[u].fr;
					umn = mnL[u].fr;
					ans = abs(mxR[u].sc - mnL[u].sc);
					um = u;
				}
				if(mxL[u].sc >= mxR[u].sc && mnR[u].sc <= mnL[u].sc && ans < abs(mxL[u].sc - mnR[u].sc)){
					umx = mxL[u].fr;
					umn = mnR[u].fr;
					ans = abs(mxL[u].sc - mnR[u].sc);
					um = u;
				}
				if(!used[u]){
					q.push(u);
					used[u] = 1;
				}
			}
		}
	}
	vi rtl, rtr;
	cout<<d[1]<<"\n";
	if(abs(mxL[um].sc - mnR[um].sc) == ans){
		for(int v = um; v != 0; v = mxL[v].fr) rtl.pb(v);
		for(int v = mnR[um].fr; v != n; v = mnR[v].fr) rtr.pb(v);
		rtr.pb(n);	
	}else{
		for(int v = um; v != 0; v = mnL[v].fr) rtl.pb(v);
		for(int v = mxR[um].fr; v != n; v = mxR[v].fr) rtr.pb(v);
		rtr.pb(n);
	}
	//cout<<um<<"\n";
	reverse(all(rtl));
	for(auto v : rtl) cout<<v<<" ";
	for(auto v : rtr) cout<<v<<" ";
}
signed main(){
	ios::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);
    solve();
}

