#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef pair <int, int> pii;
typedef pair <ll, int> pli;
typedef pair <int, ll> pil;
typedef pair <ll, ll> pll;
typedef vector <int> vi;
typedef vector <ll> vl;
typedef vector <vi> vvi;
typedef vector <vl> vvl;
#define fr first
#define sc second
#define ins insert
#define all(x) begin(x), end(x)
#define ppb pop_back()
#define pb push_back
#define sz(x) x.size()
#define lb lower_bound
#define ub upper_bound
#define endl "\n"
const int INF = 1e9, N = 1e5 + 1;
vector <pii> g[N];
int d[2][N], mn[2][N], mx[2][N], pmx[2][N], pmn[2][N], n;
queue <int> q;
void bfs(bool ok, int v){
    for(int i = 1;i <= n; ++ i){
        d[ok][i] = n;
        mx[ok][i] = 0;
        mn[ok][i] = INF;
    }
    d[ok][v] = 0;
    q.push(v);
    while(!q.empty()){
        int v = q.front();
        q.pop();
        for(auto it : g[v]){
            int to = it.fr, c = it.sc;
            if(d[ok][to] == n){
                d[ok][to] = d[ok][v] + 1;
                q.push(to);
            }
            if(d[ok][to] == d[ok][v] + 1){
                if(mn[ok][to] > min(mn[ok][v], c)){
                    mn[ok][to] = min(mn[ok][v], c);
                    pmn[ok][to] = v;
                }
                if(mx[ok][to] < max(mx[ok][v], c)){
                    mx[ok][to] = max(mx[ok][v], c);
                    pmx[ok][to] = v;
                }
            }
        }
    }
}
int m;
vector <int> ans;
void solve(){
    cin >> n >> m;
    for(int i = 1;i <= m; ++ i){
        int a, b, c;
        cin >> a >> b >> c;
        g[a].pb({b, c});
        g[b].pb({a, c});
    }
    bfs(0, 1);
    bfs(1, n);
    int dif = -INF - 1;
    pii pos;
    for(int i = 1;i <= n; ++ i){
        //cout << mx[0][i] << " " << mx[1][i] << " " << mn[0][i] << " " << mn[1][i] << endl;
        if(d[0][i] + d[1][i] == d[0][n]){
            if(dif < mx[0][i] - mn[1][i]){
                dif = mx[0][i] - mn[1][i];
                pos = {i, 0};
            }
            if(dif < mx[1][i] - mn[0][i]){
                dif = mx[1][i] - mn[0][i];
                pos = {i, 1};
            }
        }
    }
    if(pos.sc){
        int v = pos.fr;
        while(v != 1){
            v = pmn[0][v];
            ans.pb(v);
        }
        reverse(all(ans));
        v = pos.fr;
        ans.pb(v);
        while(v != n){
            v = pmx[1][v];
            ans.pb(v);
        }
    }
    else{
        int v = pos.fr;
        while(v != 1){
            v = pmx[0][v];
            ans.pb(v);
        }
        reverse(all(ans));
        v = pos.fr;
        ans.pb(v);
        while(v != n){
            v = pmn[1][v];
            ans.pb(v);
        }
    }
    cout << sz(ans) - 1 << "\n";
    for(auto to : ans){
        cout << to << " ";
    }
}

int main(){
//	freopen("input.txt", "r", stdin);
//	freopen("output.txt", "w", stdout);
    ios_base::sync_with_stdio(0);
    int T = 1;
    //cin >> T;
    while(T--){
        solve();
    }
    return 0;
}
