#include <bits/stdc++.h>

#define pb push_back
#define sz(x) (int)x.size()
#define whole(x) x.begin(), x.end()
#define rwhole(x) x.rbegin(), x.rend()

using namespace std;

typedef long long ll;
typedef long double ld;

const int N = (int)3e5 + 2;
const int INF = (int)1e9 + 7;
const ll linf = (ll)1e14;

int n, m;

int a[305][305], used[305][305];

bool can(int i, int j) {
    return ((1 <= i && i <= n) && (1 <= j && j <= m));
}

bool is_q(int i, int j) {
    int sum = 0;
    for (int d = 0; d <= 2; ++d) {
        if (!can(i, j + d)) return false;
        sum += a[i][j + d];
    }
    for (int d = 1; d <= 2; ++d) {
        if (!can(i + d, j)) return false;
        sum += a[i + d][j];
    }
    if (!can(i + 2, j + 1)) return false;
    sum += a[i + 2][j + 1];
    for (int d = 1; d <= 4; ++d) {
        if (!can(i + d, j + 2)) return false;
        sum += a[i + d][j + 2];
    }
    return (sum == 10);
}

void mark_q(int i, int j) {
    for (int d = 0; d <= 2; ++d) {
        used[i][j + d] = 1;
    }
    for (int d = 1; d <= 2; ++d) {
        used[i + d][j] = 1;
    }
    used[i + 2][j + 1] = 1;
    for (int d = 1; d <= 4; ++d) {
        used[i + d][j + 2] = 1;
    }
}

bool is_f(int i, int j) {
    int sum = 0;
    for (int d = 0; d <= 2; ++d) {
        if (!can(i, j + d)) return false;
        sum += a[i][j + d];
    }
    for (int d = 1; d <= 4; ++d) {
        if (!can(i + d, j)) return false;
        sum += a[i + d][j];
    }
    if (!can(i + 2, j + 1)) return false;
    sum += a[i + 2][j + 1];
    return (sum == 8);
}

void mark_f(int i, int j) {
    for (int d = 0; d <= 2; ++d) {
        used[i][j + d] = 1;
    }
    for (int d = 1; d <= 4; ++d) {
        used[i + d][j] = 1;
    }
    used[i + 2][j + 1] = 1;
}

void solve() {  
    cin >> n >> m;

    for (int i = 1; i <= n; ++i) {
        for (int j = 1; j <= m; ++j) {
            char ch; cin >> ch;
            if (ch == '#') a[i][j] = 1;
            else a[i][j] = 0;
        }
    }

    int cnt_q = 0, cnt_f = 0;
    for (int i = 1; i <= n; ++i) {
        for (int j = 1; j <= m; ++j) {
            if (used[i][j]) continue;
            if (is_f(i, j)) {
                mark_f(i, j);
                ++cnt_f;
            }
            else if (is_q(i, j)) {
                mark_q(i, j);
                ++cnt_q;
            }
        }
    }

    cout << cnt_q << " " << cnt_f << "\n";
}

int main() {
    int tt = 1;
    while (tt--) solve();
    return 0;
}

/*
   for (int ii = 1; ii <= n; ++ii) {
                    for (int jj = 1; jj <= m; ++jj) {
                        cout << used[ii][jj] << " ";
                    }
                    cout << "\n";
                }
                cout << "\n";
*/