#include <bits/stdc++.h>

using namespace std;

#define ll                  long long
#define vt                  vector
#define For(i, n)           for(int i = 0; i < n; ++i)
#define pii                 pair<int, int>

const int MOD = 1e9 + 7;

int vn = 1;
const int N = 7e5;
const int alphabet = 26;
vt<vt<int> > to(N, vt<int> (alphabet));
vt<int> parent(N);
vt<int> cnt(N);
int gc = 0;

void add(string s) {
	int n = s.length();
	int v = 1;
	For(i, n) {
		int c = s[i] - 'a';
		if (to[v][c] == 0) {
			to[v][c] = ++vn;
		}
		cnt[v]++;
		parent[to[v][c]] = v;
		v = to[v][c];
	}
	cnt[v]++;
}

void del(int v, set<pii> & st) {
	for (int i = 0; i < 26; i++) {
		if (cnt[to[v][i]] > 0) {
			del(to[v][i], st);
		}
	}
	st.erase({-cnt[v], -v});
}

void upd(int v, int nv, int k, set<pii> & st) {
	if (v == 0) return;
	st.erase({-cnt[v], -v});
	cnt[v] -= nv;
	if (cnt[v] != 0 && cnt[v] <= k) {
 		st.insert({-cnt[v], -v});
	}
	upd(parent[v], nv, k, st);
}

int main()
{
	int n, k; cin >> n >> k;
	For (i, n) {
		string t; cin >> t;
		add(t);
	}
	set<pair<int, int> > st;
	for (int i = 1; i <= vn; i++) {
		if (cnt[i] <= k) {
			st.insert({-cnt[i], -i});
		}
	}
	while (!st.empty()) {
		pii x = *st.begin();
		if (x.first == 0) {
			break;
		}
		gc++;
		del(-x.second, st);
		upd(parent[-x.second], -x.first, k, st);	
	}
	cout << gc << endl;
	return 0;
}