#include <bits/stdc++.h>
using namespace std;

#define ll long long
#define ld long double
#define pii pair<int, int>
#define pll pair<ll, ll>
#define F first
#define S second
#define pb push_back
#define all(x) x.begin(), x.end()

const ll inf = 1e9 + 9;
const ll linf = 1e18 + 9;
const ll maxn = 1e5+100;
const ll mod = 1e9+7;
const ld eps = 1e-9;

//-------------------------------------------------------------------------
int n, m;
vector < pii > g[maxn];

int main() {
    cin >> n >> m;
    for (int i = 1; i <= m; i++) {
        int a, b, w;
        cin >> a >> b >> w;
        g[a].pb({b, w});
        g[b].pb({a, w});
    }

    queue<int> q;
    q.push(1);
    vector<bool> used(n);
    vector<int> d(n), p(n), mx(n), mn(n);
    used[1] = true;
    p[1] = -1;
    mx[1] = -1;
    mn[1] = 1e9+1;
    while (!q.empty()) {
        int v = q.front();
        q.pop();
        for (int i=0; i<g[v].size(); ++i) {
            int to = g[v][i].F;
            int w = g[v][i].S;
            if (!used[to]) {
                used[to] = true;
                q.push(to);
                d[to] = d[v] + 1;
                mx[to] = max(mx[v], w);
                mn[to] = min(mn[v], w);
                p[to] = v;
            } else if (d[to] == d[v] + 1) {
                if (mx[to] - mn[to] < max(mx[v], w) - min(mn[v], w)) {
                    mx[to] = max(mx[v], w);
                    mn[to] = min(mn[v], w);
                    p[to] = v;
                }
            }
        }
    }

    vector<int> path;
    for (int v=n; v!=-1; v=p[v])
        path.push_back(v);
    reverse (path.begin(), path.end());
    cout << path.size()-1 << "\n";
    for (size_t i=0; i<path.size(); ++i)
        cout << path[i] << " ";

}
