#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using pii = pair<int, int>;
using ld = long double;

template <typename T>
int sz(T &x) {
  return (int)(x.size());
}

int power(int x, int y, int mod) {
  if (y == 0) {
    return 1;
  }
  int z = power(x, y >> 1, mod);
  z = z * 1ll * z % mod;
  if (y & 1) {
    z = z * 1ll * x % mod;
  }
  return z;
}

const int mod = 998244353;
const int inf = 1000000007;


struct node {
  map<char, int> nxt;
  int cnt;
  node() {
    cnt = 0;
  }
};

vector<node> t;

void add(string s) {
  int v = 0;
  for (char c : s) {
    if (!t[v].nxt.count(c)) {
      t.push_back(node());
      t[v].nxt[c] = sz(t) - 1;
    }
    v = t[v].nxt[c];
  }

  t[v].cnt++;
}

int ans;


int go(int v, int k) {
  int cur = t[v].cnt;
  vector<int> sizes;
  for (auto p : t[v].nxt) {
    int to = go(p.second, k);
    cur += to;
    sizes.push_back(to);
  }
  sort(sizes.begin(), sizes.end(), greater<int>());
  if (cur > k) {
    for (int i : sizes) {
      cur -= i;
      ans++;
      if (cur <= k) {
        break;
      }
    }
  }
  return cur;
}

void solve() {
  t.push_back(node());
  int n, k;
  cin >> n >> k;
  for (int i = 1; i <= n; ++i) {
    string s;
    cin >> s;
    add(s);
  }
  int val = go(0, k);
  if (val > 0) {
    ans++;
  }
  cout << ans << "\n";

}

int main() {
  #ifndef LOCAL58
    ios_base :: sync_with_stdio(false);
    cin.tie(nullptr);
  #endif

  int t = 1;
  //cin >> t;
  while (t--) {
    solve();
  }
  return 0;
}
