#pragma GCC optimize("Ofast")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx")

#include <bits/stdc++.h>

#define ll long long
#define pb push_back
#define F first
#define S second
#define pii pair <int , int>
#define pll pair <ll ,ll >
#define all(x) x.begin(),x.end()
#define sz(x) (int)(x.size())
#define int ll

using namespace std;

const int maxn = (int)1e5 + 7;
const ll linf = (ll)1e18 + 7;
const int INF = (int)1e9 + 7;
const double pi = 3.14159265359;
const double eps = 1e-6;
const int base = 1000 * 1000 * 1000;
const ll P = 37;
const int block = 100;

void boost(){
    ios_base::sync_with_stdio(NULL);
    cin.tie(NULL);
    cout.tie(NULL);
}

int n;

vector < pair < int , int > > g[maxn], parent[maxn];

int par[maxn];

vector < int > ans;

int curans = -1;

void findpath(int v, int mn, int mx){
    if(v == 1){
        curans = max(curans, abs(mx - mn));
        return;
    }
    for(auto i : parent[v]){
        int temp = par[v];
        par[v] = i.F;
        int current = curans;
        findpath(i.F, min(mn, i.S), max(mx, i.S));
        if(current == curans){
            par[v] = temp;
        }
    }
}

void solve(){
    int m;
    cin >> n >> m;
    for(int i = 1; i <= m; ++i){
        int x, y, w;
        cin >> x >> y >> w;
        g[y].pb({x, w});
        g[x].pb({y, w});
    }
    vector < int > dist(n + 1);
    for(int i = 1; i <= n; ++i){
        dist[i] = linf;
    }
    queue < int > q;
    dist[1] = 0;
    q.push(1);
    while(!q.empty()){
        int v = q.front();
        q.pop();
        for(auto i : g[v]){
            if(dist[i.F] > dist[v] + 1){
                dist[i.F] = dist[v] + 1;
                q.push(i.F);
            }
        }
    }
    for(int i = 1; i <= n; ++i){
        for(auto j : g[i]){
            if(dist[j.F] == dist[i] + 1){
                parent[j.F].pb({i, j.S});
            }
        }
    }
    findpath(n, linf, 0);
    cout << dist[n] << endl;
    if(dist[n] == 1){
        cout << 1 << " " << n;
        return;
    }
    int cur = n;
    while(cur != 1){
        ans.pb(cur);
        cur = par[cur];
    }
    ans.pb(1);
    reverse(all(ans));
    for(int i : ans){
        cout << i << " ";
    }
}

signed main() {
    boost();
    int t = 1;
    //cin >> t;
    for(int i = 1; i <= t; ++i){
        solve();
    }
}