#include <iostream>
#include <vector>
#include <algorithm>
#include <queue>

using namespace std;

typedef long long ll;

char c[411][411];

bool F(ll x, ll y){
    if(c[x][y] == '#' && c[x+1][y] == '#' && c[x+2][y] == '#' && c[x+3][y] == '#' && c[x+4][y] == '#' && c[x][y+1] == '#' && c[x][y+2] == '#' && c[x+2][y+1] == '#') {
        c[x][y] = '.', c[x+1][y] = '.', c[x+2][y] = '.', c[x+3][y] = '.', c[x+4][y] = '.', c[x][y+1] = '#', c[x][y+2] = '.', c[x+2][y+1] = '.';
        return true;
    }
    return false;
}

bool Q(ll x, ll y){
    if(c[x][y] == '#' && c[x+1][y] == '#' && c[x+2][y] == '#' && c[x][y+1] == '#' && c[x][y+2] == '#' && c[x+2][y+1] == '#' && c[x+1][y+2] == '#' && c[x+2][y+2] == '#' && c[x+3][y+2] == '#' && c[x+4][y+2] == '#') {
        c[x][y] = '.', c[x+1][y] = '.', c[x+2][y] = '.',c[x][y+1] = '.', c[x][y+2] = '.', c[x+2][y+1] = '.', c[x+1][y+2] = '.', c[x+2][y+2] = '.', c[x+3][y+2] = '.', c[x+4][y+2] = '.';
        return true;
    }
    return false;
}

int main(){
    ll n,m;
    cin>>n>>m;
    for(ll i=1;i<=n;i++){
        for(ll j=1;j<=m;j++){
            cin>>c[i][j];
        }
    }
    ll q=0,f=0;
    for(ll i=1;i<=m;i++){
        for(ll j=1;j<=n;j++){
            if(F(j,i)){
                f++;
            }
            if(Q(j,i)){
                q++;
            }
        }
    }
    cout << q << " " << f << endl;
    return 0;
}
