# include <bits/stdc++.h>
# define sz(x) (int)((x).size())
# define f first 
# define s second
# define all(x) x.begin(), x.end()
 
using namespace std; 
using ll = long long;
 
const int N = 2e5 + 5; 
vector<pair<ll, ll>> g[N];

struct node{
	ll dist = 1e9, mx = -1, mn = 1e10;
};

node dp[N], d[N];
int max_p[N], min_p[N], max2_p[N], min2_p[N];
int n, m;

void bfs() {
	dp[1].dist = 0;
	queue<int> q;
	q.push(1);
	max_p[1] = -1;
	min_p[1] = -1;
	while (sz(q) > 0) {
		int v = q.front();
		q.pop();
		for (auto to : g[v]) {
			ll cost = to.s;
			ll vertex = to.f;
			if (dp[vertex].dist > dp[v].dist + 1) {
				dp[vertex].dist = dp[v].dist + 1;
				dp[vertex].mx = dp[v].mx;
				dp[vertex].mn = dp[v].mn;
				dp[vertex].mx = max(dp[vertex].mx, cost);
				dp[vertex].mn = min(dp[vertex].mn, cost);
				max_p[vertex] = v;
				min_p[vertex] = v;
				q.push(vertex);
			}
			else if (dp[vertex].dist == dp[v].dist + 1) {
				if (cost > dp[vertex].mx) {
					dp[vertex].mx = cost;
					max_p[vertex] = v;
				}
				else if (cost < dp[vertex].mn) {
					dp[vertex].mn = cost;
					min_p[vertex] = v;
				}
			}
		}
	} 
	cout << dp[n].dist << '\n';
	d[n].dist = 0;
	max2_p[n] = -1;
	min2_p[n] = -1;
	q.push(n);
	while (sz(q) > 0) {
		int v = q.front();
		q.pop();
		for (auto to : g[v]) {
			ll cost = to.s;
			ll vertex = to.f;
			if (d[vertex].dist > d[v].dist + 1) {
				d[vertex].dist = d[v].dist + 1;
				d[vertex].mx = d[v].mx;
				d[vertex].mn = d[v].mn;
				d[vertex].mx = max(d[vertex].mx, cost);
				d[vertex].mn = min(d[vertex].mn, cost);
				max2_p[vertex] = v;
				min2_p[vertex] = v;
				q.push(vertex);
			}
			else if (d[vertex].dist == d[v].dist + 1) {
				if (cost > d[vertex].mx) {
					d[vertex].mx = cost;
					max2_p[vertex] = v;
				}
				else if (cost < d[vertex].mn) {
					d[vertex].mn = cost;
					min2_p[vertex] = v;
				}
			}
		}
	}
	ll ans = 0;
	int x = 0, l = 0, r = 0;
	for (int i = 2; i < n; ++i) {
		if (dp[i].mx == -1 or d[i].mx == -1) continue;
		if (dp[i].dist + d[i].dist != dp[n].dist) continue;
 		if (d[i].mx - dp[i].mn  >= ans) {
			ans = d[i].mx - dp[i].mn;
			l = 1;
			r = 2;
			x = i;
		}
		if (dp[i].mx - d[i].mn >= ans) {
			ans = dp[i].mx - d[i].mn;
			l = 2;
			r = 1;
			x = i;
		}
	}
	vector<int> answer;
	int cur = x;
	while (true) {
		if (l == 1) {
			cur = min_p[cur];
		}
		else {
			cur = max_p[cur];
		}
		if (cur == -1) break;
		answer.push_back(cur);
	}
	cur = x;
	reverse(all(answer));
	while (true) {
		answer.push_back(cur);
		if (r == 1) {
			cur = min2_p[cur];
		}
		else {
			cur = max2_p[cur];
		}
		if (cur == -1) break;
	}
	for (auto i : answer) cout << i << ' ';
}


void solve() {
	cin >> n >> m;
	for (ll i = 0, u, v, c; i < m; ++i) {
		cin >> u >> v >> c;
		g[u].push_back({v, c});
		g[v].push_back({u, c});
	}
	if (n == 2) {
		cout << 1 << '\n';
		cout << 1 << ' ' << 2;
		return;
	}
	bfs();
}
 
int main(){
  ios_base::sync_with_stdio(false);
  cin.tie(0);
  //int t = 1; cin >> t; while (t--)
  solve();
  return 0;
}