#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <sstream>
#include <set>
#include <map>
#include <iomanip>

#define ll long long

using namespace std;

void _() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    // cout.tie(0);
}

bool is_f(vector<vector<char> >& a, int i, int j, int n, int m) {
    if (a[i][j] == '#'
        && a[i][j + 1] == '#'
        && a[i][j + 2] == '#'
        && a[i + 1][j] == '#'
        && a[i + 2][j] == '#'
        && a[i + 2][j + 1] == '#'
        && a[i + 3][j] == '#'
        && a[i + 4][j] == '#') {
        return true;
    }
    return false;
}

bool is_q(vector<vector<char> >& a, int i, int j, int n, int m) {
    if (a[i][j] == '#'
        && a[i + 1][j] == '#'
        && a[i + 2][j] == '#'
        && a[i + 2][j + 1] == '#'
        && a[i][j + 1] == '#'
        && a[i][j + 2] == '#'
        && a[i + 1][j + 2] == '#'
        && a[i + 2][j + 2] == '#'
        && a[i + 3][j + 2] == '#'
        && a[i + 4][j + 2] == '#') {
        return true;
    }
    return false;
}


// Turgyn Darkhan pidor
int main() {
    _();
    
    int n, m;
    cin >> n >> m;
    vector<vector<char> > a(n + 10, vector<char>(m + 10));
    int ans_f = 0, ans_q = 0;

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cin >> a[i][j];
        }
    }

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (is_f(a, i, j, n, m)) {
                ans_f++;
            } else if (is_q(a, i, j, n, m)) {
                ans_q++;
            }
        }
    }
    cout << ans_q <<  ' ' << ans_f << endl;

}
