#include <cstdio>

typedef long long i64;

i64 solve(i64 n) {
    i64 res = n;

    auto arr = new i64[n];
    for (i64 i = 0; i < n; i++) {
        arr[i] = 1;
    }

    for(i64 p = 2; p * p <= n; p++) {
        if (n % p == 0) {
            for (i64 i = p; i < n; i += p) {
                arr[i] = 0;
            }
            res -= res / p;
        }
    }
    if (n > 1) {
        res -= res / n;
    }
    #ifdef DEBUG
    printf("res: %lld\n", res);
    #endif
    res = res / 2;
    #ifdef DEBUG
    printf("res: %lld\n", res);
    #endif
    for (i64 i = 1; i < n; i++) {
        if (arr[i] == 1) {
            res--;
            if (res == 0) {
                return i;
            }
        }
    }
    return -1;
}
  
int main() {
    i64 t, n;
    scanf("%lld", &t);
    while (t-- > 0) {
        scanf("%lld", &n);
        printf("%lld\n", solve(n));
    }
}