#include <iostream>

long long gcd (long long a, long long b) {
    if (b == 0)
        return a;
    else
        return gcd (b, a % b);
}
long long find_coprime(long long i, long long n){
    while(gcd(i, n) != 1){
       i--;
    }
    return i;
}

int main() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(0); std::cout.tie(0);

    long long n;
    int t;
    std::cin>>t;
    while(t--) {
        std::cin >> n;
        if(n == 2){
            std::cout<<'1'<<"\n";
            continue;
        }
        std::cout << find_coprime((n - 1) / 2, n)<<"\n";
    }


    return 0;
}