#include <iostream>
#include <vector>

void getData(std::vector<std::vector<char>> &data){
    for(int i = 0; i < data.size(); ++i)
        for(int j = 0; j < data[0].size(); ++j)
            std::cin>>data[i][j];
}

void printData(const std::vector<std::vector<char>> &data){
    for(int i = 0; i < data.size(); ++i){
        for(int j = 0; j < data[0].size(); ++j)
            std::cout<<data[i][j]<<"";
    std::cout<<"\n";
    }
}

bool checkq(int i, int j, std::vector<std::vector<char>> &grid){
    std::vector<std::vector<char>> q = {{'#', '#', '#'},
                                        {'#', '.', '#'},
                                        {'#', '#', '#'},
                                        {'.', '.', '#'},
                                        {'.', '.', '#'},
                                        };
//
//    for(int x = i; x < i + 5; ++x) {
//        for (int y = j; y < j + 3; ++y)
//            std::cout << grid[x][y];
//        std::cout<<"\n";
//    }

    for(int x = i; x < i + 5; ++x)
        for(int y = j; y < j + 3; ++y)
            if(q[x - i][y - j] == '#' && grid[x][y] == '.')
                return false;

    for(int x = i; x < i + 5; ++x)
        for(int y = j; y < j + 3; ++y)
            if(q[x - i][y - j] == '#')
                grid[x][y] = '.';

//    printData(grid);
   return true;
}

bool checkf(int i, int j, std::vector<std::vector<char>> &grid){
    std::vector<std::vector<char>> f = {{'#', '#', '#'},
                                        {'#', '.', '.'},
                                        {'#', '#', '.'},
                                        {'#', '.', '.'},
                                        {'#', '.', '.'},
                                        };

//    for(int x = i; x < i + 5; ++x) {
//        for (int y = j; y < j + 3; ++y)
//            std::cout << grid[x][y];
//        std::cout<<"\n";
//    }
    for(int x = i; x < i + 5; ++x)
        for(int y = j; y < j + 3; ++y)
            if(f[x - i][y - j] == '#' && grid[x][y] == '.')
                return false;

    for(int x = i; x < i + 5; ++x)
        for(int y = j; y < j + 3; ++y)
            if(f[x - i][y - j] == '#')
                grid[x][y] = '.';

//    printData(grid);
    return true;
}



int main() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(0); std::cout.tie(0);

    int n, m;
    int q = 0, f = 0;

    std::cin>>n>>m;

    std::vector<std::vector<char>> grid(n, std::vector(m, '.'));
    getData(grid);

    for(int i = 0; i < n; ++i)
        for(int j = 0; j < m; ++j){
            if(grid[i][j] == '#'){
                f += checkf(i, j, grid);
                if(grid[i][j] == '#')
                q += checkq(i, j, grid);
            }
        }

    std::cout<<q<<" "<<f;
    return 0;
}

//5 8
//###..###
//#....#.#
//##...###
//#......#
//#......#