#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ull = unsigned long long;

using ld = double;

mt19937 mt(736);


void solve(istream &cin = std::cin, ostream &cout = std::cout)
{
	int n, l, v;

	cin >> n >> l >> v;

	vector<int> arr(n);

	for (auto &it : arr)
		cin >> it;

	auto func = [&](int pref) -> ld
	{
		ld tim = pref == arr.size() ? (ld) 0 : l / (ld) arr[pref];
		ld sum = 0;

		for (int i = 0; i < pref; i++)
			sum += tim + 2 * (l - (tim * arr[i])) / (arr[i] + v);
		for (int i = pref; i < arr.size(); i++)
			sum += (ld)l / arr[i];

		return sum / (ld)arr.size();
	};

#ifdef LOCAL
	for (int i = 0; i <= arr.size(); i++)
		cout << func(i) << ' ';
	cout << endl;
#endif

	int tl = 0, tr = (int)arr.size();

	while (tr - tl > 3)
	{
		auto cl = (tl + tl + tr) / 3;
		auto cr = (tl + tr + tr) / 3;

		if (func(cl) > func(cr))
			tl = cl;
		else
			tr = cr;
	}

	ld ans = numeric_limits<ld>::max();

	for (int i = tl; i <= tr; i++)
		ans = min(ans, func(i));

	cout << fixed << setprecision(numeric_limits<ld>::digits10);
	cout << ans << endl;
}


int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);

	cout << fixed;

#ifdef LOCAL
	auto st = clock();

	ifstream fin("../input.txt");

	do
	{
		solve(fin);

		cout << "===" << endl;

		string str;
		while (getline(fin, str) && str != string(max(1, (int)str.size()), '='));
	} while (fin);

	cout << setprecision(6) << "clock: " << double(clock() - st) / CLOCKS_PER_SEC << endl;
#else
	solve();
#endif

	return 0;
}
