#pragma GCC optimize("O3,unroll-loops")

#include <iostream>
#include <map>
#include <vector>
#include <deque>
#include <algorithm>
#include <bitset>
#include <cstring>
#include <math.h>
#include <string>
#include <set>
#include <iomanip>
#include <bitset>
#include <random>
#include <complex>
#include <random>
#include <cassert>
#include <unordered_map>
#include <unordered_set>
#include <queue>

using namespace std;
#define pb push_back
#define ll long long
#define mp make_pair
#define snd second
#define ins insert
//#define ld long double
#define mt make_tuple
#define fst first
#define all(x) (x).begin(), (x).end()
#define sz(x) ((int)(x).size())
const double PI = acos(-1);
// = 5e5 + 17;
const int MOD1 = 998244353;
const int MOD = 1'000'000'007;
const int INF = 1e9;
const int MaXN = 150;
const int N = 1e8 + 1000;
const int LOG = 25;
const int FACT = 120;

mt19937 rng(239);

ll gcd(ll a, ll b) {
	if (b == 0) return a;
	return gcd(b, a % b);
}

pair<ll, ll> gcd_eu(ll a, ll b) {
	if (b == 0) return mp(1, 0);
	auto res = gcd_eu(b, a % b);
	swap(res.first, res.second);
	res.second -= (a / b) * res.first;
	return res;
}

pair<ll, ll> long_ans(ll n, ll a, ll b) {
	auto res = gcd_eu(a, b);
	ll g = gcd(a, b);
	res.first *= n / g;
	res.second *= n / g;

	if (res.first < 0) {
		ll times = (-res.first-1) / b + 1;
		res.first += times * b;
		res.second -= times * a;
	}
	if (res.second < 0) {
		ll times = (-res.second-1) / a + 1;
		res.first -= times * b;
		res.second += times * a;
	}

	return res;
}


int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int n, m;
	cin >> n >> m;

	vector<vector<bool>> board(n, vector<bool>(m));

	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			char ch;
			cin >> ch;
			if (ch == '#') board[i][j] = true;
		}
	}

	int q_cnt = 0, f_cnt = 0;

	for (int j = 0; j < m; j++) {
		for (int i = 0; i < n; i++) {
			if (board[i][j]) {
				bool is_q = !board[i + 3][j];
				if (is_q) q_cnt++;
				else f_cnt++;
				if (is_q) {
					board[i][j] = false;
					board[i][j + 1] = false;
					board[i][j + 2] = false;
					board[i + 1][j] = false;
					board[i + 1][j + 2] = false;
					board[i + 2][j] = false;
					board[i + 2][j + 1] = false;
					board[i + 2][j + 2] = false;
					board[i + 3][j + 2] = false;
					board[i + 4][j + 2] = false;
				}
				else {
					board[i][j] = false;
					board[i][j + 1] = false;
					board[i][j + 2] = false;
					board[i + 1][j] = false;
					board[i + 2][j] = false;
					board[i + 2][j + 1] = false;
					board[i + 3][j] = false;
					board[i + 4][j] = false;
				}
			}
		}
	}

	cout << q_cnt << ' ' << f_cnt << endl;

	return 0;
}