#pragma GCC optimize("Ofast,unroll-loops")
#include <bits/stdc++.h>
typedef long long ll;
typedef long double ld;
using namespace std;
#define F first
#define S second
#define pb push_back
#define all(x) (x).begin(), (x).end()
#define SZ(x) (int)(x).size()
//#define int ll

struct node {
    int l, r, f;
    pair<int, int> max;
    node() = default;
    node(int l, int r, int f, pair<int, int> mx) : l(l), r(r), f(f), max(mx) {};
};

const int N = 1e7 + 10;
node t[N];
int cnt_all = 1;

void del_all(int m) {
    cnt_all = 1;
    t[1].l = t[1].r = t[1].f = 0;
    t[1].max = {0, m - 1};
}

void push(int v) {
    if (t[v].f) {
        t[t[v].l].f += t[v].f;
        t[t[v].r].f += t[v].f;
        t[t[v].l].max.F += t[v].f;
        t[t[v].r].max.F += t[v].f;
        t[v].f = 0;
    }
}

void update(int v, int l, int r, int a, int b, int delta) {
    if (l > b || r < a) {
        return;
    }
    if (l >= a && r <= b) {
        t[v].max.F += delta;
        t[v].f += delta;
        return;
    }
    int mid = (l + r) / 2;
    if (!t[v].l) {
        cnt_all++;
        t[v].l = cnt_all;
        t[cnt_all].l = t[cnt_all].r = t[cnt_all].f = 0;
        t[cnt_all].max = {0, mid};
    }
    if (!t[v].r) {
        cnt_all++;
        t[v].r = cnt_all;
        t[cnt_all].l = t[cnt_all].r = t[cnt_all].f = 0;
        t[cnt_all].max = {0, r};
    }
    push(v);
    update(t[v].l, l, mid, a, b, delta);
    update(t[v].r, mid + 1, r, a, b, delta);
    t[v].max = max(t[t[v].l].max, t[t[v].r].max);
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int T;
    cin >> T;
    while (T--) {
        int n, m;
        cin >> n >> m;
        vector<int> srt, tt(n);
        for (int i = 0; i < n; i++) {
            cin >> tt[i];
            if (tt[i] % m == 0) {
                srt.pb(tt[i] / m);
            } else {
                srt.pb(tt[i] / m);
                srt.pb(tt[i] / m + 1);
            }
        }
        sort(all(srt));
        srt.resize(unique(all(srt)) - srt.begin());
        auto get = [&](int tt) {
            return upper_bound(all(srt), tt) - srt.begin();
        };
        vector<int> pref(SZ(srt) + 1), suf(SZ(srt) + 1);
        for (int i = 0; i < n; i++) {
            if (tt[i] % m == 0) {
                pref[get(tt[i] / m)] = m;
            } else {
                int vl = get(tt[i] / m);
                pref[vl] = max(pref[vl], m - tt[i] % m);
                suf[vl + 1] = max(suf[vl + 1], (m - 1) - (m - tt[i] % m) + 1);
            }
        }
        vector<pair<int, int>> seg(SZ(srt) + 1);
        for (int it = 1; it <= SZ(srt); it++) {
            if (pref[it] + suf[it] >= m) {
                seg[it] = {m, 0};
            } else {
                seg[it] = {pref[it], suf[it]};
            }
        }
        int r = 0;
        pair<int, int> ans = {0, 0};
        auto add = [&](int day) {
            if (seg[day].F > 0) update(1, 0, m - 1, 0, seg[day].F - 1, 1);
            if (seg[day].S > 0) update(1, 0, m - 1, m - seg[day].S, m - 1, 1);
        };
        auto del = [&](int day) {
            if (seg[day].F > 0) update(1, 0, m - 1, 0, seg[day].F - 1, -1);
            if (seg[day].S > 0) update(1, 0, m - 1, m - seg[day].S, m - 1, -1);
        };
        del_all(m);
        for (int it = 1; it <= SZ(srt); it++) {
            if (it > 1) {
                del(it - 1);
            }
            r = max(r, it);
            while (r <= SZ(srt)) {
                if (r == it || srt[r - 2] == srt[r - 1] - 1) {
                    add(r);
                    if (t[1].max.F == r - it + 1) {
                        r++;
                    } else {
                        del(r);
                        break;
                    }
                } else {
                    break;
                }
            }
            ans = max(ans, {r - it, t[1].max.S});
        }
        cout << ans.F << ' ' << ans.S << '\n';
    }
}