#include <bits/stdc++.h>
typedef long long ll;
typedef long double ld;
using namespace std;
#define F first
#define S second
#define pb push_back
#define all(x) (x).begin(), (x).end()
#define SZ(x) (int)(x).size()
#define int ll

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int T;
    cin >> T;
    while (T--) {
        int n;
        cin >> n;
        vector<int> w(n + 1), b(n + 1);
        set<pair<int, int>> st, stw, stb;
        int s = 0, p_w = 0, p_b = 0;
        bool bad = false;
        for (int i = 1; i <= n; i++) {
            cin >> w[i] >> b[i];
            if (w[i] == 0 && b[i] == 0) {
                bad = true;
            }
            if (w[i] > 0) stw.insert({w[i] + b[i], i});
            if (b[i] > 0) stb.insert({w[i] + b[i], i});
            st.insert({w[i] + b[i], i});
            s += w[i] + b[i];
            p_w += w[i];
            p_b += b[i];
        }
        if (s != 2 * (n - 1) || (p_w & 1) || (p_b & 1) || bad) {
            cout << "No\n";
            continue;
        }
        bool ok = true;
        vector<pair<int, int>> white_edges, black_edges;
        while (!st.empty()) {
            if (st.begin()->F > 1) {
                ok = false;
                break;
            }
            int id = st.begin()->S;
            st.erase(st.begin());
            if (w[id] == 1) {
                stw.erase({w[id] + b[id], id});
                int id2 = stw.rbegin()->S;
                stw.erase({w[id2] + b[id2], id2});
                st.erase({w[id2] + b[id2], id2});
                if (stb.count({w[id2] + b[id2], id2})) stb.erase({w[id2] + b[id2], id2});
                w[id2]--;
                if (w[id2]) stw.insert({w[id2] + b[id2], id2});
                if (b[id2]) stb.insert({w[id2] + b[id2], id2});
                if (w[id2] + b[id2]) st.insert({w[id2] + b[id2], id2});
                white_edges.emplace_back(id, id2);
            } else if (b[id] == 1) {
                stb.erase({b[id] + w[id], id});
                int id2 = stb.rbegin()->S;
                stb.erase({b[id2] + w[id2], id2});
                st.erase({w[id2] + b[id2], id2});
                if (stw.count({b[id2] + w[id2], id2})) stw.erase({b[id2] + w[id2], id2});
                b[id2]--;
                if (b[id2]) stb.insert({b[id2] + w[id2], id2});
                if (w[id2]) stw.insert({b[id2] + w[id2], id2});
                if (w[id2] + b[id2]) st.insert({w[id2] + b[id2], id2});
                black_edges.emplace_back(id, id2);
            }
        }
        if (!ok) {
            cout << "No\n";
        } else {
            cout << "Yes\n";
            for (auto it : white_edges) {
                cout << it.F << ' ' << it.S << " W\n";
            }
            for (auto it : black_edges) {
                cout << it.F << ' ' << it.S << " B\n";
            }
        }
    }
}