#include <bits/stdc++.h>

using namespace std;

#ifdef DEBUG
#define DEB 1
#else
#define DEB 0
#define cerr \
  if (DEB)   \
  cerr
#endif
#define MTEST() \
  int _t;       \
  cin >> _t;    \
  for (int _tn = 0; _tn < _t; ++_tn)
#define ALL(c) c.begin(), c.end()
#define SZ(c) (int)c.size()

typedef long long ll;

void run_solve();

signed main() {
#if DEB
  assert(freopen("test.in", "r", stdin));
  assert(freopen("test.out", "w", stdout));
#endif
  ios_base::sync_with_stdio(false);
  cin.tie(NULL);
  cerr.precision(3);
  cerr << fixed;
  int start = (int)clock();
  run_solve();
  double run_time = (double)(clock() - start) / CLOCKS_PER_SEC;
  cerr << "TIME: " << run_time << '\n';
  return 0;
}

const int N = 10;

int ip(int x, int y) {
  return pow(x, y);
}

int f(int x, int y) {
  // return x + y; // 0 0 0
  // return -ip(8 - (x * x + y * y), 2); // 1 8 0
  // return ip(8 - (x * x + y * y), 2); // 8 1 0
  // return ip(8 - ip(x + y, 2), 2);  // 32 19 0
  // return 1; // 0 0 441
  // return ip(8 - (x * x + y * y), 2) * (x - 1) * (x - 2); // 3 1 42
  // return -ip(8 - (x * x + y * y), 2) * (x - 1) * (x - 2);  // 1 3 42
  // return ip(8 - ip(x + y, 2), 2) * x * (x + 1);  // 24 5 42
}

int dx[4] = {-1, +1, 0, 0};
int dy[4] = {0, 0, -1, +1};

int minima() {
  int res = 0;
  for (int x = -N + 1; x < N; ++x) {
    for (int y = -N + 1; y < N; ++y) {
      int flag = 1;
      for (int k = 0; k < 4; ++k) {
        int i = x + dx[k];
        int j = y + dy[k];
        flag &= (f(x, y) < f(i, j));
      }
      res += flag;
      if (flag) {
        // cout << x << ' ' << y << '\n';
      }
    }
  }
  return res;
}

int maxima() {
  int res = 0;
  for (int x = -N + 1; x < N; ++x) {
    for (int y = -N + 1; y < N; ++y) {
      int flag = 1;
      for (int k = 0; k < 4; ++k) {
        int i = x + dx[k];
        int j = y + dy[k];
        flag &= (f(x, y) > f(i, j));
      }
      res += flag;
      if (flag) {
        // cout << x << ' ' << y << '\n';
      }
    }
  }
  return res;
}

int plaute() {
  int res = 0;
  for (int x = -N; x <= N; ++x) {
    for (int y = -N; y <= N; ++y) {
      int flag = 0;
      for (int k = 0; k < 4; ++k) {
        int i = x + dx[k];
        int j = y + dy[k];
        flag |= (i >= -N && i <= N && j >= -N && j <= N && f(x, y) == f(i, j));
      }
      res += flag;
    }
  }
  return res;
}

void run_solve() {
  // return x + y; // 0 0 0
  // return ip(8 - (x * x + y * y), 2); // 8 1 0
  // return -ip(8 - (x * x + y * y), 2); // 1 8 0
  // return ip(8 - ip(x + y, 2), 2);  // 32 19 0
  // return 1; // 0 0 441
  // return ip(8 - (x * x + y * y), 2) * (x - 1) * (x - 2); // 3 1 42
  // return -ip(8 - (x * x + y * y), 2) * (x - 1) * (x - 2);  // 1 3 42
  // return ip(8 - ip(x + y, 2), 2) * x * (x + 1);  // 24 5 42
  // cout << "minima " << minima() << '\n';
  // cout << "maxima " << maxima() << '\n';
  // cout << "plaute " << plaute() << '\n';
  string a, b, c;
  // cin >> a >> b >> c;
  getline(cin, a);
  getline(cin, b);
  getline(cin, c);
  int flag[3] = {a.back() == 's', b.back() == 's', c.back() == 's'};
  int x = (flag[0] * 2 + flag[1] + flag[2] * 4);
  if (x == 0) {
    cout << "x y +\n";
  } else if (x == 1) {
    cout << "8 x x * y y * + - 2 ^\n";
  } else if (x == 2) {
    cout << "0 8 x x * y y * + - 2 ^ -\n";
  } else if (x == 3) {
    cout << "8 x y + 2 ^ - 2 ^\n";
  } else if (x == 4) {
    cout << "1\n";
  } else if (x == 5) {
    cout << "8 x x * y y * + - 2 ^ x 1 - * x 2 - *\n";
  } else if (x == 6) {
    cout << "0 8 x x * y y * + - 2 ^ - x 1 - * x 2 - *\n";
  } else {
    cout << "8 x x * y y * + - 2 ^ x * x 1 + *\n";
  }
}