﻿#define _CRT_SECURE_NO_WARNINGS
#include <bits/stdc++.h>
#include <unordered_map>
#include <random>
#include <chrono>
using namespace std;

#define X real()
#define Y imag()
#define endl '\n'
#define int long long
#define all(X) (X).begin(), (X).end()
#define rall(X) (X).rbegin(), (X).rend()
mt19937_64 rnd(chrono::system_clock::now().time_since_epoch().count());
int gcd(int a, int b) { return b ? gcd(b, a % b) : a; }
int lcm(int a, int b) { return a * b / gcd(a, b); }

int ans = 0, n, k;

struct node {
	int term = 0;
	node* edges[26];
};

int dfs(node* v, bool is_root = 0) {
	int sum = v->term;
	vector<int> order;
	for (int i = 0; i < 26; i++) {
		if (v->edges[i] == nullptr)
			continue;
		int s = dfs(v->edges[i]);
		if (s == 0) continue;
		order.push_back(s);
		sum += s;
	}
	if (sum > k) {
		if (is_root) {
			int have = k, add = order.size();
			sort(all(order));
			for (int i = 0; i < order.size(); i++) {
				if (have >= order[i]) {
					have -= order[i];
					add--;
				}
			}
			ans += add + 1;
		}
		else ans += order.size();
		return v->term;
	}
	else return sum;
}

signed main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0), cout.tie(0);
//#ifndef ONLINE_JUDGE
//	freopen("input.txt", "r", stdin);
//#endif

	cin >> n >> k;
	vector<string> s(n);
	for (auto &i : s)
		cin >> i;

	node* root = new node();
	for (int i = 0; i < n; i++) {
		node *cur = root;
		for (int j = 0; j < s[i].size(); j++) {
			if (cur->edges[s[i][j] - 'a'] == nullptr)
				cur->edges[s[i][j] - 'a'] = new node();
			cur = cur->edges[s[i][j] - 'a'];
		}
		cur->term++;
	}
	int res = dfs(root, 1);
	if (res > 0) ans++;
	cout << ans;
	return 0;
}