#include <iostream>
#include <cstdio>
#include <vector>
#include <map>
#include <set>
#include <queue>
#include <cstdlib>
#include <cmath>
#include <cstring>
#include <string>
#include <algorithm>
#include <stack>
#include <deque>
#include <list>
#include <ctime>
#include <iomanip>
#include <fstream>
#include <unordered_map>
#include <unordered_set>
#include <bitset>
#include <cassert>

#define sqr(a) ((a)*(a))
#define sz(s) ((int)(s.size()))
#define x first
#define y second
#define mp make_pair
#define pb push_back
#define int long long
//#define endl '\n'

using namespace std;


typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef double dd;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef pair<ld, ld> pld;

const int N = 1e6 + 10;
//const int M = 1e3 + 9;
const int INFINT = 1e9 + 9;
const ll INFLL = 1e18 + 9;
const ld EPS = 1e-6;
const dd pi = acos(-1);

vector<pair<int, int> > g[100005];

signed main() {
#ifdef LOCAL
    freopen(R"(/Users/georgymuratidi/Documents/c/cmake-build-debug/input.txt)", "r", stdin);
    freopen(R"(/Users/georgymuratidi/Documents/c/cmake-build-debug/output.txt)", "w", stdout);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < m; i++) {
        int v, u, c;
        cin >> v >> u >> c;
        v--, u--;
        g[v].pb({u, c});
        g[u].pb({v, c});
    }
    vector<int> maxs(n, 0);
    vector<int> mins(n, INFINT);
    vector<int> d(n, 0);
    vector<int> used(n, 0);
    queue<int> qu;
    qu.push(0);
    used[0] = 1;
    while (!(qu.empty())) {
        int v = qu.front();
        qu.pop();
        for (int i = 0; i < g[v].size(); i++) {
            int to = g[v][i].x;
            int sz = g[v][i].y;
            if (!(used[to])) {
                used[to] = 1;
                qu.push(to);
                d[to] = d[v] + 1;
            } else if (d[to] == d[v] - 1) {
                mins[v] = min(mins[v], min(mins[to], sz));
                maxs[v] = max(maxs[v], max(maxs[to], sz));
            }
        }
    }
    cout << d[n - 1] << endl;
//    for(int i = 0; i < n; i++)
//        cout << i + 1 << " " << maxs[i] <<  " " << mins[i] << endl;
    vector<int> maxs1(n, 0);
    vector<int> mins1(n, INFINT);
    vector<int> d1(n, 0);
    used.assign(n, 0);
    qu.push(n - 1);
    used[n - 1] = 1;
    while (!(qu.empty())) {
        int v = qu.front();
        qu.pop();
        for (int i = 0; i < g[v].size(); i++) {
            int to = g[v][i].x;
            int sz = g[v][i].y;
            if (!(used[to])) {
                used[to] = 1;
                qu.push(to);
                d1[to] = d1[v] + 1;
            } else if (d1[to] == d1[v] - 1) {
                mins1[v] = min(mins1[v], min(mins1[to], sz));
                maxs1[v] = max(maxs1[v], max(maxs1[to], sz));
            }
        }
    }
//    for(int i = 0; i < n; i++)
//        cout << i + 1 << " " << maxs[i] <<  " " << mins[i] << " " << maxs1[i] << " " << mins1[i] << endl;
    int ansv = 0;
    int maxc = 0;
    for (int i = 1; i < n - 1; i++) {
        if (d[i] + d1[i] == d[n - 1] && maxc < max(abs(maxs[i] - mins1[i]), abs(maxs1[i] - mins[i]))) {
            ansv = i;
            maxc = max(abs(maxs[i] - mins1[i]), abs(maxs1[i] - mins[i]));
        }
    }
    //cout << ansv << " " << maxc << endl;

    bool b = (maxc == abs(maxs[ansv] - mins1[ansv]));

    vector<int> route;
    int curv = ansv;
    while (curv != 0) {
        for (int i = 0; i < g[curv].size(); i++) {
            int to = g[curv][i].x;
            int sz = g[curv][i].y;
            bool check = false;
            if (b) {
                check = (maxs[to] == maxs[curv] || sz == maxs[curv]);
            } else {
                check = (mins[to] == mins[curv] || sz == mins[curv]);
            }
            if (d[to] == d[curv] - 1 && check) {
                route.push_back(curv);
                curv = to;
                break;
            }
        }
    }
    route.push_back(0);
    reverse(route.begin(), route.end());

    curv = ansv;
    while (curv != n - 1) {
        for (int i = 0; i < g[curv].size(); i++) {
            int to = g[curv][i].x;
            int sz = g[curv][i].y;
            bool check = false;
            if (!b) {
                check = (maxs1[to] == maxs1[curv] || sz == maxs1[curv]);
            } else {
                check = (mins1[to] == mins1[curv] || sz == mins1[curv]);
            }
            if (d1[to] == d1[curv] - 1 && check) {
                curv = to;
                route.push_back(curv);
                break;
            }
        }
    }

    for (int i = 0; i < route.size(); i++) {
        cout << route[i] + 1 << " ";
    }
}