#include <bits/stdc++.h>

using namespace std;
#define pii pair <int, int>
#define w first
#define b second

/* struct e {
    int w, b, ind;
}; */


void solve() {
    int n; cin >> n;
    if (n == 1) {
        int a, b; cin >> a >> b;
        if (a == 0 && b == 0) {
            cout << "Yes\n";
        } else {
            cout << "No\n";
        }
        return; // sorry
    }

    vector <pii> e(n);

    set <int> leaves;
    set <int> not_leaves_b, not_leaves_w;

    for (int i = 0; i < n; ++i) {
        cin >> e[i].w >> e[i].b;
        if (e[i].w + e[i].b == 1) {
            leaves.insert(i);
        } else {
            if (e[i].w > 0) {
                not_leaves_w.insert(i);
            }
            if (e[i].b > 0) {
                not_leaves_b.insert(i);
            }
        }
    }

    vector <pii> ans;
    vector <char> col;

    while (ans.size() < n - 2) {
        if (leaves.empty()) {
            cout << "No\n"; return;
        }
        auto leaf_i = *leaves.begin();
        leaves.erase(leaves.begin());
        int leaf_col = (e[leaf_i].b == 1);

        if (leaf_col == 0) {
            if (not_leaves_w.empty()) {
                cout << "No\n"; return;
            }

            auto not_leaf_i = *not_leaves_w.begin();
            not_leaves_w.erase(not_leaves_w.begin());
            not_leaves_b.erase(not_leaf_i);

            ans.push_back({leaf_i, not_leaf_i});
            col.push_back('W');


            int i = not_leaf_i;
            e[i].w--;

            if (e[i].w + e[i].b == 1) {
                leaves.insert(i);
            } else {
                if (e[i].w > 0) {
                    not_leaves_w.insert(i);
                }
                if (e[i].b > 0) {
                    not_leaves_b.insert(i);
                }
            }
        } else {
            if (not_leaves_b.empty()) {
                cout << "No\n"; return;
            }

            auto not_leaf_i = *not_leaves_b.begin();
            not_leaves_b.erase(not_leaves_b.begin());
            not_leaves_w.erase(not_leaf_i);

            ans.push_back({leaf_i, not_leaf_i});
            col.push_back('B');


            int i = not_leaf_i;
            e[i].b--;

            if (e[i].w + e[i].b == 1) {
                leaves.insert(i);
            } else {
                if (e[i].w > 0) {
                    not_leaves_w.insert(i);
                }
                if (e[i].b > 0) {
                    not_leaves_b.insert(i);
                }
            }
        }
    }

    if (leaves.size() != 2 || !not_leaves_w.empty() || !not_leaves_b.empty()) {
        cout << "No\n"; return;
    }
    auto leaf_1 = *leaves.begin();
    leaves.erase(leaves.begin());
    auto leaf_2 = *leaves.begin();
    int leaf_1_col = (e[leaf_1].b == 1);
    int leaf_2_col = (e[leaf_2].b == 1);
    if (leaf_1_col != leaf_2_col) {
        cout << "No\n"; return;
    }

    ans.push_back({leaf_1, leaf_2});
    col.push_back(leaf_1_col ? 'B' : 'W');

    cout << "Yes\n";
    for (int i = 0; i + 1 < n; ++i) {
        cout << ans[i].w + 1 << ' ' << ans[i].b + 1 << ' ' << col[i] << '\n';
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
    int t; cin >> t;

    while (t--) {
        solve();
    }
}
