//#pragma GCC optimize("Ofast")
//#pragma GCC optimize("O4")

#include <bits/stdc++.h>

using namespace std;

using ll = long long int;
using ld = long double;
using ui = unsigned int;
using ull = unsigned long long;
using pp = pair<int, int>;
using tt = tuple<int, int, int>;

const int inf = (int) 1e9 + 1;
const int mod = 998244353;
//const ll inf = (ll) 1e18;


#define umap unordered_map
#define uset unordered_set
#define Power ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
#define all(x) (x).begin(), (x).end()
#define pb push_back


template<typename T>
T gcd(T a, T b) {
    return b ? gcd(b, a % b) : a;
}

template<typename T>
T lcm(T a, T b) {
    return a * b / gcd(a, b);
}

mt19937_64 mers((random_device()) ());

void solve() {

    int t;
    cin >> t;
    vector<vector<pair<string, int>>> q(t);
    int cnt = 0;
    for (int i = 0; i < t; i++) {
        int k;
        cin >> k;
        q[i].resize(k);
        for (int j = 0; j < k; j++) {
            string s;
            char c;
            while (true) {
                cin >> c;
                if (c == '=') {
                    break;
                } else {
                    s.push_back(c);
                }
            }
            int val;
            cin >> val;
            q[i][j] = {s, val};
            cnt++;
        }
    }
    int k;
    cin >> k;
    map<string, int> cur;
    for (int i = 0; i < k; i++) {
        string s;
        int val;
        cin >> s >> val;
        cur[s] = val;
    }

    vector<int> ans;

    while (ans.size() < cnt) {
        bool found = false;
        for (int i = 0; i < t; i++) {
            if (q[i].empty())
                continue;
            auto [k, v] = q[i].back();
            if (cur[k] == v) {
                found = true;
                ans.push_back(i);
                q[i].pop_back();
                cur.erase(k);
                break;
            }
        }
        if (!found) {
            cout << "No\n";
            return;
        }
        for (int i = 0; i < t; i++) {
            while (!q[i].empty() && cur.count(q[i].back().first) == 0) {
                ans.push_back(i);
                q[i].pop_back();
            }
        }
    }

    cout << "Yes\n";
    for (int i = cnt - 1; i >= 0; i--) {
        cout << ans[i] + 1 << " ";
    }

}


signed main() {

    Power;


#ifdef _DEBUG
    (void) freopen("input.txt", "r", stdin);
    (void) freopen("output.txt", "w", stdout);
#else
    //  (void)freopen("lwdb.in", "r", stdin);
    //  (void)freopen("lwdb.out", "w", stdout);
#endif

    int queue_counter = 1;
//    cin >> queue_counter;
    while (queue_counter--) {
        solve();
    }

    return 0;
}