#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int inf = 1000000001;
    int n, k;
    cin >> n >> k;
    vector<vector<pair<int, int>>> edges(n + 1, vector<pair<int, int>>());
    vector<int> best_diff(n + 1, -1);
    best_diff[1] = 0;
    vector<int> min_edge(n + 1, inf);
    vector<int> max_edge(n + 1, -inf);
    vector<int> depth(n + 1, inf);
    vector<bool> used(n + 1, false);
    queue<int> q;
    depth[1] = 0;
    q.push(1);
    for (int i = 0; i < k; ++i) {
        int a, b, x;
        cin >> a >> b >> x;
        edges[a].push_back({b, x});
        edges[b].push_back({a, x});
    }
    vector<int> rev_mn_e(n + 1, -1);
    vector<int> rev_mx_e(n + 1, -1);
    vector<int> rev_bd(n + 1, -1);
    vector<int> rev_tp(n + 1, -1);
    while (!q.empty()) {
        int v = q.front();
        q.pop();
        if (used[v]) continue;
        used[v] = true;
//        cout << v << " " << depth[v] << " " << best_diff[v] << " " << min_edge[v] << " " << max_edge[v] << " " << rev_tp[v] << " " << rev_bd[v] <<  " " << rev_mn_e[v] <<  " " << rev_mx_e[v] << endl;
        for (auto p : edges[v]) {
            int to = p.first;
            int c = p.second;
            if (!used[to] && (depth[to] == inf || depth[to] == depth[v] + 1)) {
                depth[to] = depth[v] + 1;
//                cout << "update " << to << " " << best_diff[to] << " " << c << endl;

                int n_mx_e = max(max_edge[v], c);
                if (n_mx_e > max_edge[to]) {
                    max_edge[to] = n_mx_e;
                    rev_mx_e[to] = v;
                }

                int n_mn_e = min(min_edge[v], c);
                if (n_mn_e < min_edge[to]) {
                    min_edge[to] = n_mn_e;
                    rev_mn_e[to] = v;
                }

                int n_bd = max(c - min_edge[v], max(max_edge[v] - c, best_diff[v]));
                if (n_bd > best_diff[to]) {
                    best_diff[to] = n_bd;
                    rev_bd[to] = v;
                    if (n_bd == best_diff[v]) {
                        rev_tp[to] = 0;
                    } else if (n_bd == max_edge[v] - c) {
                        rev_tp[to] = 1;
                    } else {
                        rev_tp[to] = 2;
                    }
                }
                q.push(to);
            }
        }
    }
    vector<int> ans;
    int cur = n;
    while (cur != 1) {
        ans.push_back(cur);
        cur = rev_bd[cur];
        if (rev_tp[cur] == 1) {
            while (cur != 1) {
                ans.push_back(cur);
                cur = rev_mx_e[cur];
            }
            break;
        } else if (rev_tp[cur] == 2) {
            while (cur != 1) {
                ans.push_back(cur);
                cur = rev_mn_e[cur];
            }
            break;
        }
    }
    cout << ans.size() << endl;
    cout << 1 << " ";
    for (int i = ans.size() - 1; i >= 0; --i) {
        cout << ans[i] << " ";
    }

    return 0;
}
