#include <locale.h>
#include <iostream>
#include <fstream>
#include <algorithm>
#include <vector>
#include <numeric>
#include <iterator>
#include <sstream>
#include <map>
#include <math.h>
#include <stdio.h>
#include <stack>
#include <random>  
#include <ctime>  
#include <queue>
#include <set>
using namespace std;
using ld = long double;
using ll = long long;

ll mod = 1e9 + 7;
int const N = 3e5 + 100;

mt19937 rnd;

ll  random(ll  limit)
{
	uniform_int_distribution <ll > uniform_dist(0, limit);
	return uniform_dist(rnd);
}


ll bpow(ll a, ll p) {
	ll res = 1;
	while (p > 0) {
		if (p % 2) {
			res = res * a % mod;
		}
		a = a * a % mod;
		p /= 2;
	}
	return res;
} 


ll inv(ll a) {
	return bpow(a, mod - 2);
}


void solve() {
	string s1, s2, s3, s4;
	cin >> s1 >> s2 >> s3 >> s4;
	ll ans = 0;
	if (s1 == "AD") ans += stoi(s2);
	else ans -= stoi(s1) - 1;

	if (s3 == "AD") ans -= stoi(s4);
	else ans += stoi(s3) - 1;

	cout << abs(ans) << '\n';
}



int main()
{
	ios::sync_with_stdio(false);
	cin.tie(0);
	rnd = mt19937(956231);
	int t = 1;
	//cin >> t;

	while (t--) {
		solve();
	}

}

/*

*/