//#pragma GCC optimize("O3")
//#pragma GCC optimize("unroll-loops")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4.1,sse4.2,sse4a,popcnt,abm,mmx,avx,avx2,tune=native")

#include <bits/stdc++.h>

#define ALL(s) (s).begin(), (s).end()
#define rALL(s) (s).rbegin(), (s).rend()
#define sz(s) int((s).size())
#define mkp make_pair
#define pb push_back
#define sqr(s) ((s) * (s))

using namespace std;

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
typedef unsigned int ui;

#ifdef EUGENE
mt19937 rng(1337);
#else
mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
#endif

const ll INF = 1e18;

ll n, m, c;
ll ans_M, ans_C, ans = INF;

void relax_(ll M, ll C) {
    if (M < 0 || C < 0)
        return;
    ll res = abs(M * m + C * c - n);
    if (res < ans) {
        ans = res;
        ans_M = M;
        ans_C = C;
    }
}

void relax(ll M, ll C) {
    for (ll M_ = M - 1; M_ <= M + 1; M_++)
        for (ll C_ = C - 1; C_ <= C + 1; C_++)
            relax_(M_, C_);
}

void solve() {
    cin >> n >> m >> c;
    ll M = 0, C = 0;
    relax(M, C);
    while ((M + 1) * m <= n)
        M++;
    relax(M, C);

    while (M >= 0) {
        while (M * m + (C + 1) * c <= n)
            C++;
        relax(M, C);
        M--;
    }

    cout << ans_M << " " << ans_C << endl;
}

int main() {
    ios::sync_with_stdio(false); cin.tie(0);
//    cout << fixed << setprecision(12);

    int t = 1;
//    cin >> t;
    while (t--)
        solve();
}