#include <bits/stdc++.h>

using namespace std;
using ll = long long;

#define ALL(x) (x).begin(), (x).end()
#define int long long

int n, m, c;

int gcd(int a, int b, int &x, int &y) {
    if (a == 0) {
        x = 0;
        y = 1;
        return b;
    }
    int x1, y1;
    int d = gcd(b % a, a, x1, y1);
    x = y1 - (b / a) * x1;
    y = x1;
    return d;
}

int solve() {
    if (!(cin >> n >> m >> c))
        return 1;
    int x1 = 0, y1 = 0;
    int g = gcd(m, c, x1, y1);
    int best = 1'000'000'000'000'000;
    int bM = 0, bC = 0;
    for (int i = 0; i < 1000; ++i) {
        for (int j = 0; j < 1000; ++j) {
            if (abs(m * i + j * c - n) < best) {
                best = abs(m * i + c * j - n);
                bM = i;
                bC = j;
            }
        }
    }

    int k = n / g;
    for (int dk = -1; dk <= 1; ++dk) {
        int xx1 = x1 * (k + dk), yy1 = y1 * (k + dk);
        while (xx1 < 0) {
            xx1 += (c / g);
            yy1 -= (m / g);
        }
        while (yy1 < 0) {
            xx1 -= (c / g);
            yy1 += (m / g);
        }
        for (int dxx1 = -1; dxx1 <= 1; ++dxx1) {
            for (int dyy1 = -1; dyy1 <= 1; ++dyy1) {
                if (xx1 + dxx1 >= 0 && yy1 + dyy1 >= 0) {
                    int i = xx1 + dxx1, j = yy1 + dyy1;
                    if (abs(m * i + j * c - n) < best) {
                        best = abs(m * i + c * j - n);
                        bM = i;
                        bC = j;
                    }
                }
            }
        }
    }

    cout << bM << ' ' << bC << '\n';


    return 0;
}

signed main() {
#ifdef LOCAL
    freopen("B.in", "r", stdin);
    freopen("B.out", "w", stdout);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int tests = 1e9;
//    cin >> tests;
    for (int i = 1; i <= tests; i++) {
        if (solve())
            break;
#ifdef LOCAL
        cout << "------------------------------\n";
#endif
    }
}
