#include <iostream>
#include <climits>
#include <cstddef>
#include <cmath>
#include <vector>
#include <iomanip>
#include <cassert>
#include <algorithm>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <queue>

using namespace std;

void solve();

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    #ifdef HOME
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
        clock_t start_clock = clock();
    // #else
    //  freopen(".in", "r", stdin);
    //  freopen(".out", "w", stdout);
    #endif
    
    solve();

    #ifdef HOME
        // system("pause");
        printf("\n\nfinished in %.3f sec", static_cast<float>(clock() - start_clock) / CLOCKS_PER_SEC);
    #endif
}

void solve() {
    pair<string, string> date1;    
    pair<string, string> date2;

    cin >> date1.first >> date1.second >> date2.first >> date2.second;

    int64_t first;
    if (date1.first == "AD") {
        first = stoi(date1.second);
    } else {
        first = -stoi(date1.first);
    }

    int64_t second;
    if (date2.first == "AD") {
        second = stoi(date2.second);
    } else {
        second = -stoi(date2.first);
    }

    if (first > second) {
        swap(first, second);
    }

    int64_t ans = 0;
    if (first < 0 && second > 0) {
        ans--;
    }

    cout << ans + second - first;
}
