#include <iostream>
#include <climits>
#include <cstddef>
#include <cmath>
#include <vector>
#include <iomanip>
#include <cassert>
#include <algorithm>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <queue>

using namespace std;

void solve();

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    #ifdef HOME
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
        clock_t start_clock = clock();
    // #else
    //  freopen(".in", "r", stdin);
    //  freopen(".out", "w", stdout);
    #endif
    
    solve();

    #ifdef HOME
        // system("pause");
        printf("\n\nfinished in %.3f sec", static_cast<float>(clock() - start_clock) / CLOCKS_PER_SEC);
    #endif
}

void solve() {
    size_t n, m;
    cin >> n >> m;

    vector<string> t(n);
    for (size_t i = 0; i != n; ++i) {
        cin >> t[i];
    }

    size_t f = 0, q = 0;
    for (size_t j = 0; j + 3 <= m; ++j) {
        for (size_t i = 0; i + 5 <= n; ++i) {
            if (t[i][j] == '#' && t[i][j + 1] == '#' && t[i][j + 2] == '#' &&
                t[i + 1][j] == '#' && 
                t[i + 2][j] == '#' && t[i + 2][j + 1] == '#' &&
                t[i + 3][j] == '#' && 
                t[i + 4][j] == '#') {
                
                ++f;
                t[i][j] = t[i][j + 1] = t[i][j + 2] = t[i + 1][j] = t[i + 2][j] = t[i + 2][j + 1] = t[i + 3][j] = t[i + 4][j] = '.';
            }

            if (t[i][j] == '#' && t[i][j + 1] == '#' && t[i][j + 2] == '#' &&
                t[i + 1][j] == '#' && t[i + 1][j + 2] == '#' &&
                t[i + 2][j] == '#' && t[i + 2][j + 1] == '#' && t[i + 2][j + 2] == '#' && 
                t[i + 3][j + 2] == '#' &&
                t[i + 4][j + 2] == '#') {

                ++q;
                t[i][j] = t[i][j + 1] = t[i][j + 2] = t[i + 1][j] = t[i + 1][j + 2] = t[i + 2][j] = t[i + 2][j + 1] = t[i + 2][j + 2] = t[i + 3][j + 2] = t[i + 4][j + 2] = '.';
            }
        }
    }

    cout << q << ' ' << f;
}
