#include <bits/stdc++.h>

const int MX = 2e9;


struct ttt{
    int value;
    int parent;
};


using namespace std;
int main() {
    ios_base::sync_with_stdio(false);
    int n, m;
    cin >> n >> m;
    vector<vector<pair<int, int>>> gr(n, vector<pair<int, int>>());

    for (int i = 0; i < m; ++i) {
        int x, y, c;
        cin >> x >> y >> c;
        x--, y--;
        gr[x].emplace_back(y, c);
        gr[y].emplace_back(x, c);
    }


    vector<int> dist1(n, MX), dist2(n, MX);

    vector<ttt> mx_1(n, {-MX,  0});
    vector<ttt> mn_1(n, {MX,0});
    vector<ttt> mx_2(n, {-MX,  0});
    vector<ttt> mn_2(n, {MX,0});

    queue<int> q;
    q.push(0);
    dist1[0] = 0;
    while(!q.empty()) {
        auto t = q.front();
        q.pop();
        for (auto v: gr[t]) {
            if (dist1[v.first] == MX) {
                q.push(v.first);
                dist1[v.first] = dist1[t] + 1;
            }
            if (dist1[v.first] != dist1[t] + 1) {
                continue;
            }
            if (mx_1[v.first].value < max(mx_1[t].value, v.second)) {
                mx_1[v.first].value = max(mx_1[t].value, v.second);
                mx_1[v.first].parent = t;
            }
            if (mn_1[v.first].value > min(mn_1[t].value, v.second)) {
                mn_1[v.first].value = min(mn_1[t].value, v.second);
                mn_1[v.first].parent = t;
            }
        }
    }

    q.push(n - 1);
    dist2[n - 1] = 0;
    while(!q.empty()) {
        auto t = q.front();
        q.pop();
        for (auto v: gr[t]) {
            if (dist2[v.first] == MX) {
                q.push(v.first);
                dist2[v.first] = dist2[t] + 1;
            }
            if (dist2[v.first] != dist2[t] + 1) {
                continue;
            }
            if (mx_2[v.first].value < max(mx_2[t].value, v.second)) {
                mx_2[v.first].value = max(mx_2[t].value, v.second);
                mx_2[v.first].parent = t;
            }
            if (mn_2[v.first].value > min(mn_2[t].value, v.second)) {
                mn_2[v.first].value = min(mn_2[t].value, v.second);
                mn_2[v.first].parent = t;
            }
        }
    }

    int best_v = 0;
    int type = 1;
    int64_t score = 0;

    for (int i = 1; i < n - 1; ++i) {
        if (int64_t(mx_1[i].value) - int64_t(mn_2[i].value) > score) {
            score = int64_t(mx_1[i].value) - int64_t(mn_2[i].value);
            best_v = i;
            type = 1;
        }
        if (int64_t(mx_2[i].value) - int64_t(mn_1[i].value) > score) {
            score = int64_t(mx_2[i].value) - int64_t(mn_1[i].value);
            best_v = i;
            type = 2;
        }
    }
    vector<int> ans;
    int cp = best_v;
    while (cp != 0) {
        ans.push_back(cp);
        if (type == 1) {
            cp = mx_1[cp].parent;
        } else {
            cp = mn_1[cp].parent;
        }
    }
    ans.push_back(0);
    reverse(ans.begin(), ans.end());

    cp = best_v;
    while (cp != n - 1) {
        if (type == 1) {
            cp = mn_2[cp].parent;
        } else {
            cp = mx_2[cp].parent;
        }
        ans.push_back(cp);
    }

    cout << ans.size() - 1 << '\n';
    for (auto x : ans) {
        cout << x + 1 << ' ';
    }




















    return 0;
}
