#include <iostream>
#include <algorithm>
#include <vector>
#include <iomanip>
#include <map>
#include <set>
#include <fstream>
#include <string>
#include <bitset>
#include <ctime>
#include <random>
#include <iterator>
#include <cmath>
#include <deque>
#include <queue>

using namespace std;

ifstream fin("input.txt");
ofstream fout("output.txt");

using ll = long long;
using ld = long double;
using ull = unsigned long long;

ll const inf = 1e18;

random_device rd;
mt19937 mersenne(rd());

ll toll(string s)
{
	ll ans = 0;
	ll d = 1;
	while (!s.empty())
	{
		ans += (s.back() - '0') * d;
		d *= 10;
		s.pop_back();
	}
	return ans;
}

signed main()
{
	ios::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	string x1, t1, x2,t2;
	cin >> x1 >> t1 >> x2>>t2;
	ll y1 = 0, y2 = 0;
	if (x1 == "AD")
	{
		y1 = toll(t1);
	}
	else
		y1 = 1 - toll(x1);


	if (x2 == "AD")
	{
		y2 = toll(t2);
	}
	else
		y2 = 1 - toll(x2);

	cout << abs(y1 - y2) << '\n';

	return 0;
}