#include <bits/stdc++.h>
using namespace std;

struct Edge{
  long long from,to,color;
};

vector<vector<Edge>> C;
vector<Edge> E;

long long M_left[100005];
long long M_right[100005];
long long U[100005];
long long Dist[100005];
long long Parent[100005];
long long Right_Parent[100005];

queue<int> Q;
long long mark = 1;


int main(){
  int n,m;
  cin >> n >> m;
  C.resize(n+1);
  for(int i = 0; i<m; i++){
    long long x,y,z;
    cin >> x >> y >> z;
    E.push_back({x, y, z});
    C[x].push_back({x, y, z});
    C[y].push_back({y, x, z});
  }

  for(int i = 0; i<=n; i++){
    Dist[i] = 20000000000;
    M_left[i] = 2000000000;
    M_right[i] = 2000000000;
    Parent[i] = -1;
    Right_Parent[i] = -1;
    U[i] = 0;
  }

  Parent[1] = 1;
  Right_Parent[n] = n;

  Q.push(1);
  U[1] = mark;
  Dist[1] = 0;

  while(!Q.empty()){
    int cur = Q.front();
    Q.pop();
    if(Dist[cur] < Dist[n]){
      for(auto e:C[cur]){
        if(U[e.to] != mark){
          Dist[e.to] = Dist[cur]+1;
          Q.push(e.to);
          U[e.to] = mark;
        }
        if(Dist[e.to] == Dist[cur]+1 && M_left[e.to] >= min(e.color, M_left[cur])){
          Parent[e.to] = cur;
          M_left[e.to] = min(e.color, M_left[cur]);
        }
      }
    }
  }

  mark++;
  U[n] = mark;
  Q.push(n);

  while(!Q.empty()){
    int cur = Q.front();
    Q.pop();
    if(Dist[cur] < Dist[n]){
      for(auto e:C[cur]){
        if(U[e.to] != mark){
          Q.push(e.to);
          U[e.to] = mark;
        }
        if(Dist[e.to] == Dist[cur]-1 && M_right[e.to] >= min(e.color, M_right[cur])){
          Right_Parent[e.to] = cur;
          M_right[e.to] = min(e.color, M_right[cur]);
        }
      }
    }
  }

  long long ans = -1, left = -1, right = -1;
  for(auto e:E){
    if((Right_Parent[e.from] != -1 && Right_Parent[e.to] != -1) &&  (Parent[e.from] != -1 && Parent[e.to] != -1) && Dist[e.from] <= Dist[n] && Dist[e.to] <= Dist[n] && abs(Dist[e.from] - Dist[e.to]) == 1){
      long long kek, lol;
      if(Dist[e.to] < Dist[e.from]){
        long long hehe = M_left[e.to], hoho = M_right[e.from];
        if(e.to == 1){
          hehe = e.color;
        }
        if(e.from == n){
          hoho = e.color;
        }
        kek = min(hehe, hoho);
        lol = max(hehe, hoho);
      } else {
        long long hehe = M_left[e.from], hoho = M_right[e.to];
        if(e.from == 1){
          hehe = e.color;
        }
        if(e.to == n){
          hoho = e.color;
        }
        kek = min(hehe, hoho);
        lol = max(hehe, hoho);
      }
      if(e.color - kek >= ans && e.color >= lol){
        ans = e.color - kek;
        left = e.from;
        right = e.to;
      }
    }
  }

  cout << Dist[n] << '\n';

  if(Dist[left] > Dist[right]){
    swap(left, right);
  }

  vector<int> Ans;
  Ans.push_back(left);
  while(Parent[left] != left){
    Ans.push_back(Parent[left]);
    left = Parent[left];
  }
  //cout << 1 << ' ';
  for(int i = Ans.size()-1; i>=0; i--){
    cout << Ans[i] << ' ';
  }
  Ans.clear();
  Ans.push_back(right);
  while(Right_Parent[right] != right){
    Ans.push_back(Right_Parent[right]);
    right = Right_Parent[right];
  }
  for(auto x:Ans){
    cout << x << ' ';
  }
  //cout << n << ' ';


  return 0;
}