#include<iostream>
#include<vector>

using namespace std;
vector<vector<int>> grid;

bool check_q(int x, int y) {
    if (x < 4 or y < 2) {
        return false;
    }
    static vector<pair<int, int>> moves = {{0,  0},
                                           {-1, 0},
                                           {-2, 0},
                                           {-3, 0},
                                           {-4, 0},
                                           {-2, -1},
                                           {-2, -2},
                                           {-3, -2},
                                           {-4, -1},
                                           {-4, -2}};
    for (auto move:moves) {
        if (grid[x + move.first][y + move.second] != 1) {
            return false;
        }
    }
    return true;
}

bool check_f(int x, int y) {
    if (x < 4 or y > grid[0].size() - 2) {
        return false;
    }
    static vector<pair<int, int>> moves = {{0,  0},
                                           {-1, 0},
                                           {-2, 0},
                                           {-3, 0},
                                           {-4, 0},
                                           {-2, 1},
                                           {-4, 1},
                                           {-4, 2}};
    for (auto move:moves) {
        if (grid[x + move.first][y + move.second] != 1) {
            return false;
        }
    }

    return true;
}
int fff = 0;
int qqq = 0;
void fill_f(int x, int y){
    static vector<pair<int, int>> moves = {{0,  0},
                                           {-1, 0},
                                           {-2, 0},
                                           {-3, 0},
                                           {-4, 0},
                                           {-2, 1},
                                           {-4, 1},
                                           {-4, 2}};

    for (auto move:moves) {
        grid[x + move.first][y + move.second] = 2;
    }
    fff++;
}

void fill_q(int x, int y){
    static vector<pair<int, int>> moves = {{0,  0},
                                           {-1, 0},
                                           {-2, 0},
                                           {-3, 0},
                                           {-4, 0},
                                           {-2, -1},
                                           {-2, -2},
                                           {-3, -2},
                                           {-4, -1},
                                           {-4, -2}};
    for (auto move:moves) {
        grid[x + move.first][y + move.second] = 2;
    }
    qqq++;
}
int main() {
    int n, m;
    cin >> n >> m;
    grid = vector<vector<int>>(n, vector<int>(m));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            char c;
            cin >> c;
            grid[i][j] = (c == '#');
        }
    }
    bool flag = true;
    while(flag){
        flag = false;
        for(int i = 0; i < n; i++){
            for(int j = 0; j < m; j++){
                if(check_f(i, j) and not check_q(i, j)){fill_f(i, j); flag = true;}
                if(check_q(i, j) and not check_f(i, j)){fill_q(i, j);flag = true;}
            }
        }
    }
    cout<<qqq<<" "<<fff;
    return 0;
}