#include <bits/stdc++.h>
using namespace std;

#define FASTIO

// #define FILEINPUT
// #define FILEOUTPUT

// #define MULTITEST

#define int long long

const int inf = 2e9 + 5;
const int mod = 1e9 + 7;
const double eps = 1e-12;

struct node{
	map<char, node*> children;
	node *parent;
	int sz = 0;
	// string deb = "";
};

node startNode;

bool isGo(node *cur, char c){
	return cur -> children.count(c);
}

void go(node *&cur, char c){
	cur = cur -> children[c];
}

void addNode(node *cur, char c){
	cur -> children[c] = new node;
	cur -> children[c] -> parent = cur;
}

void addWord(string s){

	node *cur = &startNode;

	// string deb = "";

	for (char c : s){
		// deb += c;
		cur -> sz++;
		if (!isGo(cur, c)){
			addNode(cur, c);
		}
		go(cur, c);
		// cur -> deb = deb;
	}

	cur -> sz++;

}

void solve(int numTest = 1, int cntTests = 1){

	int n, k;
	cin >> n >> k;

	for (int i = 0; i < n; i++){
		string s;
		cin >> s;
		addWord(s);
	}

	set<pair<int, node*>> s;

	queue<node *> q;
	q.push(&startNode);

	while(q.size()){
		node *cur = q.front();
		q.pop();
		if (cur -> sz <= k){
			s.insert({cur -> sz, cur});
			// cout << "a " << cur -> deb << '\n';
			continue;
		}
		for (auto e : cur -> children){
			q.push(e.second);
		}
	}

	int ans = 0;

	while(s.size()){

		auto it = --(s.end());
		node *cur = it -> second;
		// cout << "b " << cur -> deb << '\n';
		s.erase(it);

		node *last = cur;

		int kek = cur -> sz;

		while (true){
			if (cur -> parent == NULL){
				break;
			}
			cur -> parent -> sz -= kek;
			if (cur -> parent -> sz > k){
				break;
			}
			cur = cur -> parent;
			for (auto e : cur -> children){
				s.erase({e.second -> sz, e.second});
			}
		}

		if (last != cur){
			s.insert({cur -> sz, cur});
		}

		ans++;

	}

	cout << ans;

}

signed main(){

	srand(time(NULL));
	cout << setprecision(10) << fixed;

	#ifdef FASTIO
		ios_base::sync_with_stdio(NULL);
		cin.tie(NULL);
		cout.tie(NULL);
	#endif

	#ifdef FILEINPUT
		freopen("main.in", "r", stdin);
	#endif
	#ifdef FILEOUTPUT
		freopen("main.out", "w", stdout);
	#endif

	#ifdef MULTITEST
		int cntTests;
		cin >> cntTests;
		for (int numTest = 1; numTest <= cntTests; numTest++){
			solve(numTest, cntTests);
			cout << '\n';
		}
	#else
		solve();
	#endif

}