#include <iostream>
#include <iomanip>
#include <fstream>
#include <cstdio>
#include <cmath>
#include <cstring>
#include <ctime>
#include <algorithm>
#include <random>
#include <vector>
#include <string>
#include <queue>
#include <deque>
#include <list>
#include <set>
#include <map>
#include <bitset>
#include <unordered_set>
#include <unordered_map>
#include <chrono>
#include <cassert>
#include <cstdint>
#include <cstddef>
#include <utility>
#include <functional>
#include <stdexcept>

#define FILE 0
#define RANDOM 0

using namespace std;

#if RANDOM
const unsigned seed = (unsigned)chrono::system_clock::now().time_since_epoch().count();
mt19937 rnd(seed);
#endif

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef ll typ;
typedef unsigned int ui;

const int N = 1e6 + 1, K = 26, M = 1000;
const ll INF = 5e18 + 3;
const ld EPS = 5e-7, PI = acos(-1);
const int MOD = 998244353, INFI = 2e9 + 7, SQ = 50;
const ull A = 239, P = 1e9 + 9;

int n, m;
bool a[M][M];

void print() {
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cout << a[i][j];
        }
        cout << endl;
    }
    cout << endl;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

#if FILE
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    cin >> n >> m;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            char c;
            cin >> c;
            a[i][j] = (c == '#');
        }
    }
    int f = 0, q = 0;
    for (int j = m - 1; j >= 0; j--) {
        for (int i = 0; i < n; i++) {
            if (a[i][j]) {
                if (i < n && a[i + 1][j]) {
                    q++;
                    a[i][j] = 0;
                    a[i + 1][j] = 0;
                    a[i + 2][j] = 0;
                    a[i + 3][j] = 0;
                    a[i + 4][j] = 0;
                    a[i][j - 1] = 0;
                    a[i + 2][j - 1] = 0;
                    a[i][j - 2] = 0;
                    a[i + 1][j - 2] = 0;
                    a[i + 2][j - 2] = 0;
                } else {
                    f++;
                    a[i][j] = 0;
                    a[i][j - 1] = 0;
                    a[i + 2][j - 1] = 0;
                    a[i][j - 2] = 0;
                    a[i + 1][j - 2] = 0;
                    a[i + 2][j - 2] = 0;
                    a[i + 3][j - 2] = 0;
                    a[i + 4][j - 2] = 0;
                }
                //print();
            }
        }
    }
    cout << q << ' ' << f << endl;

#if FILE
    fclose(stdin);
    fclose(stdout);
#endif

    return 0;
}