#include <iostream>
#include <algorithm>
#include <vector>
#include <iomanip>
#include <set>
#include <map>
#include <queue>
using namespace std;

long long min(long long a, long long b) {
	if ( a < b) 
		return a;
	return b;
}

long long max(long long  a, long long b) {
	if (a > b) {
		return a;
	}
	return b;
}

void solve() {
	int n, m;
	cin >> n >> m;
	vector<vector<pair<int, long>>> g(n);
	for (int i = 0; i < m; i++) {
		int l, r;
		long long c;
		cin >> l >> r >> c;
		l--;
		r--;
		g[l].push_back({r, c});
		g[r].push_back({l, c});
	}
	queue<int> q;
	vector<int> traverse;
	vector<int> color(n, -1);
	vector<int> pred(n, -1);
	vector<long long> minn(n, 100000000000000);
	vector<long long> maxx(n, -100000000000000);
	vector<long long> minmax(n, -1000000000000);
	q.push(0);
	color[0] = 0;

	while(!q.empty()) {
		int curr = q.front();
		//cout << endl << "I'm in " << curr << endl;
		q.pop();
		for (int i = 0; i < g[curr].size(); i++) {
			int next = g[curr][i].first;
			//cout << endl <<  "Next " << next << endl;
			if (color[next] == -1) {
				color[next] = color[curr] + 1;
				pred[next] = curr;
				traverse.push_back(next);
				q.push(next);
				pred[next] = curr;
				minn[next] = min(g[curr][i].second, minn[curr]);
				maxx[next] = max(g[curr][i].second, maxx[curr]);
				minmax[next] = max(minmax[curr], max(maxx[next] - g[curr][i].second, g[curr][i].second - minn[next]));
				//cout << "from " << curr << " -- " << next << ": " << minn[next] << " " << maxx[next] << " " << minmax[next] << endl;

			} else {
				if ( (color[curr] + 1 == color[next])) {
					
				
					long long minn_ = min(g[curr][i].second, minn[curr]);
					long long maxx_ = max(g[curr][i].second, maxx[curr]);
					long long minmax_ = max(minmax[curr], max(maxx_ - g[curr][i].second, g[curr][i].second - minn_));
					//cout << "from " << curr << " -- " << next << ": " << minn[next] << " " << maxx[next] << " " << minmax[next];
	
					if (minmax_ > minmax[next]) {
						minmax[next] = minmax_;
						pred[next] = curr;
					}
					if (minn_ > minn[next]) {
						minn[next] = minn_;
					}
					if (maxx_ > maxx[next]) {
						maxx[next] = maxx_;
					}
				}
			}
		}
	}
	cout << color[n - 1]  << endl;
	//cout << 1 << " ";
	vector<int> ans;
	int curr = n - 1;
	ans.push_back(curr);
	while(curr != -1) {
		//cout << curr << endl;
		curr = pred[curr];
		ans.push_back(curr);
	}
	for (int i = ans.size() - 2; i >= 0; i--) {

		cout << ans[i] + 1 << " ";
	}
	

}

int main() {
    ios_base::sync_with_stdio(false);


    solve();
    return 0;
}

