#include<bits/stdc++.h>
#define ll long long
using namespace std;
const int N = 600500;
vector <int> g[N];
int to[N];
int cost[N];
int level[N];
int was[N];
int cnt = 1;
int n = 0;

void bfs()
{
	queue<int> q;
	q.push(1);
	was[1]++;

	while(!q.empty())
	{
		int cur = q.front();
		q.pop();

		for (auto e: g[cur])
			if (was[to[e]] == 0)
			{
				
				was[to[e]]++;
				level[to[e]] = level[cur]+1;
				q.push(to[e]);
			}

	}
	return;

}

vector<int> cur_ans;
vector<int> ans_path;
int glob_ans = -1;
void dfs(int v, int mn = 1e9+2, int mx = -1)
{
	cur_ans.push_back(v);
	//cerr << "cur v = " << v << endl;
	if (v == n)
	{
		if (mx - mn <= glob_ans)
			return;

		glob_ans = mx - mn;
		ans_path = cur_ans;
		cur_ans.pop_back();
		return;
	}

	if (level[v] >= level[n])
	{
		cur_ans.pop_back();
		return;
	}


	for (auto e: g[v])
		if (level[to[e]] == level[v] + 1 && level[to[e]] <= level[n])
			dfs(to[e], min(mn, cost[e]), max(mx, cost[e]));
		//

	cur_ans.pop_back();
}

int main()
{
	ios::sync_with_stdio(0);
	cin.tie(0);	
	cout.tie(0);

	int m;
	cin >> n >> m;
	int ind = 1;
	for (int i = 0; i < m; i++)
	{
		int a, b, c;
		cin >> a >> b >> c;

		g[a].push_back(ind);
		to[ind] = b;
		cost[ind] = c;

		ind++;

		g[b].push_back(ind);
		to[ind] = a;
		cost[ind] = c;

		ind++;
	}

	bfs();

	dfs(1);

	cout << (int)ans_path.size() - 1 << endl;
	for (auto i: ans_path)
		cout << i << ' ';
}
