#include <bits/stdc++.h>
#include <regex>
#include <array>
#include <unordered_set>
#include <future>
#include <optional>
#include <any>
#include <variant>
#include <stdlib.h>
#include <cmath>
#include <random>
#include <functional>
#include <climits>

#ifdef LOCAL_UTILITS
#include "Utilits/Timer.h"
#endif

using namespace std;

using li = long long;
using vi = vector<li>;
using pi = pair<li, li>;
using vpi = vector<pi>;
using vvi = vector<vector<li>>;
using vvpi = vector<vpi>;
using ld = long double;

#define forn(i,n) for (li i = 0;i < li(n);i++)
#define ford(i,n) for (li i = li(n)-1;i >=0;i--)
#define fore(i,l,r) for (li i = li(l);i < li(r);i++)
#define forv(v,arr) for (auto& v : (arr))
#define all(a) (a).begin(),(a).end()

using Point = complex<li>;

template <typename T>
istream& operator>>(istream& in, vector<T>& a)
{
    forv(v, a)
        in >> v;
    return in;
}

ostream& operator<<(ostream& out, vi& a)
{
    for (auto v : a)
    {
        out << v;
        out.put(' ');
    }
    return out;
}

ostream& operator<<(ostream& out, vi&& a)
{
    for (auto v : a)
    {
        out << v;
        out.put(' ');
    }
    return out;
}

li get_num(string s)
{
    stringstream ss;
    ss << s;
    li v;
    ss >> v;
    return v;
}

li gcd(li a, li b)
{
    return b ? gcd(b, a % b) : a;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    li num = 0;
    vector<vector<pair<string,li>>> a(n);
    for (auto& b : a)
    {
        int m;
        cin >> m;
        num += m;
        forn(i, m)
        {
            string s;
            cin >> s;
            int pos = 0;
            while (s[pos] != '=')
                pos++;
            auto name = s.substr(0, pos);
            auto val = get_num(s.substr(pos+1));
            b.push_back({ name, val });
        }
    }

    map<string, li> result;
    map<string, bool> done;
    int k;
    cin >> k;
    forn(i, k)
    {
        string name;
        li val;
        cin >> name >> val;
        result[name] = val;
        done[name] = false;
    }

    vi ans;

    auto check = [&](string name, li val)
    {
        if (done[name])
            return 1;
        if (result[name] == val)
        {
            done[name] = true;
            return 1;
        }
        return 0;
    };

    while (ans.size() < num)
    {
        bool flag = false;
        forn(i, n)
        {
            if (a[i].empty())
                continue;
            auto [name, val] = a[i].back();
            if (!check(name, val))
                continue;
            a[i].pop_back();
            flag = true;
            ans.push_back(i + 1);
        }
        if (!flag)
        {
            cout << "No" << endl;
            return 0;
        }
    }
    reverse(all(ans));
    cout << ans << endl;
};
/*3
3
5
start=1
counter=1111
counter=10
counter=3333
finish=1
3
start=2
counter=20
finish=2
3
start=3
qwerty=787788
finish=3
4
counter 10
start 1
finish 1
qwerty 787788
*/