#pragma comment(linker, "/STACK:128777216")
#define _USE_MATH_DEFINES
#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <string>
#include <cstring>
#include <vector>
#include <queue>
#include <bitset>
#include <stack>
#include <deque>
#include <set>
#include <unordered_set>
#include <tuple>
#include <map>
#include <unordered_map>
#include <algorithm>
#include <math.h>
#include <cmath>
#include <climits>
#include <ctime>
#include <cassert>
#include <random>

using namespace std;

#define For(i, n) for (int i = 0; i < (n); ++i)
#define sz(v) (int)(v).size()
#define forx(_name, _from, to, value) for (int name = from; name < to; name += value)
#define rforx(_name, from, to, value) for (int name = from; name > to; name -= _value)
#define all(_STL_NAME) _STL_NAME.begin(), _STL_NAME.end()
#define rall(_STL_NAME) _STL_NAME.rbegin(), _STL_NAME.rend()
#define mp(_FIRST, _SECOND) make_pair(_FIRST,_SECOND)

typedef long long ll;
typedef unsigned long long llu;
typedef long double ld;
const ld eps = 1e-9;
mt19937 rnd(42);

void start() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cout.precision(12);
    cout.setf(ios::fixed);
#ifdef LOCAL
    //freopen("output.out", "w", stdout);
    freopen("input.in", "r", stdin);
#endif
}

const int MAX_N = (int) 1e7 + 10;
const int MAX_M = (int) 1e6 + 10;
const int MOD = (int) 1e9;
const int INF = (int) 1e9 + 7;

struct Date {
    int year;
    int tp;
};

Date ReadDate() {
    string s1, s2;
    cin >> s1 >> s2;
    Date d;
    if (s1 == "AD") {
        d.year = std::stoi(s2);
        d.tp = 0;
    } else {
        d.year = std::stoi(s1);
        d.tp = 1;
    }
    return d;
}
void solve() {
    Date d1 = ReadDate();
    Date d2 = ReadDate();
    if (d1.tp == d2.tp) {
        cout << abs(d1.year - d2.year) << '\n';
    } else {
        cout << d1.year + d2.year - 1 << '\n';
    }
}

int main() {
    start();
    solve();
    //multitest();
#ifdef LOCAL
    //cout << "\nTime: " << 1.0 * clock() / CLOCKS_PER_SEC << endl;
#endif
    return 0;
}
