#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <iomanip>
#include <cstdlib>
#include <cstdio>
#include <cstring>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <algorithm>
#include <random>
#include <queue>
#include <unordered_set>
#include <unordered_map>
#include <tuple>
using namespace std;

typedef long long lint;
#define For(i, n) for (int i = 0; i < (n); ++i)
#define all(v) (v).begin(), (v).end()
#define sz(v) (int)((v).size())

char s[300][301];

void paint_q(int i, int j)
{
    s[i][j + 2] = ' ';
    s[i + 1][j + 2] = ' ';
    s[i + 2][j + 2] = ' ';
    s[i + 3][j + 2] = ' ';
    s[i + 4][j + 2] = ' ';

    s[i][j + 1] = ' ';
    s[i + 2][j + 1] = ' ';

    s[i][j] = ' ';
    s[i + 1][j] = ' ';
    s[i + 2][j] = ' ';
}

void paint_f(int i, int j)
{
    s[i][j] = ' ';
    s[i + 1][j] = ' ';
    s[i + 2][j] = ' ';
    s[i + 3][j] = ' ';
    s[i + 4][j] = ' ';

    s[i][j + 1] = ' ';
    s[i][j + 2] = ' ';

    s[i + 2][j + 1] = ' ';
}

void solve()
{
    int n, m;
    scanf("%d %d", &n, &m);
    For(i, n)
        scanf("%s", s[i]);
    int q = 0, f = 0;
    For(j, m)
    {
        for (int l = 0, r = 1; l < n; l = r++)
        {
            while (r < n && s[l][j] == s[r][j])
                ++r;
            if (s[l][j] == '#')
            {
                for (int i = l; i < r; i += 5)
                    if (i + 5 <= r)
                        paint_f(i, j), ++f;
                    else
                        paint_q(r - 3, j), ++q;
            }
        }
    }
    printf("%d %d\n", q, f);
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    solve();
#ifdef LOCAL
    printf("\n\n%.3f s", (double)clock() / CLOCKS_PER_SEC);
#endif
    return 0;
}
