#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <math.h>
#include <vector>

using namespace std;

#define log(d) for (int _i(0); _i < d.size(); _i++) {for (int _j(0); _j < d[_i].size(); _j++) {cout << (d[_i][_j] ? '#' : '.');} cout << '\n'; } cout << '\n';

using line = vector <int>;
using matrix = vector <line>;

int main() {
    // ...
    ios::sync_with_stdio(false);

    int n, m;
    cin >> n >> m;

    matrix d(n, line(m)), p;
    for (int i(0); i < n; i++) {
        for (int j(0); j < m; j++) {
            char c;
            cin >> c;

            d[i][j] = (c == '#');
        }
    }

    p = d;


    //cout << endl;
    int f(0), q(0);
    for (int i(0); i < n - 4; i++) {
        for (int j(0); j < m - 2; j++) {

            bool a0 = d[i + 0][j + 0];
            bool a1 = d[i + 0][j + 1];
            bool a2 = d[i + 0][j + 2];

            bool a3 = d[i + 1][j + 0];
            bool a4 = d[i + 1][j + 1];
            bool a5 = d[i + 1][j + 2];

            bool a6 = d[i + 2][j + 0];
            bool a7 = d[i + 2][j + 1];
            bool a8 = d[i + 2][j + 2];

            bool a9 = d[i + 3][j + 0];
            bool a10 = d[i + 3][j + 1];
            bool a11 = d[i + 3][j + 2];

            bool a12 = d[i + 4][j + 0];
            bool a13 = d[i + 4][j + 1];
            bool a14 = d[i + 4][j + 2];

            if (a0 && a1 && a2 && a3 && a5 && a6 && a7 && a8 && a11 && a14) {
                q++;

                d[i + 0][j + 0] = 0;
                d[i + 0][j + 1] = 0;
                d[i + 0][j + 2] = 0;
                d[i + 1][j + 0] = 0;
                d[i + 1][j + 2] = 0;
                d[i + 2][j + 0] = 0;
                d[i + 2][j + 1] = 0;
                d[i + 2][j + 2] = 0;
                d[i + 3][j + 2] = 0;
                d[i + 4][j + 2] = 0;

                //cout << "q\n";
                //log(d);
            }
        }
    }

    for (int i(0); i < n - 4; i++) {
        for (int j(0); j < m - 2; j++) {

            bool a0 = d[i + 0][j + 0];
            bool a1 = d[i + 0][j + 1];
            bool a2 = d[i + 0][j + 2];

            bool a3 = d[i + 1][j + 0];
            bool a4 = d[i + 1][j + 1];
            bool a5 = d[i + 1][j + 2];

            bool a6 = d[i + 2][j + 0];
            bool a7 = d[i + 2][j + 1];
            bool a8 = d[i + 2][j + 2];

            bool a9 = d[i + 3][j + 0];
            bool a10 = d[i + 3][j + 1];
            bool a11 = d[i + 3][j + 2];

            bool a12 = d[i + 4][j + 0];
            bool a13 = d[i + 4][j + 1];
            bool a14 = d[i + 4][j + 2];

            if (a0 && a1 && a2 && a3 && a6 && a7 && a9 && a12) {
                f++;

                d[i + 0][j + 0] = 0;
                d[i + 0][j + 1] = 0;
                d[i + 0][j + 2] = 0;
                d[i + 1][j + 0] = 0;
                d[i + 2][j + 0] = 0;
                d[i + 2][j + 1] = 0;
                d[i + 3][j + 0] = 0;
                d[i + 4][j + 0] = 0;

                //cout << "f\n";
                //log(d);
            }
        }
    }

    bool is = true;
    for (int i(0); i < n; i++) {
        for (int j(0); j < m; j++) {
            if (d[i][j]) {
                is = false;
            }
        }
    }

    if (is) {
        cout << q << " " << f;
        return 0;
    }


    //cout << "--seq--\n";
    f = 0, q = 0;
    d = p;
    for (int i(0); i < n - 4; i++) {
        for (int j(0); j < m - 2; j++) {

            bool a0 = d[i + 0][j + 0];
            bool a1 = d[i + 0][j + 1];
            bool a2 = d[i + 0][j + 2];

            bool a3 = d[i + 1][j + 0];
            bool a4 = d[i + 1][j + 1];
            bool a5 = d[i + 1][j + 2];

            bool a6 = d[i + 2][j + 0];
            bool a7 = d[i + 2][j + 1];
            bool a8 = d[i + 2][j + 2];

            bool a9 = d[i + 3][j + 0];
            bool a10 = d[i + 3][j + 1];
            bool a11 = d[i + 3][j + 2];

            bool a12 = d[i + 4][j + 0];
            bool a13 = d[i + 4][j + 1];
            bool a14 = d[i + 4][j + 2];

            if (a0 && a1 && a2 && a3 && a6 && a7 && a9 && a12) {
                f++;

                d[i + 0][j + 0] = 0;
                d[i + 0][j + 1] = 0;
                d[i + 0][j + 2] = 0;
                d[i + 1][j + 0] = 0;
                d[i + 2][j + 0] = 0;
                d[i + 2][j + 1] = 0;
                d[i + 3][j + 0] = 0;
                d[i + 4][j + 0] = 0;

                //cout << "f\n";
                //log(d);
            }
        }
    }

    for (int i(0); i < n - 4; i++) {
        for (int j(0); j < m - 2; j++) {

            bool a0 = d[i + 0][j + 0];
            bool a1 = d[i + 0][j + 1];
            bool a2 = d[i + 0][j + 2];

            bool a3 = d[i + 1][j + 0];
            bool a4 = d[i + 1][j + 1];
            bool a5 = d[i + 1][j + 2];

            bool a6 = d[i + 2][j + 0];
            bool a7 = d[i + 2][j + 1];
            bool a8 = d[i + 2][j + 2];

            bool a9 = d[i + 3][j + 0];
            bool a10 = d[i + 3][j + 1];
            bool a11 = d[i + 3][j + 2];

            bool a12 = d[i + 4][j + 0];
            bool a13 = d[i + 4][j + 1];
            bool a14 = d[i + 4][j + 2];

            if (a0 && a1 && a2 && a3 && a5 && a6 && a7 && a8 && a11 && a14) {
                q++;

                d[i + 0][j + 0] = 0;
                d[i + 0][j + 1] = 0;
                d[i + 0][j + 2] = 0;
                d[i + 1][j + 0] = 0;
                d[i + 1][j + 2] = 0;
                d[i + 2][j + 0] = 0;
                d[i + 2][j + 1] = 0;
                d[i + 2][j + 2] = 0;
                d[i + 3][j + 2] = 0;
                d[i + 4][j + 2] = 0;

                //cout << "q\n";
               // log(d);
            }
        }
    }

    cout << f << " " << q;

    return 0;
}