#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
using namespace std;

int main() {
    int t;
    size_t n;
    cin >> t;

    while (t--) {
        cin >> n;
        set<size_t> divider;
        size_t cur_n = n;
        size_t div = 2;
        while (cur_n != 1) {
            if (cur_n % div != 0)
                div++;
            else {
                cur_n /= div;
                divider.insert(div);
            }
        }

        vector<size_t> coprime;
        for (size_t i = 1; i < n; i++)
            if (all_of(divider.begin(), divider.end(), [i](size_t div) { return i % div != 0; }))
                coprime.push_back(i);

        if (coprime.size() % 2 == 0)
            cout << coprime[coprime.size() / 2 - 1];
        else
            cout << coprime[(coprime.size() + 1) / 2 - 1];
        cout << endl;
    }

    return 0;
}