﻿#define _USE_MATH_DEFINES
#include<iostream>
#include<fstream>
#include<string>
#include<vector>
#include<utility>
#include<algorithm>
#include<climits>
#include<set>
#include<map>
#include<cmath>
#include<iomanip>
#include<iterator>
#include<queue>
#include<stack>
#include<cctype>
#include<deque>
#include<time.h>
#include<bitset>
#include<random>
#include<functional>
#include<unordered_set>
#include<unordered_map>
#include<random>
#include<numeric>
#include<sstream>
#include<cassert>
#include<chrono>
#include<complex>

//by Skeef79

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

#pragma warning(disable : 4996)
#pragma comment(linker, "/STACK:16777216")
#define pb push_back
#define en '\n'
#define forn(i,n) for(int i = 0;i<n;i++)
#define all(x) (x).begin(),(x).end()
#define rall(x) (x).rbegin(),(x).rend()
#define vec vector
#define pii pair<int,int>
#define pll pair<ll,ll>
#define szof(x) int(x.size())

using namespace std;

const int INF = 1000000000 + 1e8;
const ll LINF = 2000000000000000000;


template<typename T> void input(vec<T> &a) {
	for (auto &to : a)
		cin >> to;
}

template<typename T> void print(vec<T> &a) {
	for (auto to : a)
		cout << to << ' ';
	cout << en;
}


int n, k;

struct vertex {
	map<char, int>nxt;
	int cnt;
	bool leaf;
	vertex() {
		cnt = 0;
		leaf = false;
	}
};

vec<vertex>t;

void add_string(string s) {
	int v = 0;
	for (auto to : s) {
		t[v].cnt++;
		if (!t[v].nxt[to]) {
			t.pb(vertex());
			t[v].nxt[to] = szof(t) - 1;
		}
		v = t[v].nxt[to];
	}
	t[v].cnt++;
	t[v].leaf = true;
}

const int N = 4e5 + 1010;
int dp[N];

int ans = 0;

int dfs(int v) {
	if (t[v].cnt <= k) {
		return t[v].cnt;
	}

	vector<int>cur;
	int total = 0;
	for (auto[c, to] : t[v].nxt) {
		int amount = dfs(to);
		total += amount;
		cur.pb(amount);
	}


	if (t[v].leaf)
		total++;

	if (total <= k)
		return total;

	sort(rall(cur));
	for (auto to : cur) {
		total -= to;
		ans++;
		if (total <= k)
			break;
	}

	return total;
}

void solve() {
	cin >> n >> k;
	t.pb(vertex());

	for (int i = 0; i < n; i++) {
		string s;
		cin >> s;
		add_string(s);
	}

	dfs(0);
	cout << ans + 1;

}


int main() {
	srand(time(0));
	ios::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif

	int tst = 1;
	//cin >> tst;

	while (tst--) {
		solve();
	}

}