from math import gcd, ceil

def mygcd(a, b):
    if a == 0:
        return b, 0, 1
    d, x1, y1 = mygcd(b%a, a)
    x = y1 - (b // a) * x1
    y = x1
    return d, x, y

n = int(input())
a = int(input())
b = int(input())


def generate_n(n, a, b):

    g = gcd(a, b)
    dg = g

    if n % g != 0:
        if abs(n - g * (n // g)) < abs(n - g * (n // g + 1)):
            n = g * (n // g)
        else:
            n = g * (n // g + 1)
            dg *= -1
    
    if n < a + b:
        n += ((a + b - n) // g) * g

    while True:
        yield n
        n += dg
        if dg < 0:
            dg = -(dg - g)
        else:
            dg = -(dg + g)
    

def res(a, b, n):
    g, x1, y1 = mygcd(a, b)
    x1 *= n // g;
    y1 *= n // g;

    dx = b//g
    dy = a//g

    k_min = ceil((-x1) / dx)
    k_max = y1 // dy
    if k_min > k_max:
        return None

    x1 += k_min * dx
    y1 -= k_min * dy
    return x1, y1


if n % a == 0:
    print(n // a, 0)
elif n % b == 0:
    print(0, n // b)
else:
    for currn in generate_n(n, a, b):
        r = res(a, b, currn)
        if r:
            print(*r)
            break