
n, k = map(int, input().split())
count = 0

class Node:
    def __init__(self) -> None:
        self.count = 0
        self.nodes = {chr(i): None for i in range(ord('a'), ord('z') + 1)}
    
    def get(self, char):
        ret = self.nodes[char]
        if not ret:
            ret = Node()
        self.nodes[char] = ret
        return ret
    
    def increment(self):
        self.count += 1
    
    def decrement(self):
        self.count -= 1
    
    def __lt__(self, other):
        return self.count < other.count
    
    def __gt__(self, other):
        return self.count > other.count

root = Node()

for _ in range(n):
    curr = root
    curr.increment()
    s = input()
    for ch in s:
        curr = curr.get(ch)
        curr.increment()

def delete(curr=root):
    global count, k
    if curr.count <= k:
        count += 1
        ret = curr.count
        curr.count  = 0
        return ret
    s = 0
    for ch, val in curr.nodes.items():
        if val:
            s += delete(val)
            if val.count == 0:
                curr.nodes[ch] = None
            if curr.count - s <= k:
                curr.count -= s
                return s
    curr.count -= s
    return s

while root.count > 0:
    delete()

print(count)
            

    

