import sys
sys.stdin = open('input.txt')

n, m = map(int, input().split())
pole = []
for i in range(n):
    pole.append(list(input()))
q, f = 0, 0


def print_pole():
    for i in pole:
        for j in i:
            print(j, end='')
        print()


def delete_letter(i, j, pattern):
    if pattern == 'f':
        pole[i][j] = '.'
        pole[i][j+1] = '.'
        pole[i][j+2] = '.'
        pole[i+1][j] = '.'
        pole[i+2][j] = '.'
        pole[i+2][j+1] = '.'
        pole[i+3][j] = '.'
        pole[i+4][j] = '.'
    elif pattern == 'q':
        pole[i][j] = '.'
        pole[i][j+1] = '.'
        pole[i][j+2] = '.'
        pole[i+1][j] = '.'
        pole[i+1][j+2] = '.'
        pole[i+2][j] = '.'
        pole[i+2][j+1] = '.'
        pole[i+2][j+2] = '.'
        pole[i+3][j+2] = '.'
        pole[i+4][j+2] = '.'


def process_letter(i, j):
    global q, f
    if pole[i+1][j] == '#' and \
            pole[i+2][j] == '#' and \
            pole[i+3][j] == '#' and \
            pole[i+4][j] == '#':
        f += 1
        delete_letter(i, j, 'f')
    else:
        q += 1
        delete_letter(i, j, 'q')


def search():
    final = True
    for j in range(len(pole[0])):
        for i in range(len(pole)):
            if pole[i][j] == '#':
                process_letter(i, j)
                final = False
    if final:
        print(q, f)
        exit()


while True:
    search()
