#include <iostream>
#include <vector>

using namespace std;

long long gcd(long long a, long long b)
{
    while (a != 0 && b != 0)
    {
        if (a > b)
            a %= b;
        else
            b %= a;
    }
    return a > b ? a : b;
}

int areCoprime(long long a, long long b){
    if(gcd(a, b) == 1) return 1; // coprime
    return 0; // not coprime
}

int main() {

    long long k, n, length;
    cin >> k;

    vector<int> list;

    for(int i = 0; i < k; i++){
        cin >> n;
        for(int j = 1; j < n; j++){
            if((n % 2 == 0 && j % 2 == 0) || (n % 3 == 0 && j % 3 == 0)) continue;
            if(areCoprime(n, j)){
                list.push_back(j);
            }
        }

        length = list.size();

        if(length % 2 == 0){
            cout << list[length/2 - 1] << endl;
        }else{
            cout << list[(length+1)/2 - 1] << endl;
        }

        list.clear();
    }

    return 0;
}