#include <iostream>
#include <vector>

using namespace std;

long long gcd(long long a, long long b)
{
    while (a != 0 && b != 0)
    {
        if (a > b)
            a %= b;
        else
            b %= a;
    }
    return a > b ? a : b;
}

int areCoprime(long long a, long long b){
    if(gcd(a, b) == 1) return 1; // coprime
    return 0; // not coprime
}

int main() {

    long long k, n, length;
    bool should_continue = false;
    cin >> k;

    vector<long long> list;
    vector<long long> divisors;

    for(int i = 0; i < k; i++){
        cin >> n;
        for(int j = 1; j < n; j++){

            for(int f = 0; f < divisors.size(); f++){
                if(j % divisors[f] == 0){
                    divisors.push_back(j);
                    should_continue = true;
                    break;
                }
            }

            if(should_continue){
                should_continue = false;
                continue;
            }

            if(areCoprime(n, j) == 1){
                list.push_back(j);
            }else{
                if(j != 1) divisors.push_back(j);
            }
        }

        length = list.size();

        if(length % 2 == 0){
            cout << list[length/2 - 1] << endl;
        }else{
            cout << list[(length+1)/2 - 1] << endl;
        }

        list.clear();
        divisors.clear();
    }

    return 0;
}