//package com.anar;

import java.io.*;

public class H {
    public static long gcd( long a,  long b) {
        while (a != 0 && b != 0) {
            if (a > b)
                a %= b;
            else
                b %= a;
        }
        return Math.max(a, b);
    }

    public static boolean areCoprime(long a, long b){
        return gcd(a, b) == 1;
    }

    public static void main(String[] args) throws IOException {
        BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
        BufferedWriter bw = new BufferedWriter(new OutputStreamWriter(System.out));

        int t = Integer.parseInt(br.readLine());
        for (int i = 0; i < t; i++) {
            long n = Integer.parseInt(br.readLine());
            long toBeFound = (n/2);

            while(! areCoprime(n, toBeFound)) toBeFound--;
            bw.append(toBeFound + "");
            bw.newLine();
        }

        bw.flush();
    }
}
