#include <iostream>
#include <vector>
using namespace std;

int main()
{
    ios_base::sync_with_stdio(false);
    int n, m, c;
    cin >> n >> m >> c;

    vector<int> diff = {-2, -1, 0, 1, 2};
    vector<int> a (n / m + 2);
    int k = diff.size();
    vector<int> b (k * (n / m + 2));

    int min = -1, ixsI = -1, ixsJ = -1, C = -1;

    for (int i = 0; i < a.size(); i++) {
        a[i] = i;
        C = (n - a[i] * m) / c;
        for (int j = 0; j < k; j++) {
            b[k*i+j] = abs(C + diff[j]);
        }
    }

    int e;
    for (int i = 0; i < a.size(); i++) {
        for (int j = 0; j < k; j++) {
            e = abs(m*a[i] + c*b[k*i+j] - n);
            if (ixsI == -1 || e < min) {
                min = e;
                ixsI = i;
                ixsJ = j;
            }
        }
    }

    cout << a[ixsI] << " " << b[k*ixsI + ixsJ];
}