#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <queue>
#include <set>
#include <map>
#include <stack>
#include <iomanip>
#include <string>
#include <unordered_map>
#include <complex>
#include <unordered_set>
#include <algorithm>
#include <cstring>
#include <bitset>
#include <math.h>
#include <ctime>
using namespace std;
#define ll long long
#define sint unsigned char
#define ull unsigned long long
#define pii pair<int, int>
#define uint unsigned int
typedef complex<double> base;

const double PI = acos(-1);

#pragma GCC optimize("Ofast")
#pragma GCC optimize("O2")
#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx")

const int MAXN = 3e5 + 100;
const int LOGN = 18;
const int MOD = (int)1e9 + 7;
void clear()
{
}
void precalc() {
	
}
void gen_tests() {
}
struct item {
	string name;
	int value;
};

stack<item> values[100];
unordered_set<string> set_values;

item parse_by(string& line) {
	string cur_line = "";
	string d2 = "";
	for (auto u : line) {
		if (u == '=') {
			d2 = cur_line;
			cur_line = "";
			continue;
		}
		cur_line += u;
	}
	return { d2, stoi(cur_line) };
}

void solve() {
	int n;
	cin >> n;
	for (int i = 0; i < n; ++i) {
		int k;
		cin >> k;
		for (int j = 0; j < k; ++j) {
			string val;
			cin >> val;
			values[i].push({ parse_by(val) });
		}
	}
	unordered_map<string, int> req_values;
	int k;
	cin >> k;
	for (int i = 0; i < k; ++i) {
		string value;
		int rst;
		cin >> value >> rst;
		req_values[value] = rst;
	}
	vector<int> order;
	while (1) {
		bool any_values = false;
		for (int i = 0; i < n; ++i) {
			while (values[i].size()) {
				auto top = values[i].top();
				if (set_values.count(top.name)) {
					order.push_back(i + 1);
					values[i].pop();
					any_values = true;
					continue;
				}
				if (req_values[top.name] == top.value) {
					set_values.insert(top.name);
					order.push_back(i + 1);
					any_values = true;
					values[i].pop();
					continue;
				}
				break;
			}
		}
		if (!any_values)
			break;
	}
	for (int i = 0; i < n; ++i) {
		if (values[i].size()) {
			cout << "No\n";
			return;
		}
	}
	cout << "Yes\n";
	for (auto it = order.rbegin(); it != order.rend(); it++) {
		cout << *it << ' ';
	}
	cout << '\n';
}

void multisolve()
{
	int t;
	cin >> t;
	while (t--)
	{
		solve();
	}
}
int main()
{
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	//freopen("input.in", "r", stdin);
	//freopen("output.out", "w", stdout);
	precalc();
	solve();

	return 0;
}