#include <bits/stdc++.h>
#define forab(i, a, b) for (long long i = a; i < b; i++)
#define for0(i, n) for(int  i = 0; i < n; i++)
#define for1(i, n) for(int i = 1; i < n; i++)
#define forn(i, n) for(int i = n; i >= 0; i--)
#define pb push_back

#define en '\n'

#define PI 3.14159265
#define EPS 1e-9

#define vec vector
#define all(x) (x).begin(),(x).end()
#define rall(x) (x).rbegin(),(x).rend()

using namespace std;
template<typename T>
istream& operator>>(istream& in, vector<T>& a) {
    for (auto& i : a)
        cin >> i;
    return in;
}
template<typename T>
ostream& operator<<(ostream& out, vector<T>& a) {
    for (auto& i : a)
        cout << i << ' ';
    return out;
}

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
typedef pair<ll, ll> pll;
typedef pair<int, int> pii;
typedef pair<int, ll> pil;
typedef pair<ld, int> pli;

typedef map<int, int> mii;
typedef map<ll, ll> mll;

typedef vector<int> vi;
typedef vector<bool> vb;
typedef vector<ll> vll;
typedef vector<pii> vpii;
typedef vector<vector<int>> vvi;
typedef vector<vector<ll>> vvll;

const int MAXN = 51000;
const int INF = 1e9 + 1e8 + 1e7;
const ll BINF = LLONG_MAX / 3;
const ll MD = 1e9 + 7;

ll gcd(ll a, ll b) {
    if (b == 0)
        return a;
    return gcd(b, a % b);
}

struct node {
    int nxt[26];
    int cnt=0;
    bool leaf = false;
    int p = 0;
    node() {
        for(int i = 0; i < 26; i++) {
            nxt[i] = -1;
        }
    }
};
vector<node> a;

void add_str(string s) {
    int pos = 0;
    for (int i = 0; i < s.length(); i++) {
        if (a[pos].nxt[s[i] - 'a'] == -1) {
            a[pos].nxt[s[i] - 'a'] = a.size();
            a.push_back(node());
            a[a.size()-1].p=pos;
        }
//        a[pos].cnt++;
        pos = a[pos].nxt[s[i] - 'a'];
    }
//    a[pos].cnt++;
    a[pos].leaf = true;
}

vvi lvls;
void lvl_search(int v, int lvl) {
    if(lvl>=lvls.size())
        lvls.push_back({});
    lvls[lvl].push_back(v);
    for0(i, 26) {
        if(a[v].nxt[i]!=-1) {
            lvl_search(a[v].nxt[i], lvl+1);
        }
    }
}

vector<priority_queue<int>> qq;

void solve() {
    int n, k;
    cin >> n >> k;
    a.resize(0);
    a.push_back(node());
    for0(i, n) {
        string s;
        cin >> s;
        add_str(s);
    }
    lvl_search(0, 0);
//    for0(i, lvls.size()){
//        cout << i << " lvl:\n";
//        for(auto c: lvls[i]){
//            cout << c << ' ' << a[c].p << en;
//        }
//    }
    qq.resize(a.size());
    int ans=0;
    for(auto v: lvls[lvls.size()-1]) {
        qq[v].push(1);
    }

    for(int lvl=lvls.size()-1; lvl>-1; lvl--){
        for(int v: lvls[lvl]){
            if(!v){
                while(a[0].cnt>k){
                    a[0].cnt-=qq[0].top();
                    qq[0].pop();
                    ans++;
                }
                if(a[0].cnt){
                    ans++;
                }
                break;
            }
            if(a[v].leaf)
                a[v].cnt++;
            if(a[v].cnt<=k && v) {
                a[a[v].p].cnt+=a[v].cnt;
                qq[a[v].p].push(a[v].cnt);
                while(!qq[v].empty()){
                    qq[v].pop();
                }
            }
            else{
                while(a[v].cnt>k) {
                    a[v].cnt-=qq[v].top();
                    qq[v].pop();
                    ans++;
                }

                a[a[v].p].cnt+=a[v].cnt;
                qq[a[v].p].push(a[v].cnt);
                while(!qq[v].empty()){
                    qq[v].pop();
                }
            }
        }
    }
    cout << ans << en;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    //freopen("grid.in", "r", stdin);
    //freopen("grid.out", "w", stdout);

    int tst = 1;
    //cin >> tst;
    while (tst--)
        solve();
}