#include <bits/stdc++.h>
#include <bitset>
#include <cstdint>

#define forab(i, a, b) for (long long i = a; i < b; i++)
#define for0(i, n) for(int  i = 0; i < n; i++)
#define for1(i, n) for(int i = 1; i < n; i++)
#define pb push_back
#define mp make_pair
#define fi first
#define se second

#define en '\n'

#define PI 3.14159265
#define EPS 1e-9

#define vec vector
#define all(x) (x).begin(),(x).end()
#define rall(x) (x).rbegin(),(x).rend()


using namespace std;

typedef long long ll;
typedef long double ld;

typedef pair<ll, ll> pll;
typedef pair<int, int> pii;
typedef pair<int, ll> pil;
typedef pair<ld, int> pli;

typedef map<int, int> mii;
typedef map<ll, ll> mll;

typedef vector<int> vi;
typedef vector<ll> vll;
typedef vector<vector<int>> vvi;
typedef vector<vector<ll>> vvll;

const int MAXN = 4*1e5;
const int INF = 200000000;
const ll LINF = 20000000000000000;
const ll MOD = 1e9+7;
const ld eps = 1e-9;




void solve(){
    int n,m;
    cin>>n>>m;
    vector<vector<pii>> g(n,vector<pii>());
    for(int i=0,a,b,c;i<m;++i){
        cin>>a>>b>>c;
        a--;b--;
        g[a].pb({b,c});
        g[b].pb({a,c});
    }

    vector<pii> dp_left(n),dp_right(n);
    vector<pii> prev_left(n,{-1,-1}),prev_right(n,{-1,-1});
    queue<int> q;
    q.push(0);
    vector<bool> used (n);
    used[0] = true;
    vector<int> lvlL(n),lvlR(n);
    dp_left[0].fi = INT_MAX;
    dp_left[0].se = INT_MIN;
    while(!q.empty()){
        int v = q.front(); q.pop();
        for(auto u:g[v]){
            if(!used[u.fi]){
                dp_left[u.fi] = {min(dp_left[v].fi,u.se),max(dp_left[v].se,u.se)};
                prev_left[u.fi].fi = prev_left[u.fi].se = v;
                used[u.fi] = true;
                lvlL[u.fi] = lvlL[v] + 1;
                q.push(u.fi);
            }else if(lvlL[u.fi]==lvlL[v]+1){
                //dp_left[u.fi] = {min(dp_left[u.fi].fi,dp_left[v].fi+u.se),max(dp_left[u.fi].se,dp_left[v].se+u.se)};
                if(min(dp_left[v].fi,u.se)<dp_left[u.fi].fi){
                    prev_left[u.fi].fi = v;
                    dp_left[u.fi].fi =min(dp_left[v].fi,u.se);
                }
                if(max(dp_left[v].se,u.se)>dp_left[u.fi].se){
                    prev_left[u.fi].se = v;
                    dp_left[u.fi].se = max(dp_left[v].se,u.se);
                }
            }
        }
    }
    /*for(int i=0;i<n;++i)
        cout<<i<<" -> "<<prev_left[i].fi<<' '<<prev_left[i].se<<en;*/

    dp_right[n-1].fi = INT_MAX;
    dp_right[n-1].se = INT_MIN;

    used.assign(n,false);
    q.push(n-1);
    used[n-1] = true;
    while(!q.empty()){
        int v = q.front(); q.pop();
        for(auto u:g[v]){
            if(!used[u.fi]){
                dp_right[u.fi] = {min(dp_right[v].fi,u.se),max(dp_right[v].se,u.se)};
                used[u.fi] = true;
                prev_right[u.fi].fi = prev_right[u.fi].se = v;
                lvlR[u.fi] = lvlR[v] + 1;
                q.push(u.fi);
            }else if(lvlR[u.fi]==lvlR[v]+1){
                //dp_right[u.fi] = {min(dp_right[u.fi].fi,dp_right[v].fi+u.se),max(dp_right[u.fi].se,dp_right[v].se+u.se)};
                if(min(dp_right[v].fi,u.se)<dp_right[u.fi].fi){
                    prev_right[u.fi].fi = v;
                    dp_right[u.fi].fi = min(dp_right[v].fi,u.se);
                }
                if(max(dp_right[v].se,u.se)>dp_right[u.fi].se){
                    prev_right[u.fi].se = v;
                    dp_right[u.fi].se = max(dp_right[v].se,u.se);
                }
            }
        }
    }
    /*for(int i=0;i<n;++i)
        cout<<i<<" -> "<<dp_left[i].fi<<' ' <<dp_left[i].se<<' '<<lvlL[i]<<en;
    cout<<en;
    for(int i=0;i<n;++i)
        cout<<i<<" -> "<<dp_right[i].fi<<' ' <<dp_right[i].se<<' '<<lvlR[i]<<en;*/

    /*cout<<"YOU\n";
    for(int i=0;i<n;++i)
        cout<<i<<" -> "<<prev_right[i].fi<<' '<<prev_right[i].se<<en;*/

    int ans = -1;
    int ver = -1;
    int naprav=0;
    for(int i=1;i<n-1;++i){
        if(lvlL[i]+lvlR[i]!=lvlL[n-1]) continue;
        //naprav = abs(dp_left[i].fi-dp_right[i].se)>abs(dp_left[i].se-dp_right[i].fi);
        if(max(abs(dp_left[i].fi-dp_right[i].se),abs(dp_left[i].se-dp_right[i].fi))>ans){
            ans = max(abs(dp_left[i].fi-dp_right[i].se),abs(dp_left[i].se-dp_right[i].fi));
            ver = i;
            naprav = abs(dp_left[i].fi-dp_right[i].se)>abs(dp_left[i].se-dp_right[i].fi);
        }
        //ans = max(ans,max(abs(dp_left[i].fi-dp_right[i].se),abs(dp_left[i].se-dp_right[i].fi)));
    }
    //cout<<ans<<en;
    deque<int> path;
    int i =ver;
    if(naprav){
        cout<<lvlL[n-1]<<en;
        int prev =0;
        while(i!=-1){
            path.push_front(prev_left[i].fi);
            i = prev_left[i].fi;
        }
        path.pop_front();
        path.push_back(ver);
        i = ver;
        while(i!=-1){
            path.push_back(prev_right[i].se);
            i = prev_right[i].se;
        }
        path.pop_back();
        for(int u:path)
            cout<<u+1<<' ';
    }else{
        cout<<lvlL[n-1]<<en;
        int prev =0;
        while(i!=-1){
            path.push_front(prev_left[i].se);
            i = prev_left[i].se;
        }
        path.pop_front();
        path.push_back(ver);
        i = ver;
        while(i!=-1){
            path.push_back(prev_right[i].fi);
            i = prev_right[i].fi;
        }
        path.pop_back();
        for(int u:path)
            cout<<u+1<<' ';
    }

}



int main(){

    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    //freopen("input.txt","r",stdin);
    //freopen("aztec.out","w",stdout);

    int tst = 1;
    //cin >> tst;
    while (tst--)
        solve();
}