#define _CRT_SECURE_NO_WARNINGS
#pragma GCC optimization("O3")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")
#include <bits/stdc++.h>

#define int long long
#define all(x) (x).begin(), (x).end()
using namespace std;

const int MOD = 1e9 + 7, P = 31, INF = 1e9, MAXN = 1e2, MAXM = 1e4;
const double EPS = 1e-6;

void paintF(vector<vector<bool>>& f, int x, int y) {
	f[x][y] = f[x - 1][y] = f[x - 2][y] = f[x - 3][y] = f[x - 4][y] = 0;
	f[x - 2][y + 1] = f[x - 4][y + 1] = f[x - 4][y + 2] = 0;
}

void paintQ(vector<vector<bool>>& f, int x, int y) {
	f[x][y] = f[x - 1][y] = f[x - 2][y] = 0;
	f[x][y + 1] = f[x - 2][y + 1] = 0;
	f[x][y + 2] = f[x - 1][y + 2] = f[x - 2][y + 2] = 0;
	f[x + 1][y + 2] = f[x + 2][y + 2] = 0;
}

signed main() {
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	
	int n, m;
	char ch;
	cin >> n >> m;
	vector<vector<bool>> f(n, vector<bool>(m));
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			cin >> ch;
			if (ch == '#') f[i][j] = 1;
		}
	}
	int Q = 0, F = 0;
	for (int j = 0; j < m; j++) {
		int row = 0;
		for (int i = 0; i < n; i++) {
			//if (i == 0 && j == 6) return 0;
			if (f[i][j]) row++;
			if (!f[i][j]) {
				if (row) {
					paintQ(f, i - 1, j);
					//for (int v = 0; v < n; v++) {
					//	for (int u = 0; u < m; u++) {
					//		cout << f[v][u] << ' ';
					//	}cout << '\n';
					//}cout << '\n';
					Q++;
					row = 0;
				}
			}
			if (row == 5) {
				paintF(f, i, j);
				//for (int v = 0; v < n; v++) {
				//	for (int u = 0; u < m; u++) {
				//		cout << f[v][u] << ' ';
				//	}cout << '\n';
				//}cout << '\n';
				F++;
				row = 0;
			}
		}
	}
	cout << Q << ' ' << F;
}