﻿#define _USE_MATH_DEFINES

#include<iostream>
#include<fstream>
#include<string>
#include<vector>
#include<utility>
#include<algorithm>
#include<climits>
#include<set>
#include<map>
#include<cmath>
#include<iomanip>
#include<iterator>
#include<queue>
#include<stack>
#include<cctype>
#include<deque>
#include<time.h>
#include<bitset>
#include<random>
#include<unordered_set>
#include<unordered_map>
#include<sstream>
#include<random>
#include<numeric>
#include <assert.h>

#pragma warning(disable : 4996)

#pragma comment(linker, "/STACK:16777216")

#define en "\n"
#define for0(i, n) for(int i = 0; i < n; i++)
#define all(x) (x).begin(), (x).end()
#define allr(x) (x).rbegin(), (x).rend()
#define pb push_back
#define pii pair<int, int>
#pragma warning(disable : 4996)
#define fst first
#define snd second
typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

using namespace std;


template<typename T> void print(vector<T>& a)
{
	for (int i = 0; i < a.size(); i++)
		cout << a[i] << ' ';
	cout << en;
}

template<typename T> void print(deque<T>& a)
{
	for (int i = 0; i < a.size(); i++)
		cout << a[i] << ' ';
	cout << en;
}

template<typename T> void print(vector<vector<T>>& a)
{
	for (int i = 0; i < a.size(); i++)
	{
		for (int j = 0; j < a[i].size(); j++)
			cout << a[i][j];
		cout << en;
	}
}

template <typename T> void input(vector<T>& a)
{
	for (int i = 0; i < a.size(); i++)
		cin >> a[i];
}

template<typename T> void input(deque<T>& a)
{
	for (int i = 0; i < a.size(); i++)
		cin >> a[i];
}

template<typename T> void input(vector<vector<T>>& a)
{
	for (int i = 0; i < a.size(); i++)
		for (int j = 0; j < a[i].size(); j++)
			cin >> a[i][j];
}

const ll INF = 1e9 + 5;
const ll MOD = 1e9 + 7;
const int NMAX = 400;
double EPS = 1e-5;
const int MAX_LOGN = 18;

void solve()
{
	ll n, m, c; cin >> n >> m >> c;

	ll _b_m = (n + m - 1) / m;

	ll ans_min = INT_MAX;
	pair<ll, ll> res;
	for (ll _m = 0; _m <= 2e6 + 100; _m++)
	{
		ll out = n - _m * m;
		if (abs(out) < ans_min)
		{
			ans_min = abs(out);
			res = { _m,0 };
		}
		ll _c = out / c;
		if (_c < 0) continue;
		if (abs(_m * m + _c * c - n) < ans_min)
		{
			ans_min = abs(_m * m + _c * c - n);
			res = { _m,_c };
		}
		if (abs(_m * m + (_c + 1) * c - n) < ans_min)
		{
			ans_min = abs(_m * m + (_c + 1) * c - n);
			res = { _m,_c + 1 };
		}

		if (abs(_m * m + (_c + 2) * c - n) < ans_min)
		{
			ans_min = abs(_m * m + (_c + 2) * c - n);
			res = { _m,_c + 2 };
		}
	}

	cout << res.first << " " << res.second << en;
}

int main() {

	srand(time(0));
	ios::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	cout.setf(ios::fixed);
	cout.precision(12); //anagrams.in
	//freopen("little.in", "r", stdin);
	//freopen("little.out", "w", stdout);

#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#endif

	int t = 1;
	//cin >> t;
	while (t--) {
		solve();
	}
}