﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Transactions;

namespace ACM
{
    class Program
    {
        static void Main(string[] args)
        {
            var n = int.Parse(Console.ReadLine());
            var m = int.Parse(Console.ReadLine());
            var c = int.Parse(Console.ReadLine());
            var arr = Enumerable.Repeat((int.MinValue, int.MinValue), n).ToArray();
            arr[0] = (0, 0);
            for (int i = 0; i < n; i++)
            {
                if (arr[i].Item1 >= 0)
                {
                    var mMove = i + m;
                    if (mMove < n)
                    {
                        arr[mMove - 1] = (arr[i].Item1, arr[i].Item2);
                        arr[mMove - 1].Item1++;

                    }
                    
                    var cMove = i + c;
                    if (cMove < n)
                    {
                        arr[cMove - 1] = (arr[i].Item1, arr[i].Item2);
                        arr[cMove - 1].Item2++;
                    }
                }
            }

            var result = arr.Last(x => x.Item1 >= 0);
            Console.WriteLine($"{result.Item1} {result.Item2}");
        }
    }
}