#include <iostream>
#include <cmath>

using namespace std;

char matrix[302][302];
int n, m;
int ansQ=0, ansF=0;

bool is_it_q(int i, int j){
    if(matrix[i][j] != '#'){return false;}
    if(matrix[i][j+1] != '#'){return false;}
    if(matrix[i][j+2] != '#'){return false;}

    if(matrix[i+1][j] != '#'){return false;}
    if(matrix[i+1][j+2] != '#'){return false;}

    if(matrix[i+2][j] != '#'){return false;}
    if(matrix[i+2][j+1] != '#'){return false;}
    if(matrix[i+2][j+2] != '#'){return false;}

    if(matrix[i+3][j+2] != '#'){return false;}
    if(matrix[i+4][j+2] != '#'){return false;}
    return true;
}

bool is_it_f(int i, int j){
    if(matrix[i][j] != '#'){return false;}
    if(matrix[i][j+1] != '#'){return false;}
    if(matrix[i][j+2] != '#'){return false;}

    if(matrix[i+1][j] != '#'){return false;}

    if(matrix[i+2][j] != '#'){return false;}
    if(matrix[i+2][j+1] != '#'){return false;}

    if(matrix[i+3][j] != '#'){return false;}
    if(matrix[i+4][j] != '#'){return false;}
    return true;
}

void it_is_q(int i, int j){
    ansQ++;
    matrix[i][j] = '.';
    matrix[i][j+1] = '.';
    matrix[i][j+2] = '.';
    matrix[i+1][j] = '.';
    matrix[i+1][j+2] = '.';
    matrix[i+2][j] = '.';
    matrix[i+2][j+1] = '.';
    matrix[i+2][j+2] = '.';
    matrix[i+3][j+2] = '.';
    matrix[i+4][j+2] = '.';
}

void it_is_f(int i, int j){
    ansF++;
    matrix[i][j] = '.';
    matrix[i][j+1] = '.';
    matrix[i][j+2] = '.';
    matrix[i+1][j] = '.';
    matrix[i+2][j] = '.';
    matrix[i+2][j+1] = '.';
    matrix[i+3][j] = '.';
    matrix[i+4][j] = '.';
}

int main()
{
    cin>>n>>m;
    for(int i=0; i<n; i++){
        for(int j=0; j<m; j++){
            cin>>matrix[i][j];
        }
    }
    for(int i=0; i<n; i++){
        for(int j=0; j<m; j++){
            if(matrix[i][j]=='#'){
                if(is_it_f(i, j)){
                    it_is_f(i, j);
                    j+=2;
                }else{
                    it_is_q(i, j);
                    j+=2;
                }
            }
        }
    }
    cout<<ansQ<<" "<<ansF<<endl;
    return 0;
}
/*
cout<<"Q: "<<ansQ<<" ,F: "<<ansF<<endl;
                for(int ii=0;ii<n; ii++){
                    for(int jj=0; jj<m; jj++){
                        cout<<matrix[ii][jj];
                    }
                    cout<<endl;
                }

*/
