﻿using System;

namespace olp
{
    class Program
    {
        static long gcd(long a, long b)
        {
            if (a == b)
                return a;
            if (a > b)
                return gcd(a - b, b);
            return gcd(a, b - a);
        }

        static bool coprime(long a, long b)
        {
            return (gcd(a, b) == 1);
        }

        static long numOfPairs(long n)
        {
            long count = 0;
            long[] arr = new long[n];
            for (long i = 1; i < n; i++)
                if (coprime(n, i))
                {
                    arr[count++] = i;
                }
            Console.WriteLine(arr[(count+1) / 2 - 1]);
            return count;
        }

        static void Main(string[] args)
        {
            int t = Convert.ToInt32(Console.ReadLine());
            for (int i = 0; i < t; i++)
            {
                long n = Convert.ToInt64(Console.ReadLine());
                numOfPairs(n);
            }
        }
    }
}
