﻿#include <iostream>
#include <vector>

std::pair<int, int> solve(int n, int x, int y)
{
	std::pair<int, int> ans(0,0);

	int min_dot = 2147483647;

	for (int i = 0; i <= (n / x); ++i)
	{
		if ((n - (i * x)) % y == 0)
		{
			ans.first = i;
			ans.second = (n - (i * x)) / y;
			return ans;
		}
		else
		{
			if (abs(n - i * x - ((n - (i * x))/y)*y) < min_dot)
			{
				min_dot = abs(n - i * x - ((n - (i * x)) / y) * y);
				ans = { i, (n - (i * x)) / y };
			}
			if (abs(n - i * x - ((n - (i * x)) / y + 1) * y) < min_dot)
			{
				min_dot = abs(n - i * x - ((n - (i * x)) / y + 1) * y);
				ans = { i, (n - (i * x)) / y + 1 };
			}
						
		}
	}

	for (int i = 0; i <= (n / y); ++i)
	{
		if ((n - (i * y)) % x == 0)
		{
			ans.first = (n - (i * y)) / x;
			ans.second = i;
		}
		else
		{
			if (abs(n - i * y - ((n - (i * y)) / x) * x) < min_dot)
			{
				min_dot = abs(n - i * y - ((n - (i * y)) / x) * x);
				ans = { (n - (i * y)) / x, i };
			}

			if (abs(n - i * y - ((n - (i * y)) / x + 1) * x) < min_dot)
			{
				min_dot = abs(n - i * y - ((n - (i * y)) / x + 1) * x);
				ans = { (n - (i * y)) / x + 1, i };
			}
		}
	}

	return ans;
}


int main()
{
	int n, x, y;
	std::cin >> n >> x >> y;
	
	std::pair<int, int> answer = solve(n, x, y);

	std::cout << answer.first << ' ' << answer.second;

}