#include <bits/stdc++.h>

using namespace std;

struct abc {
	int a, b, c;
};

vector <abc> kek;
vector <int> road;
vector <vector <int> > allRoads;
 
void bfs(vector <int> g[], vector <int> p[], int n, int start)
{
    vector <int> d(n, 1e9);
    queue <int> q;
 
    q.push(start);
    d[start] = 0;
    p[start] = {-1};
 
    while (!q.empty()) {
        int v = q.front();
        q.pop();
        for (int i : g[v]) {
            if (d[i] > d[v] + 1) {
                q.push(i);
                d[i] = d[v] + 1;
                p[i].clear(), p[i].push_back(v);
            }
            else if (d[i] == d[v] + 1)
                p[i].push_back(v);
        }
    }
}

void find_roads(vector <int> p[], int n, int end) {
    if (end == -1) {
        allRoads.push_back(road);
        return;
    }

    for (int v : p[end]) {
        road.push_back(end);
        find_roads(p, n, v);
        road.pop_back();
    }
}
int main()
{
	int n, m;
	cin >> n >> m;

	vector <int> g[n], p[n];
	
	int a, b, c;
	for (int i = 0; i < m; i++) {
		cin >> a >> b >> c;
		
		kek.push_back({a - 1, b - 1, c});
		g[a - 1].push_back(b - 1);
    	g[b - 1].push_back(a - 1);
	}
 
    bfs(g, p, n, 0);
    find_roads(p, n, n - 1);
    
    int ans = 0, o = 0, size = 0;
    int ansMAX = -1;
    for (auto v : allRoads) {
		int minn = 1e9, maxx = -1e9;
		for (int j = 0; j < m; j++)
			for (int i = 0; i < v.size() - 1; i++)
				if (v[i] == kek[j].a && v[i + 1] == kek[j].b) {
					maxx = max(maxx, kek[j].c), minn = min(minn, kek[j].c);
					
					if (maxx - minn > ansMAX)
						ansMAX = maxx - minn, ans = o, size = v.size();	
				}
					
		o++;
    }
    
	cout << size - 1 << '\n';
	for (int i = size - 1; i >= 0; i--)
		cout << allRoads[ans][i] + 1 << ' ';

	return 0;
}

