#include <iostream>
#include <iomanip>
#include <cstdio>
#include <fstream>
#include <cmath>
#include <algorithm>
#include <string>
#include <cstring>
#include <vector>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <stack>
#include <queue>
#include <deque>
#include <bitset>
#include <chrono>
#include <functional>
#include <numeric>
#include <sstream>
//#include <ext/pb_ds/assoc_container.hpp>
#define _crt_secure_no_warnings
#define JH ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#define pb push_back
#define INF 0x3F3F3F3F3F3F3F3FLL
#define MAXLL 1000000000000000000LL
#define MOD 1000000007
#define LOGMAX 21
#define ALPHABET 26
#define loop(i, n) for (int i = 1; i <= (n); i++)
#define loop0(i, n) for (int i = 0; i < (n); i++)
#define sz(x) (int)x.size()
#define all(v) v.begin(), v.end()
#define all1(v) v.begin() + 1, v.end()
#define F first
#define S second
#define EPS 1e-6
using namespace std;
//using namespace __gnu_pbds;
typedef long long ll;
typedef unsigned long long ull;
typedef long double lld;
typedef pair<int, int> ii;
//typedef tree<int, null_type, less_equal<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
//main exec
struct item{
    map<char, int> next;
    int leaf;
    item(){
        leaf = 0;
    }
};
vector<item> trie(1);
void Insert(string &s)  
{
    int cur = 1;
    item temp;
    for (char c : s)
    {
        if (trie[cur].next[c] == 0)
        {
            trie[cur].next[c] = trie.size();
            trie.push_back(temp);
        }
        cur = trie[cur].next[c];
    }
    trie[cur].leaf = 1;
}
vector<int> dp, ans;
int dfs(int v){
    if (trie[v].next.empty()) return dp[v] = trie[v].leaf;
    dp[v] = trie[v].leaf;
    for (auto [c, to] : trie[v].next){
        dp[v] += dfs(to);
    }
    return dp[v];
}
int k;

int dfs2(int v){
    if (dp[v] <= k) return ans[v] = 1;
    int res = INF;
    vector<ii> children;
    for (auto [c, to] : trie[v].next){
        children.pb({to, 0});
    }
    for (auto &[to, w] : children){
        w = dfs2(to);
    }
    int n = sz(children);
    for (int mask = 0; mask < (1<<n); mask++){
        int sum = 0, sumdp = 0;
        for (int i = 0; i < n; i++){
            if (mask & (1<< i)) sum += children[i].S, sumdp += dp[children[i].F];
        }
        if (dp[v] - sumdp <= k) res = min(res, sum + 1);
    }
    int sum = 0; for (auto &[to, w] : children) sum += w;
    res = min(res, sum);
    return ans[v] = res;
}

int main(){
    JH
    int n; cin >> n >> k;
    item temp; trie.pb(temp);
    loop(i, n){
        string s; cin >> s;
        Insert(s);
    }
    dp.resize(sz(trie) + 1), ans.resize(sz(trie) + 1);
    dp[1] = dfs(1);
    cout << dfs2(1) << endl;
}