#include <iostream>
#include <vector>

int gcd(int a, int b){
	while(b != 0){
		int temp = a;
		a = b;
		b = temp % b;
	}
	return a;
}

bool is_coprime(int a, int b){
	return (gcd(a, b) == 1);
}
int main(){
	std::ios_base::sync_with_stdio(false);
	std::cin.tie(0);
	std::cout.tie(0);

	int t;
	std::cin >> t;
	for(int i = 0; i < t; i++){
		int n;
		std::vector<int> list;
		std::cin >> n;
		for(int j = 1; j < n; j++){
			if(is_coprime(j, n))
				list.push_back(j);
		}
		int median = (list.size() / 2) + (list.size() % 2);
		std::cout << list[median - 1] << '\n';
	}

}