#include <bits/stdc++.h>
#define ll long long
#define pb push_back
#define FLOAT_PRECISION 6
#define MOD 1000000007
#define N 30000
#define X first
#define Y second
using namespace std;
using namespace std::chrono;

int n, k;

struct node{
	int cnt;
	int next[26];
	node() {
        for(int i =0 ; i < 26; i++){
        	next[i] = -1;
		}
		cnt = 0;
    }
};
vector<node> trie(1);
void add_string(string const& s) {
    int v = 0;
    for (char ch : s) {
        int c = ch - 'a';
        if (trie[v].next[c] == -1) {
            trie[v].next[c] = trie.size();
            trie.emplace_back();
        }
        v = trie[v].next[c];
    }
    trie[v].cnt++;
}

pair<int, int> dfs(int c){
	int ans = 0, cnt = trie[c].cnt;
	vector<pair<int, int>>	res;
	for(int i = 0; i<26; i++){
		int v = trie[c].next[i];
		if(v == -1) continue;
		pair<int, int> p= dfs(v);
		cnt += p.X;
		ans += p.Y;
		res.pb(p);
	}
	sort(res.rbegin(), res.rend());
	for(auto r: res){
		if(cnt <= k) break;
		//k.Y- op cnt, k.X - remaniing cnt;
		cnt -= r.X;
		ans++;
	}
//	cout << c << " " << cnt << " " << ans << endl;
	return {cnt, ans};
}

void solve(){
	cin >> n >> k;
	for(int i = 0; i < n; i++){
		string s;
		cin >> s;
		add_string(s);
	}
	pair<int, int> ans = dfs(0);
	cout << ans.Y + 1 << endl;
	return;
}


int main(){
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout << fixed << setprecision(FLOAT_PRECISION);

	
	auto start = high_resolution_clock::now();
	int t = 1;
	//cin >> t;
	while(t--){
		solve();
	}
	auto stop = high_resolution_clock::now();
	auto duration = duration_cast<milliseconds>(stop - start);
	//cerr << duration.count()<< " milliseconds" << endl;
	return 0;
}
