#include <bits/stdc++.h>
#pragma GCC optimize("Ofast")
typedef long long ll;
typedef long double ld;
using namespace std;
mt19937 rnd(time(NULL));
#define fs first
#define sc second
const int maxn = 1e6 + 100;
const double eps = 1e-9;
const int mod = 1e9 + 7;
const int inf =1e9;


struct node {
    node *p[26] = {nullptr, };
    int count_nodes = 0, min_rms = inf, max_add = 0, fuck = 0;
} trie[int(1e6)+100];

int tsize = 1;
int n, k;


void dfs(node *v) {
    if (v->count_nodes <= k) {
        v->min_rms = 1;
        v->max_add = 1;
        return;
    }
    int rms = 1;
    int count_nodes = 1;
    vector<int> max_add;
    for (int i = 0; i < 26; ++i) {
        if (v->p[i] == nullptr) continue;
        dfs(v->p[i]);
        rms += v->p[i]->min_rms;
        max_add.push_back(v->p[i]->max_add);
    }
    sort(max_add.begin(), max_add.end());
    for (int i : max_add) {
        if (i + count_nodes <= k) {
            count_nodes += i;
            rms--;
        } else {
            break;
        }
    }
    v->min_rms = rms;
    v->max_add = count_nodes;
//    cout << v->min_rms << endl;
}

void add(string &s) {
    node *cur = trie;
    for (char c : s){
        cur->count_nodes++;
        if (cur->p[c-'a'] == nullptr) {
            cur->p[c-'a'] = &trie[tsize++];
        }
        cur = cur->p[c-'a'];
    }
    cur->count_nodes++;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("../input.txt", "r", stdin);
//    freopen("../output.txt", "w", stdout);
#endif

    cin>>n>>k;
    for (int i = 0; i < n; ++i) {
        string word;
        cin>>word;
        add(word);
    }
    dfs(trie);
    cout<<trie->min_rms;
    return 0;
}