#include <bits/stdc++.h>

#define ll long long

using namespace std;

int get(int v, int l, int r, int pos, vector <int> & tree)
{
    if (l == r)
    {
        return tree[v];
    }

    int mid = (l + r) / 2;

    if (pos <= mid)
        return min(tree[v], get(v * 2, l, mid, pos, tree));

    return min(tree[v], get(v * 2 + 1, mid + 1, r, pos, tree));
}

void update(int v, int tl, int tr, int l, int r, int val, vector <int> & tree)
{
    if (l == tl && r == tr)
    {
        tree[v] = min(tree[v], val);
        return;
    }

    int mid = (tl + tr) / 2;

    if (l <= mid)
        update(v * 2, tl, mid, l, min(r, mid), val, tree);

    if (r > mid)
        update(v * 2 + 1, mid + 1, tr, max(l, mid + 1), r, val, tree);
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int test;
    cin >> test;

    while (test--)
    {
        int n, m;
        cin >> n >> m;

        vector <int> a(n);
        set <int> rems;

        for (int i = 0; i < n; i++)
        {
            cin >> a[i];
            rems.insert(a[i] % m);

            if (a[i] % m > 0)
                rems.insert(a[i] % m - 1);
        }

        rems.insert(0);
        rems.insert(m - 1);

        map <int, int> coords;

        int it = 0;

        for (auto x: rems)
        {
            coords[x] = it;
            it++;
        }

        vector <int> tree(rems.size() * 4, n);
        int mx = (1000000000 + m - 1) / m * m;

        int ans = 0, time_zone = 0;

        for (int iter = 0; iter < 2; iter++)
        {
            if (iter == 1)
            {
                for (int i = 0; i < rems.size() * 4; i++)
                tree[i] = n;

                for (int i = 0; i < n; i++)
                    a[i] = mx - a[i];

                reverse(a.begin(), a.end());
                //cout << iter << endl;

            }
        for (int i = n - 1; i >= 0; i--)
        {
            int ind = max(get(1, 0, rems.size() - 1, coords[a[i] % m], tree), get(1, 0, rems.size() - 1, coords[a[i] % m == 0 ? m - 1 : a[i] % m - 1], tree)) - 1;
        if (iter == 1)
        {
           // cout << a[0] << " ?? " << a[1] << endl;
          //  cout << i << " !! " << get(1, 0, rems.size() - 1, coords[a[0] % m], tree) << endl;;
        }
            int cur_zone = m - 1 - a[i] % m;
            int res = (a[ind] + cur_zone) / m - (a[i] + cur_zone) / m + 1;
            //cout << res << " !! " << endl;

            if (res > ans)
            {
                ans = res;
                time_zone = cur_zone;
            }

            if (i > 0)
            {
                if (a[i] - a[i - 1] >= m * 2)
                {
                    update(1, 0, rems.size() - 1, 0, rems.size() - 1, i, tree);
                }
                else if (a[i] - a[i - 1] <= m)
                {
                    //do nothing
                }
                else
                {
                    vector <pair <int, int> > segms;
                    int r1 = a[i] % m, r2 = a[i - 1] % m;
                    int val1 = a[i], val2 = a[i - 1];

                    if (r1 > r2)
                    {
                        swap(val1, val2);
                        swap(r1, r2);
                    }

                    if (r1 == 0)
                    {
                        int x1 = (val1 - 1 + m) / m, x2 = (val2 - 1 + m) / m;

                        if (abs(x1 - x2) > 1)
                            segms.push_back({0, r2 - 1});

                        x1 = (val1 + r2 - 1 + m) / m;
                        x2 = (val2 + r2 - 1 + m) / m;

                        if (abs(x1 - x2) > 1)
                            segms.push_back({r2, m - 1});
                    }
                    else
                    {
                        int x1 = (val1 - 1 + m) / m, x2 = (val2 - 1 + m) / m;

                        if (abs(x1 - x2) > 1)
                            segms.push_back({0, r1 - 1});

                        x1 = (val1 + r1 - 1 + m) / m;
                        x2 = (val2 + r1 - 1 + m) / m;

                        if (abs(x1 - x2) > 1)
                            segms.push_back({r1, r2 - 1});

                        x1 = (val1 + r2 - 1 + m) / m;
                        x2 = (val2 + r2 - 1 + m) / m;

                        if (abs(x1 - x2) > 1)
                            segms.push_back({r2, m - 1});
                    }

                    for (auto x: segms)
                        update(1, 0, rems.size() - 1, coords[x.first], coords[x.second], i, tree);
                }
            }
        }
        }

        cout << ans << " " << time_zone << "\n";
    }
}

