﻿#include <iostream>
#include <vector>

using namespace std;

vector <vector<int>> map;

int n, m;

bool check(int x,int y, int k) {
    bool tr = true;
    for (int i = x - 1; i <= x + 1; i++) {
        for (int j = y - 1; j <= y + 1; j++) {
            if (i != x || j != y) tr = tr & (map[i][j] > k);
        }
    }
    return tr;
}

bool checkf(int i, int j, int k) {
    return (map[i + 1][j] > k && map[i - 1][j + 1] > k
        && map[i - 1][j] > k && map[i - 1][j - 1] > k && map[i][j - 1] > k && map[i + 1][j - 1] > k);
}

bool checkk(int x, int y, int k) {
    bool tr = false;
    for (int i = x - 1; i <= x + 1; i++) {
        for (int j = y - 1; j <= y + 1; j++) {
            if (i != x || j != y) tr = tr | (map[i][j] > k);
        }
    }
    return tr;
}

bool checkkk(int i, int j, int k) {
    return (map[i + 1][j] > k || map[i - 1][j + 1] > k
        || map[i - 1][j] > k || map[i - 1][j - 1] > k || map[i][j - 1] > k || map[i + 1][j - 1] > k);
}

void ff(int x, int y) { 
    
    for (int i = x - 1; i <= x + 1; i++) {
        for (int j = y - 1; j <= y + 1; j++) {
            if (i != x || j != y)map[i][j] = 2;
        }
    }
    map[x + 2][y - 1] = 2;
    map[x + 3][y - 1] = 2;
}

void qq(int x, int y) {
    for (int i = x - 1; i <= x + 1; i++) {
        for (int j = y - 1; j <= y + 1; j++) {
            if (i != x || j != y)map[i][j] = 2;
        }
    }
    map[x + 2][y + 1] = 2;
    map[x + 3][y + 1] = 2;
}

int main()
{

    cin >> n >> m;

    map.resize(n, vector <int>(m));

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            char c;
            cin >> c;
            if (c == '#') {
                map[i][j] = 1;
            }
            else {
                map[i][j] = 0;
            }
        }
    }

    int f = 0;
    int q = 0;
    for (int j = m - 2; j >= 1; j--) {
        for (int i = 1; i < n - 3; i++) {        
            if (map[i][j] == 0) {
                if (check(i, j, 0)) {
                    if (!checkk(i, j, 1)) {
                        q++;
                        qq(i, j);
                    }
                    else if (!checkkk(i, j, 1)) {
                        f++;
                        ff(i, j);
                    }
                }
                else if (map[i][j] == 0 && checkf(i, j, 0) && !checkkk(i, j, 1)) {
                    f++;
                    ff(i, j);
                }
            }
        }
    }

    cout << q << " " << f;
}
