#include <iostream>
#include <map>
#include <cmath>
#include <vector>
#include <algorithm>

using namespace std;

long long gcd(long long a, long long b) {
    if (b == 0) return a;
    return gcd(b, a % b);
}



int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int t;
    cin >> t;
    for (int i = 0; i < t; i++) {
        long long n;
        cin >> n;

        for (long long p = n / 2; p >= 1; p--) {
            if (gcd(n, p) == 1) {
                cout << p << endl;
                break;
            }
        }
    }


    return 0;
}