#define F first
#define S second

#include <bits/stdc++.h>

typedef long long ll;
typedef unsigned long long ull;
typedef unsigned int ui;
typedef long double ld;

using namespace std;


mt19937_64 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());



int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    auto starttime = chrono::steady_clock::now();
#else
    //     freopen("input.in", "r", stdin);
//     freopen("output.out", "w", stdout);
#endif
    ll n, m, c;
    ll bx, by;
    ll best = 1e18;
    cin >> n >> m >> c;
    for (ll x = 0; x <= n / m + 1; ++x) {
        int y = max(0ll, (n - x * m) / c);
        if (best > abs(x * m + y * c - n)) {
            best = abs(x * m + y * c - n);
            bx = x;
            by = y;
        }
    }
    cout << bx << ' ' << by << '\n';
#ifdef LOCAL
    auto endtime = chrono::steady_clock::now();
    printf("\n[Finished in %.3lfs]\n", 1e-6*(ll)chrono::duration_cast
            <chrono::microseconds>(endtime-starttime).count());
#endif
    return 0;
}
