#include <bits/stdc++.h>

using namespace std;

int n, m;
vector<stack<string>> st;
set<string> r;
set<string> used;

inline string get_name(string s) {
    return s.substr(0, s.find('='));
}

int main() {

    cin >> n;
    st.resize(n);

    for (int i = 0; i < n; ++i) {
        cin >> m;
        while (m--) {
            string s;
            cin >> s;
            st[i].push(s);
        }
    }

    cin >> m;
    for (int i = 0; i < m; ++i) {
        string s;
        cin >> s;
        int v;
        cin >> v;
        s = s + '=' + to_string(v);
        r.insert(s);
    }

    vector<int> ress;

    int good = true;

    do {
        good = false;

        for (int i = 0; i < n; ++i) {
            if (!st[i].empty()) {
                if (r.find(st[i].top()) != r.end()) {
                    r.erase(st[i].top());
                    used.insert(get_name(st[i].top())); 
                    ress.push_back(i + 1);
                    st[i].pop();
                    good = true;
                } else if (used.find(get_name(st[i].top())) != used.end()) {
                    ress.push_back(i + 1);
                    good = true;
                    st[i].pop();
                }
            }
        }
    } while (good);

    bool all_empty = true;

    for (int i = 0; i < n; ++i) {
        if (!st[i].empty()) {
            all_empty = false;
        }
    }

    if (r.empty() && all_empty) {
        cout << "Yes\n";
        reverse(ress.begin(), ress.end());
        for (int x : ress) {
            cout << x << ' ';
        }
    } else {
        cout << "No\n";
    }

/*
start=1
counter=1111
counter=10
counter=3333

start=2
counter=20
counter=10

start=3
qwerty=787788

counter=10
start=1
finish=1
qwerty=787788
*/

    return 0;
}