def flatten(t):
    return [item for sublist in t for item in sublist]


if __name__ == '__main__':
    s = input().split()
    n = int(s[0].strip())
    m = int(s[1].strip())
    matrix = []
    for _ in range(n):
        row = input()
        l = [1 if c == '#' else 0 for c in row]
        matrix.append(l)
    f = [1, 1, 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 1, 0, 0]
    q = [1, 1, 1, 1, 0, 1, 1, 1, 1, 0, 0, 1, 0, 0, 1]
    f_and = [1, 1, 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 1, 0, 0]
    q_and = [1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 1]
    num_f = 0
    num_q = 0
    for i in range(n - 4):
        for j in range(m - 2):
            if matrix[i][j] != 1 or matrix[i][j + 1] != 1 or matrix[i][j + 2] != 1:
                continue
            tile = flatten([row[j:j + 3] for row in matrix[i:i + 5]])
            is_f =  sum((a != b) and c for a, b, c in zip(tile, f, f_and)) == 0
            is_q = sum((a != b) and c for a, b, c in zip(tile, q, q_and)) == 0
            if is_f and is_q:
                try:
                    tile_2 = flatten([row[j+2:j + 5] for row in matrix[i+1:i + 6]])
                except Exception:
                    # definitely q
                    num_q += 1
                else:
                    if sum((a != b) and c for a, b, c in zip(tile_2, f, f_and)) == 0:
                        num_f += 1
                    else:
                        num_q += 1
            elif is_f:
                num_f += 1
            elif is_q:
                num_q += 1
    print(f'{num_q} {num_f}')
