f = [1, 1, 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 1, 0, 0]
q = [1, 1, 1, 1, 0, 1, 1, 1, 1, 0, 0, 1, 0, 0, 1]
f_and = [1, 1, 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 1, 0, 0]
q_and = [1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 1]


def flatten(t):
    return [item for sublist in t for item in sublist]


def is_f(tile, matrix, i, j):
    is_f_ = sum((a != b) and c for a, b, c in zip(tile, f, f_and)) == 0
    is_q_ = sum((a != b) and c for a, b, c in zip(tile, q, q_and)) == 0
    if is_f_ and is_q_:
        if i + 5 >= len(matrix) or j + 5 >= len(matrix[0]):
            return False
        tile_2 = flatten([row[j + 2:j + 5] for row in matrix[i + 1:i + 6]])
        if is_f(tile_2, matrix, i+1, j+2):
            return True
        else:
            return False
    elif is_f_:
        return True
    return False


def is_q(tile):
    return sum((a != b) and c for a, b, c in zip(tile, q, q_and)) == 0


if __name__ == '__main__':
    s = input().split()
    n = int(s[0].strip())
    m = int(s[1].strip())
    matrix = []
    for _ in range(n):
        row = input()
        l = [1 if c == '#' else 0 for c in row]
        matrix.append(l)
    num_f = 0
    num_q = 0
    for i in range(n - 4):
        for j in range(m - 2):
            if matrix[i][j] != 1 or matrix[i][j + 1] != 1 or matrix[i][j + 2] != 1:
                continue
            tile = flatten([row[j:j + 3] for row in matrix[i:i + 5]])
            if is_f(tile, matrix, i, j):
                num_f += 1
            elif is_q(tile):
                num_q += 1
    print(f'{num_q} {num_f}')
