#pragma comment(linker, "/STACK:534217728")
//#pragma GCC optimize("fast-maths")
//#pragma GCC optimize("unroll-loops")
//#pragma GCC optimize("no-stack-protector")
//#pragma GCC optimize("Ofast")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,avx2,fma,tune=native")
#define _USE_MATH_DEFINES
#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <stdio.h>
#include <string>
#include <cstring>
#include <vector>
#include <queue>
#include <bitset>
#include <stack>
#include <deque>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <algorithm>
#include <math.h>
#include <cmath>
#include <climits>
#include <ctime>
#include <random>
using namespace std;

#define forx(name, from, to, value) for (int name = from; name < to; name += value)
#define rforx(name, from, to, value) for (int name = from; name > to; name -= value)
#define all(_STL_NAME) _STL_NAME.begin(), _STL_NAME.end()
#define rall(_STL_NAME) _STL_NAME.rbegin(), _STL_NAME.rend()
#define mp(_FIRST,_SECOND) make_pair(_FIRST,_SECOND)

typedef long long ll;
typedef unsigned long long llu;
typedef long double ld;
const ld eps = 1e-6;
mt19937 rndm;

void start() {
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	cout.precision(5); cout.setf(ios::fixed);
	string FILENAME = "n3v3r_g0|\|na_g1v3_u_up";
	rndm.seed(time(0));
#ifdef _DEBUG
	freopen("input.txt", "rt", stdin);
	freopen("output.txt", "wt", stdout);
#else
	//freopen((FILENAME + ".in").c_str(), "rt", stdin);
	//freopen((FILENAME + ".out").c_str(), "wt", stdout);
#endif
}

inline int FastIn() {
	int val = 0;
	char c = ' ';
	bool mns = false;
	while (!isdigit(c)) {
		mns = c == '-';
		c = _getchar_nolock(); // getchar_unlocked() in Clang
	}
	while (isdigit(c)) {
		val *= 10;
		val += c - '0';
		c = _getchar_nolock();
	}
	return (mns ? -val : val);
}

inline void FastOut(int val) {
	if (val < 0) {
		_putchar_nolock('-');
		val = -val;
	}
	bool fst = true;
	const int degree = 1000000000;
	//const ll degree = 10000000000000000ll;
	for (int i = degree; i > 0; i /= 10) {
		int dl = val / i;
		if (dl || !fst) {
			_putchar_nolock('0' + dl); // putchar_unlocked() in Clang
			fst = false;
		}
		val %= i;
	}
	if (fst)
		_putchar_nolock('0');
}

int main() {
	start();
	int t;
	cin >> t;
	vector<stack<pair<string, int>>> q;
	vector<int> ans;
	for (int i = 0; i < t; ++i) {
		int v;
		cin >> v;
		stack<pair<string, int>> st;
		for (int j = 0; j < v; ++j) {
			string s;
			cin >> s;
			int val;
			int p = s.find('=');
			val = atoi(s.substr(p + 1).c_str());
			s = s.substr(0, p);
			st.push(mp(s, val));
		}
		q.emplace_back(st);
	}
	unordered_set<string> used;
	int k;
	cin >> k;
	unordered_map<string, int> qq;
	for (int i = 0; i < k; ++i) {
		string p; int v;
		cin >> p >> v;
		qq[p] = v;
	}
	for (int i = 0; i < k; ++i) {
		bool fnd = false;
		for (int j = 0; j < t; ++j) {
			while (!q[j].empty() && used.count(q[j].top().first)) {
				ans.emplace_back(j);
				q[j].pop();
			}
			if (!q[j].empty() && qq[q[j].top().first] == q[j].top().second) {
				ans.emplace_back(j);
				used.insert(q[j].top().first);
				q[j].pop();
				fnd = true;
				break;
			}
		}
		if (!fnd)
			return !(cout << "No");
	}
	for (int j = 0; j < t; ++j) {
		while (!q[j].empty()) {
			ans.emplace_back(j);
			q[j].pop();
		}
	}
	cout << "Yes\n";
	reverse(all(ans));
	for (auto i : ans)
		cout << i + 1 << ' ';
#ifdef _DEBUG
	cout << "\nTime: " << 1.0 * clock() / CLOCKS_PER_SEC << endl;
#endif
	return 0;
}