#include <bits/stdc++.h>

#define int long long
#define boost ios::sync_with_stdio(false), cin.tie(0), cout.tie(0)
#define real long double
#define uint unsigned long long
#define all(s) begin(s), end(s)
#define btw(s, n) begin(s) + 1, begin(s) + n + 1
#define between(s, l, r) begin(s) + l, begin(s) + r + 1
#define mp make_pair
#define sz size()
#define pb push_back
#define pf push_front
#define ppb pop_back()
#define ppf pop_front()
#define forn(s, n, i) for(int i = s; i <= n; ++i)
#define forr(s, n, i) for(int i = n; i >= s; --i)
#define form(s, n, i) for(int i = s; i < n; ++i)
#define forc(s, i) for(auto i = begin(s); i != end(s); ++i)
#define endl '\n'
using namespace std;

template <typename head>
void debug(head a)
{
    cout << a << endl;
}

template <typename head, typename ...tail>
void debug(head a, tail... b)
{
    cout << a << ' ';
    debug(b...);
}

template <typename head>
head Max(head a, head b)
{
    return max(a, b);
}

template <typename head, typename ...tail>
head Max(head a, tail... b)
{
    return Max(a, Max(b...));
}

template <typename head>
head Min(head a, head b)
{
    return min(a, b);
}

template <typename head, typename ...tail>
head Min(head a, tail... b)
{
    return Min(a, Min(b...));
}

template <typename container>
typename container::value_type Min(container box)
{
    auto minimum = *box.begin();
    forc(box, i)
    {
        minimum = min(minimum, *i);
    }
    return minimum;
}

template <typename container>
typename container::value_type Max(container box)
{
    auto minimum = *box.begin();
    forc(box, i)
    {
        minimum = max(minimum, *i);
    }
    return minimum;
}

#ifdef int
const int INF = 1e18 + 500;
#   else
const int INF = 1e9 + 500;
#endif

const int dx[] = {1, 0, -1, 0, 1, -1, 1, -1}, dy[] = {0, 1, 0, -1, 1, -1, -1, 1};
const int SIZE = 1e5 + 500;
int n, m, d[SIZE], p[SIZE], dist[SIZE];
bool was[SIZE];
vector<pair<int, int>> g[SIZE];

void dij()
{
    priority_queue<pair<pair<int, int>, pair<int, pair<int, int>>>> q;
    forn(1, n, i)
    {
        d[i] = -INF;
        dist[i] = INF;
    }
    d[1] = 0;
    dist[1] = 1;
    p[1] = -1;
    q.push(mp(mp(0, 0), mp(1, mp(INF, 0))));
    while(!q.empty())
    {
        auto a = q.top();
        q.pop();
        int dif = -a.first.first, distance = a.first.second, x = a.second.first, mn = a.second.second.first, mx = a.second.second.second;
        if(dif < d[x] or distance > dist[x])
        {
            continue;
        }
        form(0, g[x].sz, i)
        {
            int to = g[x][i].first, len = g[x][i].second;
            int mnp = mn, mxp = mx;
            if(to == p[x])
            {
                continue;
            }
            if(len > mxp)
            {
                mxp = len;
            }
            if(len < mnp)
            {
                mnp = len;
            }
            int difference = mxp - mnp;
            if(d[to] < difference or (d[to] == distance and dist[to] > distance + 1))
            {
                d[to] = difference;
                dist[to] = distance + 1;
                p[to] = x;
                q.push(mp(mp(-d[to], dist[to]), mp(to, mp(mnp, mxp))));
            }
        }
    }
}

void bfs()
{
    forn(1, n, i)
    {
        d[i] = -INF;
        dist[i] = INF;
    }
    queue<pair<int, pair<int, int>>> q;
    d[1] = 0;
    dist[1] = 0;
    p[1] = -1;
    was[1] = true;
    q.push(mp(1, mp(INF, -INF)));
    while(!q.empty())
    {
        auto a = q.front();
        q.pop();
        int x = a.first, mn = a.second.first, mx = a.second.second;
        form(0, g[x].sz, i)
        {
            int to = g[x][i].first, len = g[x][i].second;
            int mnp = mn, mxp = mx;
            if(len < mnp and p[to] != x and (dist[to] > dist[x] + 1 or (dist[to] == dist[x] + 1 and d[to] < mxp - len)))
            {
                mnp = len;
                was[to] = true;
                d[to] = mxp - mnp;
                dist[to] = dist[x] + 1;
                p[to] = x;
                q.push(mp(to, mp(mnp, mxp)));
            }
            if(len > mxp and p[to] != x and (dist[to] > dist[x] + 1 or (dist[to] == dist[x] + 1 and d[to] < len - mnp)))
            {
                mxp = len;
                was[to] = true;
                d[to] = mxp - mnp;
                dist[to] = dist[x] + 1;
                p[to] = x;
                q.push(mp(to, mp(mnp, mxp)));
            }
        }
    }
}

void solution()
{
    cin >> n >> m;
    forn(1, m, i)
    {
        int u, v, w;
        cin >> u >> v >> w;
        g[u].pb(mp(v, w));
        g[v].pb(mp(u, w));
    }
    bfs();
    int cur = n;
    vector<int> ans;
    while(p[cur] != 1)
    {
        ans.pb(cur);
        cur = p[cur];
    }
    ans.pb(cur);
    ans.pb(1);
    reverse(all(ans));
    cout << ans.sz - 1 << endl;
    form(0, ans.sz, i)
    {
        cout << ans[i] << ' ';
    }
}

#undef int
int main()
{
    boost;
#define int long long
    int request = 1;
    //cin >> request;
    while (request--)
    {
        solution();
    }
    return 0;
}