#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef long double ld;
#define maxN (ll)5e5
#define inf (ll)2e18
#define pb push_back
#define vec vector
#define forn(i,a,b) for (ll i=a; i<b; i++)
#define rforn(i,a,b) for (ll i=a-1; i>=b; i--)
#define sz(a) a.size()
#define all(a) a.begin(), a.end()
#define F first
#define S second
#define pr pair

ld n, l, v;

ld eps = 1e-12;

ld f(ld w, vec<ld>& a) {
    ld tot = 0;
    forn(j,0,n) {
        ld t = w + 2 * (l - a[j] * w) / (a[j] + v);
        if (l < a[j] * w) {
            t = l / a[j];
        }
        tot += t;
    }
    ld x = tot / n;
    return x;
}

bool decreasing(ld w, vec<ld>& a) {
    ld x = f(w, a);
    ld xr = f(w + eps, a);
    return xr < x;
}

void solve(){
    cin >> n >> l >> v;
    vec<ld> a(n);
    forn(i,0,n)
        cin >> a[i];
    // if i just wait
    ld tot = 0;
    forn(i,0,n) {
        ld t = l / a[i];
        tot += t;
    }
    ld x = tot / n;
    
    // if I go with V
    tot = 0;
    forn(i,0,n) {
        ld meetTime = l / (a[i] + v);
        ld t = meetTime * 2;
        tot += t;
    }
    ld y = tot / n;

    ld ans = min(x, y);

    ld left = 0;
    ld right = l / a[0];

    while (right - left > eps) {
        ld mid = (left + right) / 2;
        if (decreasing(mid, a)) {
            left = mid;
        } else {
            right = mid;
        }
    }

    ans = min(ans, f(left, a));

    cout << setprecision(30) << ans;
}

int main() {
    ios::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    ll t = 1;
    // cin>>t;
    forn(i,0,t){
        solve();
        // cout<<"\n";
    }
    return 0;
}