#include <iostream>
#include <iomanip>
#include <cstdio>
#include <vector>
#include <string>
#include <queue>
#include <map>
#include <set>
#include <algorithm>
#include <unordered_set>

using namespace std;

const int N = int(2e5) + 7;

struct node{
    char val;
    int passes;
    vector < node* > sons;

    node(char in){
        val = in;
        sons = {};
        passes = 0;
    }

    node(){
        val = '.';
        sons = {};
        passes = 0;
    }
};

int ans = 0;

void add_str(node* root, string &str, int i){
    if(!root || i > str.size()){
        return;
    }
    int ok = 0;
    root->passes++;
    if(i == str.size()){
        return;
    }
    for(auto son : root->sons){
        if(son->val == str[i]){
            ok = 1;
            add_str(son, str, i + 1);
        }
    }
    if(!ok){
        node* new_son = new node(str[i]);
        root->sons.push_back(new_son);
        add_str(new_son, str, i + 1);
    }
}

int rec(node* root, int k){
    int sum = 0;
    if(!root){
        return 0;
    }
    if(root->passes <= k){
        ans++;
        int x = (root->passes);
//        cout << "AAA" << (root->val) << x << '\n';
        root = nullptr;
        return x;
    }
    else{
        sum = 0;
        while(true){
            if((root -> passes) <= k){
                break;
            }
            int mx = INT_MIN;
            node* res = nullptr;
            for(auto j : (root -> sons)){
                if(mx < (j -> passes)){
                    mx = (j -> passes);
                    res = j;
                }
            }
            int rr = rec(res, k);
            sum += rr;
//            cout << "BBB" << (root -> val) << '\n';
            (root -> passes) -= rr;
        }
    }
    return sum;
}

int main() {
    int n, k;
    cin >> n >> k;
    node* root = new node();
    for(int i = 1; i <= n; i++){
        string s;
        cin >> s;
        add_str(root, s, 0);
    }
    rec(root, k);
    ans += ((root -> passes) ? 1 : 0);
    cout << ans;
}