#include <bits/stdc++.h>

using namespace std;

const int N = 3e5 + 5;
const int M = 1e5 + 5;
const long long INF = 1e9 + 5;
const int base = 317;

typedef long long ll;

const ll mod = 1e9 + 7;

double pi = acos(-1);
const int tx[] = {0, 1, 0, -1}, ty[] = {1, 0, -1, 0};

int n, k, ans;
string s;

struct node {
    int to[26];
    int cnt;
    node() {
        memset(to, 0, sizeof(to));
        cnt = 0;
    }
};

vector<node> trie;

void add(string s) {
    if (trie.size() == 0)
        trie.push_back(node());
    int cur = 0;
    for (int i = 0; i < s.size(); i++) {
        int ch = s[i] - 'a';
        if (trie[cur].to[ch] == 0) {
            trie[cur].to[ch] = trie.size();
            trie.push_back(node());
        }
        trie[cur].cnt++;
        cur = trie[cur].to[ch];
    }
    trie[cur].cnt++;
}

pair<int, int> dfs(int v) {
    if (trie[v].cnt <= k) {
        return {trie[v].cnt, 0};
    }
    int res = 0;
    vector<pair<int, int>> vec;
    for (int i = 0; i < 26; i++) {
        if (trie[v].to[i]) {
            vec.push_back({trie[trie[v].to[i]].cnt, trie[v].to[i]});
        }
    }
    sort(vec.begin(), vec.end());
    reverse(vec.begin(), vec.end());
    for (auto it : vec) {
        auto go = dfs(it.second);
        res += go.second;
        if (trie[v].cnt - res <= k) {
            return {trie[v].cnt, res};
        } else {
            ans++;
            res += go.first;
        }
        if (trie[v].cnt - res <= k) {
            return {trie[v].cnt, res};
        }
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cin >> n >> k;
    for (int i = 1; i <= n; i++) {
        cin >> s;
        add(s);
    }

    if (dfs(0).second != n)
        ans++;
    cout << ans;
}
