//#pragma GCC optimize("Ofast")
//#pragma GCC target("sse,sse2,sse3,sse3,sse4,popcnt,abm,mmx")

#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <set>
#include <map>
#include <iomanip>
#include <cassert>
#include <stack>
#include <queue>
#include <deque>
//#include <ext/pb_ds/assoc_container.hpp>
//#include <ext/pb_ds/tree_policy.hpp>-

using namespace std;
//using namespace __gnu_pbds;

typedef long long ll;
typedef pair <int, int> pii;
typedef pair <ll, ll> pll;

// template<typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
//  order_of_key (k) : Number of items strictly smaller than k .
//  find_by_order(k) : K-th element in a set (counting from zero).
#define sz(a) (int)a.size()
#define all(a) a.begin(), a.end()
#define pb push_back
#define ppb pop_back
#define mkp make_pair
#define F first
#define S second
#define lb lower_bound
#define ub upper_bound
#define show(a) cerr << #a <<" -> "<< a <<" "
#define nl cerr <<"\n"
//#define int ll

const int N = 3e5 + 5;
const int oo = 1e9 + 5;

struct Trie {
    int go[30];
} node[N];
int NUM = 0, cnt[N], par[N];

int n, k, ans;
set <pii> st;

void dfs(int v) {
    st.insert({cnt[v], v});
    for (int ch = 0; ch < 26; ++ch) {
        int to = node[v].go[ch];
        if (to) { dfs(to); }
    }
}

void dfs0(int v) {
    if (st.find({cnt[v], v}) == st.end()) { return; }
    st.erase({cnt[v], v});
    for (int ch = 0; ch < 26; ++ch) {
        int to = node[v].go[ch];
        if (to) { dfs0(to); }
    }
}

void add(string s) {
    int cur_node = 0;
    ++cnt[cur_node];
    for (int i = 0; i < sz(s); ++i) {
        int ch = (s[i] - 'a');
        if (!node[cur_node].go[ch]) {
            node[cur_node].go[ch] = ++NUM;
            par[NUM] = cur_node;
        }
        cur_node = node[cur_node].go[ch];
        ++cnt[cur_node];
    }
}

void solve() {
    cin >> n >> k;
    for (int it = 1; it <= n; ++it) {
        string s;
        cin >> s;
        add(s);
    }
    dfs(0);
    par[0] = -1;
    while (sz(st)) {
        ++ans;

        auto it = st.upper_bound({k, N+N});
        --it;
        int v = it -> S, san = it -> F;
        dfs0(v);

        v = par[v];
        while (v != -1) {
            st.erase({cnt[v], v});
            cnt[v] -= san;
            if (cnt[v]) { st.insert({cnt[v], v}); }
            v = par[v];
        }
    }
    cout << ans;
}

 main () {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	int tests = 1;
	//cin >> tests;
	while (tests --) {
		solve();
	}
	return 0;
}
/*
5 2
abracadabra
avadakedabra
avad
avacado
alma
*/
