#include <bits/stdc++.h>
#define fr first
#define se second
#define pb push_back
#define mk make_pair
#define all(v) v.begin(), v.end()

using namespace std;
typedef long long ll;
typedef pair <ll, ll> pll;
typedef pair <ll, ll> pll;
const ll N = 4e5 + 9;
const ll mod = 1e9 + 7;
string en = "\n";
ll used[N], p1[N], p2[N], p3[N], p4[N];
vector <pll> g[N];
struct Node
{
	ll sz = mod, mn = mod, mx = -1;
}d1[N], d2[N];

void bfs1(ll v)
{
	set <pll> s;
	s.insert(mk(0, v));
	d1[v].sz = 0;
	used[v] = 1;
	while (!s.empty())
	{
		pll x = *s.begin();
		s.erase(x);
		//cout << x.fr << " " << x.se << en;
		for (pll u : g[x.se])
		{
			if (d1[x.se].sz + 1 == d1[u.fr].sz && min(d1[x.se].mn, u.se) < d1[u.fr].mn)
				d1[u.fr].mn = min(d1[x.se].mn, u.se), p1[u.fr] = x.se;
			if (d1[x.se].sz + 1 < d1[u.fr].sz)
				d1[u.fr].sz = d1[x.se].sz + 1, d1[u.fr].mn =min(d1[x.se].mn, u.se), p1[u.fr] = x.se;
			if (used[u.fr] != 1)
				used[u.fr] = 1, s.insert(mk(d1[u.fr].mn, u.fr));
		}
	}
}
void bfs2(ll v)
{
	set <pll> s;
	s.insert(mk(0, v));
	d1[v].sz = 0;
	used[v] = 2;
	while (!s.empty())
	{
		set <pll>::iterator it = s.end();
		it--;
		pll x = *(it);
		s.erase(x);
		for (pll u : g[x.se])
		{
			if (d1[x.se].sz + 1 == d1[u.fr].sz && max(d1[x.se].mx, u.se) > d1[u.fr].mx)
				d1[u.fr].mx = max(d1[x.se].mx, u.se), p2[u.fr] = x.se;
			if (d1[x.se].sz + 1 < d1[u.fr].sz)
				d1[u.fr].sz = d1[x.se].sz + 1, d1[u.fr].mx = max(d1[x.se].mx, u.se), p2[u.fr] = x.se;
			if (used[u.fr] != 2)
				used[u.fr] = 2, s.insert(mk(d1[u.fr].mx, u.fr));
		}
	}
}

void bfs3(ll v)
{
	set <pll> s;
	s.insert(mk(0, v));
	d2[v].sz = 0;
	used[v] = 3;
	while (!s.empty())
	{
		pll x = *s.begin();
		s.erase(x);
		for (pll u : g[x.se])
		{
			if (d2[x.se].sz + 1 == d2[u.fr].sz && min(d2[x.se].mn, u.se) < d2[u.fr].mn)
				d2[u.fr].mn = min(d2[x.se].mn, u.se), p3[u.fr] = x.se;
			if (d2[x.se].sz + 1 < d2[u.fr].sz)
				d2[u.fr].sz = d2[x.se].sz + 1, d2[u.fr].mn = min(d2[x.se].mn, u.se), p3[u.fr] = x.se;
			if (used[u.fr] != 3)
				used[u.fr] = 3, s.insert(mk(d2[u.fr].mn, u.fr));
		}
	}
}
void bfs4(ll v)
{
	set <pll> s;
	s.insert(mk(0, v));
	d2[v].sz = 0;
	used[v] = 4;
	while (!s.empty())
	{
		set <pll>::iterator it = s.end();
		it--;
		pll x = *(it);
		s.erase(x);
		for (pll u : g[x.se])
		{
			if (d2[x.se].sz + 1 == d2[u.fr].sz && max(d2[x.se].mx, u.se) > d2[u.fr].mx)
				d2[u.fr].mx = max(d2[x.se].mx, u.se), p4[u.fr] = x.se;
			if (d2[x.se].sz + 1 < d2[u.fr].sz)
				d2[u.fr].sz = d2[x.se].sz + 1, d2[u.fr].mx = max(d2[x.se].mx, u.se), p4[u.fr] = x.se;
			if (used[u.fr] != 4)
				used[u.fr] = 4, s.insert(mk(d2[u.fr].mx, u.fr));
		}
	}
}

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	ll n, m;
	cin >> n >> m;
	for (ll i = 1; i <= m; i++)
	{
		ll u, v, c;
		cin >> u >> v >> c;
		g[u].pb(mk(v, c));
		g[v].pb(mk(u, c));
	}
	if (n == 2)
	{
		cout << 1 << en << 1 << " " << n;
		return 0;
	}
	bfs1(1);
	bfs2(1);
	bfs3(n);
	bfs4(n);
	ll mx = -1, w1, w2, x;
	p1[1] = p2[1] = p3[n] = p4[n] = -1;
	for (ll i = 2; i <= n - 1; i++)
	{
		//cout << i << en;
		//cout << d1[i].sz << " " << d1[i].mn << " " << d1[i].mx << en;
		//cout << d2[i].sz << " " << d2[i].mn << " " << d2[i].mx << en;
		if (d1[i].sz + d2[i].sz == d1[n].sz && max(abs(d1[i].mx - d2[i].mn), abs(d2[i].mx - d1[i].mn)) > mx)
		{
			mx = max(mx, max(abs(d1[i].mx - d2[i].mn), abs(d2[i].mx - d1[i].mn)));
			if (abs(d1[i].mx - d2[i].mn) > abs(d2[i].mx - d1[i].mn))
				w1 = 1, w2 = 1;
			else
				w1 = 2, w2 = 2;
			x = i;
		}
	}
	//cout << x << en;
	vector <ll> ans;
	ans.push_back(x);
	ll x1 = x;
	if (mx == -1)
	{
		cout << 1 << en << 1 << " " << n;
		return 0;
	}
	while (w1 == 1 && p2[x1] != -1)
		ans.pb(p2[x1]), x1 = p2[x1];
	while (w1 == 2 && p1[x1] != -1)
		ans.pb(p1[x1]), x1 = p1[x1];
	reverse(all(ans));
	while (w2 == 1 && p3[x] != -1)
		ans.pb(p3[x]), x = p3[x];
	while (w2 == 2 && p4[x] != -1)
		ans.pb(p4[x]), x = p4[x];
	cout << ans.size() - 1 << en;
	for (ll i : ans)
		cout << i << " ";
}