#include <bits/stdc++.h>

using namespace std;

#define pb(i)               push_back(i)
#define For(i, n)           for(int i = 0; i < n; ++i)
#define qFor(i, x, n)       for(int i = x; i < n; ++i)
#define rFor(i, n)          for(int i = n - 1; i >= 0; --i)
#define see                 cout << endl;
#define all(x)              (x).begin(),(x).end()
#define rall(x)             (x).rbegin(),(x).rend()

#define ld                  long double
#define pii                 pair<int, int>
#define vt                  vector
#define ll                  long long


const int MAX = 1e9;
const int MOD = 1e9 + 7;
const int BINT = 32;
const int BLONG = 64;
const ll  INF = 1e18;
const ld  PI  = 3.14159265358979323846;
 
template<typename T>
void read(vt<T> & a) {
	For(i, a.size()) cin >> a[i];
}
template<typename T>
void print(vt<T> & a) {
	For(i, a.size()) cout << a[i] << " ";
	cout << endl;
}
template<typename T>
void print2(vt<vt<T> > & a) {
	For(i, a.size()) {
		For(j, a[i].size()) cout << a[i][j] << " ";
		cout << endl;
	}
}
template<typename T>
void read2(vt<vt<T> > & a) {
	For(i, a.size()) For(j, a[i].size()) cin >> a[i][j];
}

int n, m; 

int m1 = -1, m2 = -1;

vt<int> solve(int s, int f, vt<vt<pii> > & g) {
	vt<int> mn(n, MAX);
	vt<int> mx(n, -1);
	vt<int> dist(n, -1);
	queue<int> q;
	q.push(s);
	dist[s] = 0;
	while (!q.empty()) {
		int v = q.front();
		q.pop();
		for (pii u : g[v]) {
			if (dist[u.first] == -1) {
				dist[u.first] = dist[v] + 1;
				mn[u.first] = min(u.second, mn[v]);
				q.push(u.first);
			}
			if (dist[u.first] == dist[v] + 1) {
				mn[u.first] = min(mn[u.first], min(u.second, mn[v]));
			}
		}
	}
	vt<int> dist2(n, -1);
	q.push(f);
	dist2[f] = 0;
	int mmx = 0;
	while (!q.empty()) {
		int v = q.front();
		q.pop();
		for (pii u : g[v]) {
			if (dist2[u.first] == -1) {
				dist2[u.first] = dist2[v] + 1;
				mmx = dist2[u.first];
				mx[u.first] = max(u.second, mx[v]);
				q.push(u.first);
			}
			if (dist2[u.first] == dist2[v] + 1) { 
				mx[u.first] = max(mx[u.first], (u.second, mx[v]));
			}
		}
	}
	int ans = -2 * MAX;
	For(i, n) {
		if (dist[i] + dist2[i] == mmx) {
			ans = max(mx[i] - mn[i], ans); 
		}
	}
	if (s == 0) m1 = ans;
	else m2 = ans;
	vt<int> res;
	For(i, n) {
		if (mx[i] - mn[i] == ans && dist[i] + dist2[i] == mmx) {
			int v = i;
			while (true) {
				res.push_back(v);
				if (dist[v] == 0) {
					break;
				}
				for (pii to : g[v]) {
					if (dist[to.first] == dist[v] - 1 && mn[v] == min(to.second, mn[to.first])) {
						v = to.first;
						break;
					}
				}
			}
			reverse(all(res));
			v = i;
			bool first = true;
			while (true) {
				if (!first) {
					res.push_back(v);
				}
				first = false;
				if (dist2[v] == 0) {
					break;
				}
				for (pii to : g[v]) {
					if (dist2[to.first] == dist2[v] - 1 && mx[v] == max(to.second, mx[to.first])) {
						v = to.first;
						break;
					}
				}
			}
			break;
		}
	}
	return res;
}

void write()
{
	cin >> n >> m;
	vt<vt<pii> > g(n);
	For(i, m) {
		int u, v, c; cin >> v >> u >> c; u--, v--;
		g[u].push_back({v, c}); 
		g[v].push_back({u, c}); 
	}	
	vt<int> res1 = solve(0, n - 1, g);
	vt<int> res2 = solve(n - 1, 0, g);
	if (res1.empty()) {
		reverse(all(res2));
		cout << res2.size() - 1<< endl;
		For(i, res2.size()) {
			cout << res2[i] + 1 << " ";
		}
	} else if (res2.empty()) {
		cout << res1.size() - 1<< endl;
		For(i, res1.size()) {
			cout << res1[i] + 1 << " ";
		}
	} else if (m1 > m2) {
		cout << res1.size() - 1<< endl;
		For(i, res1.size()) {
			cout << res1[i] + 1 << " ";
		}
	} else {
		reverse(all(res2));
		cout << res2.size() - 1<< endl;
		For(i, res2.size()) {
			cout << res2[i] + 1 << " ";
		}
	}
}
 
int main()
{
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#ifdef DEBUG
	freopen("output.txt", "w", stdout);
	freopen("input.txt", "r", stdin);
#endif
	int T;
	T = 1;
	// cin >> T;
	For(t, T) write();
	return 0;
}