// In the name of GOD

// the Last Dance from AITU 3: Beigut + (Baq+Nur)Daulet

#include <bits/stdc++.h>

using namespace std;

#define F first
#define S second
#define pb push_back
#define sz(x) (int) x.size()
#define all(x) x.begin(), x.end()

const int N = 1e5 + 7;
const int M = 1e9 + 7;

int n, m;
vector<pair<int, int> > g[N];
void solve() {
    cin >> n >> m;
    for(int i = 0; i < m; ++i) {
        int u, v, w; cin >> u >> v >> w;
        g[u].pb({v, w});
        g[v].pb({u, w});
    }
    vector<int> pmx(n + 1), pmn(n + 1);
    vector<int> mx(n + 1, -M), mn(n + 1, M);
    vector<int> use(n + 1);
    vector<int> cur(n + 1, -M), p(n + 1), curmx(n + 1, -M), curmn(n + 1, M);

    queue<int> q;
    vector<int> d(n + 1, M);
    q.push(1);

    d[1] = 0;
    pmx[1] = -1;
    pmn[1] = -1;
    cur[1] = 0;
    p[1] = -1;

    while(!q.empty()) {
        int v = q.front();
        q.pop();
        for(pair<int, int> i : g[v]) {
            int to = i.F, w = i.S;
            if(d[v] + 1 < d[to]) {
                d[to] = d[v] + 1;
                cur[to] = max(curmx[v], w) - min(curmn[v], w);
                mx[to] = max(w, mx[v]);
                mn[to] = min(w, mn[v]);
                curmn[to] = mn[to];
                curmx[to] = mx[to];

                pmx[to] = v;
                pmn[to] = v;
                p[to] = v;
                q.push(to);

                if(abs(mn[v] - w) > abs(mx[v] - w) && abs(mn[v] - w) > cur[to]) {
                    use[to] = 1;
                    p[to] = v;
                    curmn[v] = mn[w];
                    curmx[v] = w;
                } else if(abs(mx[v] - w) > abs(mn[v] - w) && abs(mx[v] - w) > cur[to]) {
                    use[to] = 2;
                    p[to] = v;
                    curmx[v] = mx[w];
                    curmn[v] = w;
                } else {
                    use[to] = 3;
                }
            } else if(d[v] + 1 == d[to]) {
                if(cur[to] < max(curmx[v], w) - min(curmn[v], w)) {
                    cur[to] = max(curmx[v], w) - min(curmn[v], w);
                    p[to] = v;
                    use[to] = 3;
                    curmx[to] = max(curmx[v], w);
                    curmn[to] = min(curmn[v], w);
                } else {
                    if(abs(mn[v] - w) > abs(mx[v] - w) && abs(mn[v] - w) > cur[to]) {
                        use[to] = 1;
                        p[to] = v;
                        curmn[v] = mn[w];
                        curmx[v] = w;
                    }
                    if(abs(mx[v] - w) > abs(mn[v] - w) && abs(mx[v] - w) > cur[to]) {
                        use[to] = 2;
                        p[to] = v;
                        curmx[v] = mx[w];
                        curmn[v] = w;
                    }
                }

                if(mn[to] > min(mn[v], w)) {
                    mn[to] = min(mn[w], w);
                    pmn[to] = v;
                }
                if(mx[to] < max(mx[v], w)) {
                    mx[to] = max(mx[w], w);
                    pmx[to] = v;
                }

            }
        }
    }
/*    cout << "\n";
    for(int i = 1; i <= n; ++i) {
        cout << "I:  " << i << ' ' << cur[i] << ' ' << d[i] << "\n";
        cout << p[i] << ' ' << pmn[i] << ' ' << pmx[i] << ' ' << use[i] << "\n";
        cout << curmx[i] << ' ' << curmn[i] << "\n";
        cout << mx[i] << ' ' << mn[i] << "\n\n";

    }*/

    vector<int> path;
    int last = n, lastt = use[n];
    while(last != -1) {
       // if(qq == 10) break;
        path.pb(last);
        int cc = last;
        if(lastt == 1) {
            last = pmn[last];
        } else if(lastt == 2) {
            last = pmx[last];
        } else {
            last = p[last];
        }
        lastt = use[cc];
    }
    reverse(all(path));
    cout << path.size() - 1 << "\n";
    for(int i : path) {
        cout << i << ' ';
    }
}
int main() {

    ios_base ::sync_with_stdio(0), cin.tie(0), cout.tie(0);

    int tt = 1;
    //cin >> tt;
    while(tt--){
        solve();
    }
    return 0;
}

/*
6 8
1 5 2
5 2 5
3 5 4
1 3 10
3 4 6
4 5 7
4 6 8
2 6 1

5 5
 1 2 2
 2 3 3
 1 4 4
 4 3 6
 3 5 9


 7 9
 1 2 1
 2 3 3
 1 4 2
 4 3 5
 1 5 5
 5 3 9
 1 6 11
 6 3 8
 3 7 6

 6 8
 1 2 1
 1 4 8
 2 4 9
 2 3 7
 4 3 10
 4 5 9
 5 6 8
 3 6 5

 */