#include <bits/stdc++.h>

#define all(x) (x).begin(), (x).end()
#define pb push_back
#define sz(s) (int)s.size()
#define fi first
#define se second

using namespace std;

void __print(int x) {cerr << x;}
void __print(long x) {cerr << x;}
void __print(long long x) {cerr << x;}
void __print(unsigned x) {cerr << x;}
void __print(unsigned long x) {cerr << x;}
void __print(unsigned long long x) {cerr << x;}
void __print(float x) {cerr << x;}
void __print(double x) {cerr << x;}
void __print(long double x) {cerr << x;}
void __print(char x) {cerr << '\'' << x << '\'';}
void __print(const char *x) {cerr << '\"' << x << '\"';}
void __print(const string &x) {cerr << '\"' << x << '\"';}
void __print(bool x) {cerr << (x ? "true" : "false");}
void __print(array<int, 3> x) {cerr << x[0] << ':' << x[1] << ':' << x[2];}

template<typename T, typename V>
void __print(const pair<T, V> &x) {cerr << '{'; __print(x.first); cerr << ','; __print(x.second); cerr << '}';}
template<typename T>
void __print(const T &x) {int f = 0; cerr << '{'; for (auto &i: x) cerr << (f++ ? "," : ""), __print(i); cerr << "}";}
void _print() {cerr << "]\n";}
template <typename T, typename... V>
void _print(T t, V... v) {__print(t); if (sizeof...(v)) cerr << ", "; _print(v...);}
#ifndef DEBUG
#define dbg(x...) cerr << "[" << #x << "] = ["; _print(x)
#else
#define dbg(x...)
#endif

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef vector<vector<int>> vvi;

const int mod = 1e9 + 7;
const int N = 1e6 + 7;

vector<pii> g[N / 10];
int d[N / 10];
int used[N / 10];
map<array<int, 3>, array<int, 3>> mp;
int main(){
    ios::sync_with_stdio(false);
    cin.tie(0);  
    int n, m;
    cin >> n >> m;
    d[0] = 0;
    for (int i = 1; i <= m; i++) {
        int a, b, w;
        cin >> a >> b >> w;
        a--, b--;
        g[a].pb({b, w});
        g[b].pb({a, w});
    }
    queue<array<int, 3>> q;
    for (auto p : g[0]) {
        // dbg(p.fi, p.se);
        q.push({p.fi, p.se, p.se});
        mp[{p.fi, p.se, p.se}] = {-1, -1, -1};
    }
    int ans = 0;
    used[0] = 1;
    // vector<int> v;
    array<int, 3> l;
    while (!q.empty()) {
        int v = q.front()[0];
        int mn = q.front()[1];
        int mx = q.front()[2];
        // dbg(v, mn, mx);
        q.pop();
        for (auto to : g[v]) {
            if (!used[to.fi]) {
                d[to.fi] = d[v] + 1;
                used[to.fi] = true;
                q.push({to.fi, min(mn, to.se), max(mx, to.se)}); 
                mp[{to.fi, min(mn, to.se), max(mx, to.se)}] = {v, mn, mx};
                if (to.fi == n - 1) {
                    if (to.fi == n - 1) {
                        if (ans < max(mx, to.se) - min(mn, to.se)) {
                            l = {to.fi, min(mn, to.se), max(mx, to.se)};
                            ans = max(ans, max(mx, to.se) - min(mn, to.se));
                        }
                    }
                }
            }   else {
                if (d[v] + 1 == d[to.fi]) {
                    mp[{to.fi, min(mn, to.se), max(mx, to.se)}] = {v, mn, mx};
                    if (to.fi == n - 1) {
                        if (ans < max(mx, to.se) - min(mn, to.se)) {
                            l = {to.fi, min(mn, to.se), max(mx, to.se)};
                            ans = max(ans, max(mx, to.se) - min(mn, to.se));
                        }
                    }
                    q.push({to.fi, min(mn, to.se), max(mx, to.se)});
                }
            }
        }
    }
    // for (auto p : mp) {
    //     dbg(p.fi, p.se);
    // }
    // cout << ans << '\n';
    vector<int> path;
    array<int, 3> s = {-1, -1, -1};
    while (l != s) {
        // dbg(l);
        path.pb(l[0]);
        l = mp[l];
    }
    path.pb(0);
    reverse(all(path));
    cout << sz(path) - 1 << '\n';
    for (int v : path) {
        cout << v + 1 << ' ';
    }
    return 0;
}