#include<bits/stdc++.h>

using namespace std;

#define rep(i, a, b) for(int i = a; i < b; ++i)
#define x first
#define y second
#define SZ(x) (int((x).size()))
#define ALL(x) (x).begin(), (x).end()
#define debug(x) cerr << '[' << #x << '=' << x << "]\n"

using namespace std;

long long read() {
	bool Minus = false;
	long long result = 0;
	char ch = getchar();
	while (true) {
		if (ch == '-')  break;
		if (ch >= '0' && ch <= '9')  break;
		ch = getchar();
	}
	if (ch == '-')  Minus = true;
	else  result = ch - '0';
	while (true) {
		ch = getchar();
		if (ch < '0' || ch > '9')  break;
		result = result * 10 + (ch - '0');
	}
	return Minus ? -result : result;
}

vector<vector<pair<int, int>>> g;

int solve(int test, const int mod = 1e9 + 7) {
	int n = read(), m = read();
	g.resize(n + 5);
	rep(i, 0, m) {
		int u = read(), v = read(), c = read();
		g[u].emplace_back(v, c);
		g[v].emplace_back(u, c);
	}
	queue<int> q;
	vector<bool> used(n + 5, 0);
	vector<int> dist(n + 5, 0), Min(n + 5, 1e9), Max(n + 5, -1), p(n + 5, -1);
	used[1] = true;
	q.push(1);
	while (!q.empty()) {
		int v = q.front();
		q.pop();
		for (auto& to: g[v]) {
			if (!used[to.x]) {
				used[to.x] = true;
				dist[to.x] = dist[v] + 1;
				q.push(to.x);
				p[to.x] = v;
				Min[to.x] = min({Min[to.x], Min[v], to.y});
				Max[to.x] = max({Max[to.x], Max[v], to.y});
			}
		}
	}
	q.push(1);
	while (!q.empty()) {
		int v = q.front();
		q.pop();
		for (auto& to: g[v]) {
			if (dist[v] + 1 != dist[to.x])  continue;
			q.push(to.x);
			if (max(Max[v], to.y) - min(Min[v], to.y) > Max[to.x] - Min[to.x]) {
				Min[to.x] = min(Min[v], to.y);
				Max[to.x] = max(Max[v], to.y);
				p[to.x] = v;
			}
		}
	}
	cout << dist[n] << endl;
	vector<int> restore;
	for (int v = n; v != -1; v = p[v]) {
		restore.push_back(v);
	}
	reverse(ALL(restore));
	for (auto& to: restore)  cout << to << ' ';
	return 0;
}

int main(int argc, char **argv) {
	ios_base :: sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
	#ifdef local
		freopen("input", "r", stdin);
		freopen("output", "w", stdout);
	#endif
	freopen("error", "w", stderr);
	int tests = 1; // read();
	rep(i, 0, tests) solve(i + 1);
	cerr << endl << clock() * 1.0 / CLOCKS_PER_SEC << endl;
	return 0;
}