#include <iostream>
#include <vector>
#include <algorithm>
#include <queue>

using namespace std;

typedef long long ll;
const int maxn = (int) 4e6 + 1;


struct node{
    node *child[30];
    int cnt = 0;
};

node *get(){
    node *p=new node();
    p->cnt=0;
    for(int i=0;i<27;i++){
        p->child[i]=nullptr;
    }
    return p;
}

node *head;
void add(string s){
    node *cur=head;
    for(int i=0;i<s.size();i++){
        int p = s[i]-'a';
        if(cur->child[p]==nullptr){
            cur->child[p]=get();
        }
        cur=cur->child[p];
        cur->cnt++;
    }
}

int n,m;
int mx=0,mxp=0;
vector<int> cur, col;
void search(node *root, int pr_cnt){
    if(root->cnt==0) return ;
    if(root->cnt<=m){
        if(mx < root->cnt){
            mx=root->cnt;
            col = cur;
        }
        else if(root->cnt==mx){
            int pos = 0;
            while (pos < cur.size() && pos < col.size() && col[pos] == cur[pos]){
                pos++;
            }
            if(pos == col.size()){
                col = cur;
            }
        }
        return ;
    }
    for(int i=0;i<26;i++){
        if(root->child[i]!=nullptr){
            cur.push_back(root->cnt);
            search(root->child[i],root->cnt);
            cur.pop_back();
        }
    }
}

string s[maxn];

bool ok;
void upd(node *root, int pr_cnt){
    if(ok) return ;
    if(root->cnt==0) return ;
    if(cur == col){
        root->cnt = 0;
        ok = true;
        return ;
    }
    if(root->cnt <= m){
        return;
    }
    for(int i=0;i<26;i++){
        if(root->child[i]!=nullptr){
            cur.push_back(root->cnt);
            upd(root->child[i], root->cnt);
            cur.pop_back();
        }
    }
    if(ok)
        root->cnt-=mx;
}

int main(){
    cin>>n>>m;
    head = get();
    head->cnt = n;
    for(int i=1;i<=n;i++){
        cin>>s[i];
        add(s[i]);
    }
    if(n<=m){
        cout<<1;
        return 0;
    }
    mx = 1;
    int ans = 0;
    while(n>m && mx > 0){
        mx = 0, mxp =0;
        ans++;
        search(head, 0);
        n -= mx;
        ok = false;
        upd(head, 0);
    }
    cout << ans+(n>0);
}