# include <iostream>
# include <vector>
# define sz(x) (int)((x).size())

# define all(x) x.begin(), x.end()
 
using namespace std; 
using ll = long long;

int a[305][305];
int n, m;

vector<int> dxQ = {0, -1, -2, -3, -4, -4, -4, -3, -2, -2};
vector<int> dyQ = {0, 0,   0,  0,  0, -1, -2, -2, -2, -1};


// vector<int> dxF = {0,  -1, -2, -3, -4, -4, -4, -2};
// vector<int> dyF = {-2, -2, -2, -2, -2, -1,  0, -1};

vector<int> dxF = {0,  -1, -2, -3, -4, -4, -4, -2};
vector<int> dyF = {0,   0,  0,  0,  0,  1,  2, 1};

void markQ(int i, int j) {
  for (int d = 0; d < dxQ.size(); d++) {
    a[i + dxQ[d]][j + dyQ[d]] = 0;
  }
}

void markF(int i, int j) {
  for (int d = 0; d < dxF.size(); d++) {
    a[i + dxF[d]][j + dyF[d]] = 0;
  }
}

bool isQ(int i, int j) {
  int sum = 0;
  for (int d = 0; d < dxQ.size(); d++) {
    int x = i + dxQ[d];
    int y = j + dyQ[d];
    if (x >= 1 && x <= n && y >= 1 && y <= m) {
      sum += a[x][y];
    }
  }
  return sum == 10;
}

bool isF(int i, int j) {
  int sum = 0;
  for (int d = 0; d < dxF.size(); d++) {
    int x = i + dxF[d];
    int y = j + dyF[d];
    if (x >= 1 && x <= n && y >= 1 && y <= m) {
      sum += a[x][y];
    }
  }
  return sum == 8;
}

void show() {
  for (int i = 1; i <= n; i++) {
    for (int j = 1; j <= m; j++) {
      cout << a[i][j] << ' ';
    }
    cout << endl;
  }
  cout << endl;
}

int Q = 0, F = 0;

bool solul() {
  for (int i = n; i >= 1; i--) {
    for (int j = m; j >= 1; j--) {
      bool q = isQ(i, j);
      if (q) {
        markQ(i, j);
        //show();
        Q++;
      } else if (isF(i, j)) {
        markF(i, j);
        //show();
        F++;
      }
    }
  }
  //show();
  int zeros = 0;
  for (int i = 1; i <= n; i++) {
    for (int j = 1; j <= m; j++) {
      zeros += (a[i][j] == 0);
    }
  }
  return zeros == n * m;
}

void solve() {
  cin >> n >> m;
  for (int i = 1; i <= n; i++) {
    for (int j = 1; j <= m; j++) {
      char x;
      cin >> x;
      a[i][j] = (x == '#');
    }
  }

  //show();
  while (!solul()) {
  }

  //show();

  cout << Q << ' ' << F << endl;
}
 
int main(){
  //freopen("input.in", "r", stdin);
  //freopen("output.out", "w", stdout);
  ios_base::sync_with_stdio(false);
  cin.tie(0);
  //int t = 1; cin >> t; while (t--)
  solve();
  return 0;
}
