#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <string>
#include <vector>
#include <algorithm>
#include <map>
#include <unordered_map>
#include <set>
#include <cmath>
#include <cassert>
#include <queue>
#include <bitset>
#include <numeric>
#include <cstdlib>
#include <iostream>     // std::cout
#include <algorithm>    // std::random_shuffle
#include <vector>       // std::vector
#include <ctime>        // std::time
#include <cstdlib>
#include <iomanip>
#include <sstream>

using namespace std;

const int N = (int) 1e6 + 123;
const int MOD = (int) 1e9 + 7;

int n, m, c;

int val(int M, int C) {
    return abs(M * m + C * c - n);
}

int find(int M) {
    int have = M * m;
    if (have >= n) {
        return 0;
    }
    int need = n - have;

    int opt_c = need / c;
    if (val(M, opt_c) > val(M, opt_c + 1)) {
        opt_c++;
    }
    return opt_c;
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif

    ios_base::sync_with_stdio(0);
    cin.tie(0);

    cin >> n >> m >> c;

    int mini = MOD;
    int best_m = -1, best_c = -1;

    for (int M = 0; ; M++) {
        int opt_c = find(M);

        if (mini > val(M, opt_c)) {
            mini = val(M, opt_c);
            best_m = M;
            best_c = opt_c;
        }

        if (M * m > n) {
            break;
        }
    }

    cout << best_m << ' ' << best_c << endl;
    return 0;
}
